package com.vykon.vykonPro.alarm;

import java.util.ArrayList;

import javax.baja.alarm.BAlarmClass;
import javax.baja.alarm.BAlarmClassFolder;
import javax.baja.alarm.BAlarmRecord;
import javax.baja.alarm.BIAlarmClassFolder;
import javax.baja.sys.Action;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BLink;
import javax.baja.sys.BValue;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.SlotCursor;
import javax.baja.sys.Sys;
import javax.baja.sys.Topic;
import javax.baja.sys.Type;
import javax.baja.util.BCompositeTopic;
import javax.baja.util.IFuture;
import javax.baja.util.Invocation;

import com.vykon.vykonPro.util.BVykonProService;

/**
 * 
 *  The component is desinged to be linked between an alarmClass component and an
 *  alarm recipient in order to filter out specific alarm events from being processed
 *  by the alarm recipient. Boolean properties are used to configure filtering for
 *  alarm note events and escalation events.
 *
 * @author James Johnson
 * @creation Nov 8, 2010
 *
 */

public class BAlarmEmailRecipFilter
    extends BComponent
{
  /*-
   class BAlarmEmailRecipFilter
   {
     properties
     {
       filterNotes: boolean
         -- boolean property when set to true blocks routing of alarm event if the BAlarmRecord
         -- lastUpdateTime matches a timestamp in the alarmData.notes.
         flags{ operator }
         default{[ false ]}
         
       filterEscalation: boolean
         -- boolean property when set to true blocks routing of alarm event if the BAlarmRecord
         -- alarmData.escalated value doesn't match the linked topic of the associated alarmClass
         flags{ operator }
         default{[ false ]}
     }
     actions
     {
       filterAlarm(alarm: BAlarmRecord)
         -- filter the alarm and pass to a recipient if applicable
         flags { summary, async }
         default{[ new BAlarmRecord() ]}
     }
     topics
     {
       route: BAlarmRecord
         -- Fired when the filterAlarm action processes an alarm that matches the filter
         -- criteria.
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter(968380366)1.0$ @*/
/* Generated Thu Sep 27 16:23:53 EDT 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "filterNotes"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>filterNotes</code> property.
   * boolean property when set to true blocks routing of
   * alarm event if the BAlarmRecord lastUpdateTime matches
   * a timestamp in the alarmData.notes.
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#getFilterNotes
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#setFilterNotes
   */
  public static final Property filterNotes = newProperty(Flags.OPERATOR, false,null);
  
  /**
   * Get the <code>filterNotes</code> property.
   * boolean property when set to true blocks routing of
   * alarm event if the BAlarmRecord lastUpdateTime matches
   * a timestamp in the alarmData.notes.
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#filterNotes
   */
  public boolean getFilterNotes() { return getBoolean(filterNotes); }
  
  /**
   * Set the <code>filterNotes</code> property.
   * boolean property when set to true blocks routing of
   * alarm event if the BAlarmRecord lastUpdateTime matches
   * a timestamp in the alarmData.notes.
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#filterNotes
   */
  public void setFilterNotes(boolean v) { setBoolean(filterNotes,v,null); }

////////////////////////////////////////////////////////////////
// Property "filterEscalation"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>filterEscalation</code> property.
   * boolean property when set to true blocks routing of
   * alarm event if the BAlarmRecord alarmData.escalated
   * value doesn't match the linked topic of the associated
   * alarmClass
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#getFilterEscalation
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#setFilterEscalation
   */
  public static final Property filterEscalation = newProperty(Flags.OPERATOR, false,null);
  
  /**
   * Get the <code>filterEscalation</code> property.
   * boolean property when set to true blocks routing of
   * alarm event if the BAlarmRecord alarmData.escalated
   * value doesn't match the linked topic of the associated
   * alarmClass
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#filterEscalation
   */
  public boolean getFilterEscalation() { return getBoolean(filterEscalation); }
  
  /**
   * Set the <code>filterEscalation</code> property.
   * boolean property when set to true blocks routing of
   * alarm event if the BAlarmRecord alarmData.escalated
   * value doesn't match the linked topic of the associated
   * alarmClass
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#filterEscalation
   */
  public void setFilterEscalation(boolean v) { setBoolean(filterEscalation,v,null); }

////////////////////////////////////////////////////////////////
// Action "filterAlarm"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>filterAlarm</code> action.
   * filter the alarm and pass to a recipient if applicable
   */
  public static final Action filterAlarm = newAction(Flags.SUMMARY|Flags.ASYNC,new BAlarmRecord(),null);
  
  /**
   * Invoke the <code>filterAlarm</code> action.
   * filter the alarm and pass to a recipient if applicable
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#filterAlarm
   */
  public void filterAlarm(BAlarmRecord alarm) { invoke(filterAlarm,alarm,null); }

////////////////////////////////////////////////////////////////
// Topic "route"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>route</code> topic.
   * Fired when the filterAlarm action processes an alarm
   * that matches the filter criteria.
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#fireRoute
   */
  public static final Topic route = newTopic(0,null);
  
  /**
   * Fire an event for the <code>route</code> topic.
   * Fired when the filterAlarm action processes an alarm
   * that matches the filter criteria.
   * @see com.vykon.vykonPro.alarm.BAlarmEmailRecipFilter#route
   */
  public void fireRoute(BAlarmRecord event) { fire(route, event, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAlarmEmailRecipFilter.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  
  public IFuture post(Action action, BValue argument, Context cx)
  {
    if(action == filterAlarm)
      return BVykonProService.getInstance().getWorker().post(new Invocation(this, action, argument, cx));
    else
      return super.post(action, argument, cx);
  }
  
  public void doFilterAlarm(BAlarmRecord alarm)
  {
    if(accept(alarm))
      fireRoute(alarm);
  }
  
  public boolean accept(BAlarmRecord alarm)
  {
    if(getFilterEscalation())
    {
      acceptEscalation = false;
      String escLevel = alarm.getAlarmFacet("escalated").toString();
      if(escLevel==null || escLevel.length()==0)
      {
        aclasses = getSubscribedAlarmClasses("alarm");
      }
      else
      {
        int level = Integer.parseInt(escLevel.substring(escLevel.length()-1));
        aclasses = getSubscribedEscalatedAlarmClasses(level);
      }
      
      for(int i=0; i<aclasses.length; i++)
      {
        if(alarm.getAlarmClass().equals(aclasses[i]))
          acceptEscalation = true;
      }
    }
    else
    {
      acceptEscalation = true;
    }
    
    if(getFilterNotes())
    {
      acceptNotes = false;
      
      if(alarm.getAlarmFacet("notes")!=null)
      {
        //there is at least a note to check
        String note = alarm.getAlarmFacet("notes").toString();
        BFacets f = BFacets.make("SHOW_SECONDS", BBoolean.make(false));
        String timestamp = alarm.getLastUpdate().toString(f);
        if(note.indexOf(timestamp) == -1 ) acceptNotes = true;
      }
      else
      {
        //no notes to just accept
        acceptNotes = true;
      }
    }
    else
    {
      acceptNotes = true;
    }
    
    if(acceptNotes && acceptEscalation) return true;
    else return false;
    
  }
  
  /**
   * Get the EscalatedAlarmClasses linked to this AlarmRecipient.
   * Valid levels are 1, 2 and 3.
   */
  public String[] getSubscribedEscalatedAlarmClasses(int level)
  {
    if (level < 1 || level > 3)
      return new String[0];
    
    return getSubscribedAlarmClasses("escalatedAlarm"+level);
  }

  /**
   * This method returns a list of subscribed alarm classes based on the
   * name of the source slot name of the links of this alarm recipient.
   * @return
   */
  private String[] getSubscribedAlarmClasses(String sourceSlotName)
  {
    ArrayList classes = new ArrayList();
    SlotCursor c = this.getProperties();
    while (c.next(BLink.class))
    {
      try
      {
        BLink link = (BLink)c.get();
        if (!link.isActive())
          link.activate();
        
        BComponent srcComp = link.getSourceComponent();
        
        if (srcComp instanceof BAlarmClass && link.getSourceSlotName().equals(sourceSlotName))
        {
          classes.add(srcComp.getName());
          // Remember, it's the name of the alarm class, not the alarm class 
          // itself.  AlarmRecords store their alarm 
          // class as a string, so we need to match that
        }
        else 
        {
          //check if we're dealing with nested alarm class folders
          while( srcComp instanceof BIAlarmClassFolder )
          {
            //get source component as an Alarm Class Folder
            BAlarmClassFolder folder = (BAlarmClassFolder)srcComp;
            String folderSlotName = link.getSourceSlotName();
            //get the link to this folder
            link = ((BCompositeTopic)folder.get(folderSlotName)).getMirror().link;
            //check the source component of the link
            srcComp = link.getSourceComponent();
            if( srcComp instanceof BAlarmClass && link.getSourceSlotName().equals(sourceSlotName) )
            {
              classes.add(srcComp.getName());
              break;
            }
          }
        }
      }
      catch (Exception e)
      {
        System.out.println(this.getSlotPath() + " - " + e.getMessage());
      }
    }

    String [] array = new String[classes.size()];
    return (String[])classes.toArray(array);
  }

  String[] aclasses = null;
  private boolean acceptEscalation = false;
  private boolean acceptNotes = false;
}
