package com.vykon.vykonPro.alarm;

import javax.baja.alarm.ext.BAlarmSourceExt;
import javax.baja.control.BControlPoint;
import javax.baja.naming.BOrd;
import javax.baja.nre.annotations.Facet;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.status.BStatus;
import javax.baja.sys.*;
import java.util.HashMap;

/**
 * Created by james on 1/9/2019.
 */

@NiagaraType

@NiagaraProperty(
        name = "numberOfItems",
        type = "int",
        defaultValue = "0",
        flags = Flags.OPERATOR,
        facets = {
                @Facet(name = "BFacets.MIN", value = "BInteger.make(0)")
        }
)

@NiagaraProperty(
        name = "status",
        type = "BStatus",
        defaultValue = "BStatus.DEFAULT",
        flags = Flags.READONLY
)

@NiagaraProperty(
        name = "faultCause",
        type = "String",
        defaultValue = "",
        flags = Flags.READONLY
)

public class BRelatedMetadata
    extends BComponent
{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.alarm.BRelatedMetadata(1447457961)1.0$ @*/
/* Generated Thu Jan 10 13:55:43 EST 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "numberOfItems"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code numberOfItems} property.
   * @see #getNumberOfItems
   * @see #setNumberOfItems
   */
  public static final Property numberOfItems = newProperty(Flags.OPERATOR, 0, BFacets.make(BFacets.MIN, BInteger.make(0)));
  
  /**
   * Get the {@code numberOfItems} property.
   * @see #numberOfItems
   */
  public int getNumberOfItems() { return getInt(numberOfItems); }
  
  /**
   * Set the {@code numberOfItems} property.
   * @see #numberOfItems
   */
  public void setNumberOfItems(int v) { setInt(numberOfItems, v, null); }

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code status} property.
   * @see #getStatus
   * @see #setStatus
   */
  public static final Property status = newProperty(Flags.READONLY, BStatus.DEFAULT, null);
  
  /**
   * Get the {@code status} property.
   * @see #status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the {@code status} property.
   * @see #status
   */
  public void setStatus(BStatus v) { set(status, v, null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code faultCause} property.
   * @see #getFaultCause
   * @see #setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY, "", null);
  
  /**
   * Get the {@code faultCause} property.
   * @see #faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the {@code faultCause} property.
   * @see #faultCause
   */
  public void setFaultCause(String v) { setString(faultCause, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRelatedMetadata.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


    public void started()
    {
        subscriber = new MySubscriber();
        if(Sys.atSteadyState()) subscribeItems();

        // set NON_CRITICAL slot flag on the parent BAlarmSourceExt since will be writing to metadata slot frequently
        BComponent parent = getParent().getParentComponent();
        ase = (BAlarmSourceExt)parent;

        if(ase!=null)
        {
            Slot s = parent.getSlot("metaData");
            parent.setFlags(s, parent.getFlags(s) | Flags.NON_CRITICAL);
        }
    }

    public void stopped()
    {
        if(subscriber!=null) subscriber.unsubscribeAll();
    }

    public void stationStarted()
    {
        subscribeItems();
    }

    public void changed(Property prop, Context cx)
    {
        if (!isRunning()) return;

        if (prop.equals(numberOfItems))
        {
            initSlots();
        }
        else if(prop.getName().startsWith(SLOT_NAME))
        {
            validateOrd(prop.getName());
        }

        super.changed(prop, cx);
    }

    public boolean isParentLegal(BComponent parent)
    {
        return (parent instanceof BAlarmSourceExt);
    }

    // detect removal of slot by some means other than changing the numberOfItems property
    public void removed(Property property, BValue oldValue, Context context)
    {
        // remove facet key from metadata
        if(property.getName().startsWith(SLOT_NAME))
        {
            BOrd compOrd = (BOrd)oldValue;
            if(compOrd!=BOrd.DEFAULT)
            {
                BComponent comp = (BComponent)compOrd.resolve(this).get();
                if(ase!=null) ase.setMetaData(BFacets.makeRemove(ase.getMetaData(), comp.getName()));
            }
        }

        int numSlots = getChildren(BOrd.class).length;
        if(getNumberOfItems()!=numSlots) setNumberOfItems(numSlots);
        subscribeItems();
        super.removed(property, oldValue, context);
    }

    private void initSlots()
    {
        int numOrds = getNumberOfItems();
        int numSlots = this.getChildren(BOrd.class).length;

        if(numOrds>numSlots)
        {
            // need to add slots
            for(int i=numSlots+1; i<=numOrds; i++)
            {
                this.add(SLOT_NAME+i, BOrd.DEFAULT, Flags.OPERATOR);
            }
        }
        else if(numOrds<numSlots)
        {
            // need to remove slots
            for(int i=numOrds+1; i<=numSlots; i++)
            {
                removeMetadata(SLOT_NAME+i);
                this.remove(SLOT_NAME+i);
            }
        }

        subscribeItems();
    }

    private void removeMetadata(String slot)
    {
        BOrd compOrd = (BOrd)get(slot);
        if(compOrd!=BOrd.DEFAULT)
        {
            BComponent comp = (BComponent)compOrd.resolve(this).get();
            if(comp!=null)
            {
                if(ase!=null) ase.setMetaData(BFacets.makeRemove(ase.getMetaData(), comp.getName()));
            }
        }
    }

    private void subscribeItems()
    {
        subscriber.unsubscribeAll();
        BFacets facets = BFacets.DEFAULT;

        for(int i=1; i<=getNumberOfItems(); i++)
        {
            String slotName = SLOT_NAME + i;
            BOrd objOrd = (BOrd)get(slotName);
            if(objOrd!=BOrd.DEFAULT)
            {
                try
                {
                    BObject object = objOrd.resolve(this).get();
                    if(object!=null && object instanceof BControlPoint)
                    {
                        BControlPoint point = (BControlPoint)object;
                        subscriber.subscribe(point);
                        facets = BFacets.make(facets, BFacets.make(point.getName(), point.getValueWithFacets(point.getFacets())));
                        keys.put(slotName, point.getName());
                    }
                }
                catch (Exception e)
                {
                    setStatus(BStatus.fault);
                    setFaultCause(slotName + CAUSE);
                    System.out.println(this.getSlotPath());
                    e.printStackTrace();
                }
            }
        }

        setStatus(BStatus.ok);
        setFaultCause("");
        if(facets!=BFacets.DEFAULT && ase!=null)
            ase.setMetaData(BFacets.make(ase.getMetaData(), facets));
    }

    private void updateMetadata(BComponent source)
    {
        BControlPoint point;
        if(source instanceof BControlPoint) point = (BControlPoint)source;
        else return;

        BFacets facet = BFacets.make(point.getName(), point.getValueWithFacets(point.getFacets()));
        if(ase!=null) ase.setMetaData(BFacets.make(ase.getMetaData(), facet));
    }

    private void validateOrd(final String slot)
    {
        boolean fault = false;
        BOrd checkOrd = (BOrd)get(slot);
        if(checkOrd==BOrd.DEFAULT) fault = true;

        try
        {
            BObject obj = checkOrd.resolve(this).get();
            if(obj!=null && obj instanceof BControlPoint)
            {
                BControlPoint point = (BControlPoint)obj;
                // if the point name has changed remove the old facet key
                keys.forEach((k, v) -> {
                    if(keys.get(slot)!=null && !(keys.get(slot).equals(point.getName())))
                    {
                        if(ase!=null) ase.setMetaData(BFacets.makeRemove(ase.getMetaData(), keys.get(slot)));
                        keys.put(slot, point.getName());
                    }
                });
                subscriber.subscribe(point);
                updateMetadata(point);
            }
            else
            {
                fault = true;
            }

            if(fault)
            {
                setStatus(BStatus.fault);
                setFaultCause(slot + CAUSE);
            }
            else
            {
                setStatus(BStatus.ok);
                setFaultCause("");
            }
        }
        catch (Exception e)
        {
            setStatus(BStatus.fault);
            setFaultCause((slot + CAUSE));
            System.out.println(this.getSlotPath());
            e.printStackTrace();
        }
    }

    MySubscriber subscriber;
    private static String SLOT_NAME = "relatedPoint";
    private static String CAUSE = " must be mapped to a valid Control Point ord in the station";
    private BAlarmSourceExt ase;
    private HashMap<String, String> keys = new HashMap<String, String>();

    ///////////////////////////////////////////
    // inner classes
    ///////////////////////////////////////////

    public class MySubscriber extends Subscriber
    {
        public void event (BComponentEvent event)
        {
            if(event.getId()==BComponentEvent.PROPERTY_CHANGED && event.getSlotName().equals("out"))
            {
                try
                {
                    updateMetadata(event.getSourceComponent());
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
            }
        }
    }
}