package com.vykon.vykonPro.bql;

import javax.baja.control.BControlPoint;
import javax.baja.data.BIDataValue;
import javax.baja.status.BStatusValue;
import javax.baja.schedule.BDailySchedule;
import javax.baja.schedule.BDaySchedule;
import javax.baja.schedule.BTimeSchedule;
import javax.baja.schedule.BWeekSchedule;
import javax.baja.schedule.BWeekdaySchedule;
import javax.baja.schedule.BWeeklySchedule;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BFacets;
import javax.baja.sys.BObject;
import javax.baja.sys.BString;
import javax.baja.sys.Clock;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.tag.Tag;
import javax.baja.tag.Taggable;
import javax.baja.tag.Tags;
import java.util.Collection;
import java.util.Iterator;
import javax.baja.sys.BComponent;

public class BLib
    extends BObject
{
  /*-
   class BLib
   {
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.bql.BLib(430087482)1.0$ @*/
/* Generated Thu Sep 08 09:44:58 EDT 2011 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BLib.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  //declare the cycles aggregator
  public static final Type[] cycles = {BCycles.TYPE};
  
  //declare the runtime aggregator
  public static final Type[] runtime = {BRuntime.TYPE};
  
  public static BString tsEvent(BObject obj, BTimeSchedule sched)
  {
    BWeeklySchedule top = (BWeeklySchedule)sched.getRootSchedule();
    BFacets facets = top.getFacets();
    StringBuffer sb = new StringBuffer();
    sb.append(sched.getEffectiveValue().getValueValue().toString(facets) + " from ");
    sb.append(sched.getStart() + " to " + sched.getFinish());

    return BString.make(sb.toString().trim());
  }

  public static BString dsEvent(BObject obj, BDailySchedule sched)
  {
    BWeeklySchedule top = (BWeeklySchedule)sched.getRootSchedule();
    BFacets facets = top.getFacets();
    StringBuffer sb = new StringBuffer();
    BTimeSchedule[] times = sched.getDay().getTimesInOrder();

    for(int i=0; i<times.length; i++)
    {
      if(i!=0) sb.append(" | ");
      sb.append(times[i].getEffectiveValue().getValueValue().toString(facets) + " from ");
      sb.append(times[i].getStart() + " to " + times[i].getFinish());
    }

    return BString.make(sb.toString().trim());
  }

  public static BString dEvent(BObject obj, BDaySchedule sched)
  {
    BWeeklySchedule top = (BWeeklySchedule)sched.getRootSchedule();
    BFacets facets = top.getFacets();
    StringBuffer sb = new StringBuffer();
    BTimeSchedule[] times = sched.getTimesInOrder();

    for(int i=0; i<times.length; i++)
    {
      if(i!=0) sb.append(" | ");
      sb.append(times[i].getEffectiveValue().getValueValue().toString(facets) + " from ");
      sb.append(times[i].getStart() + " to " + times[i].getFinish());
    }

    return BString.make(sb.toString().trim());
  }
  public static BString wsEvent(BObject obj, BWeekSchedule sched)
  {
    BWeeklySchedule top = (BWeeklySchedule)sched.getRootSchedule();
    BFacets facets = top.getFacets();
    StringBuffer sb = new StringBuffer();
    BDailySchedule[] days = sched.schedulesInOrder(null);

    for(int i=0; i<days.length; i++)
    {
      if(i!=0) sb.append(" | ");
      sb.append(days[i].getDisplayName(null) + " " );

      BTimeSchedule[] times = days[i].getDay().getTimesInOrder();
      for(int k=0; k<times.length; k++)
      {
        if(k!=0) sb.append(" , ");
        sb.append(times[k].getEffectiveValue().getValueValue().toString(facets) + " from ");
        sb.append(times[k].getStart() + " to " + times[k].getFinish());
      }
    }

    return BString.make(sb.toString().trim());
  }

  public static BBoolean isToday(BObject obj, BWeekdaySchedule sched)
  {
    BAbsTime current = Clock.time();
    boolean result = sched.getSet().contains(current.getWeekday().getOrdinal());
    return BBoolean.make(result);
  }


  public static BString showFacets(BObject obj, BControlPoint point)
    {
      if(point.getFacets()!=null && point.getFacets()!=BFacets.NULL)
      {
        BFacets f = point.getFacets();
        return BString.make(point.getOutStatusValue().getValueValue().toString(f));
      }
      return BString.make(point.getOutStatusValue().getValueValue().toString());
  }

  public static BString showFacets(BObject obj, BStatusValue val)
  {
    if(val.getStatusValueFacets()!=null && val.getStatusValueFacets()!=BFacets.NULL)
  	{
  	  BFacets f = val.getStatusValueFacets();
  	  return BString.make(val.getValueValue().toString(f));
    }
  	return BString.make(val.getValueValue().toString());
  }

  /**
   * return s comma separated list of all implied and direct tags from all
   * dictionary name spaces for the object. Result includes tag values.
   */
  public static BString tags(BObject obj)
  {
    if(obj instanceof Taggable)
    {
      Tags tags = ((Taggable)obj).tags();
      Collection<Tag> collection = tags.getAll();
      Iterator<Tag> it = collection.iterator();

      String t = "";
      boolean first = true;

      while (it.hasNext())
      {
        Tag tag = it.next();
        if (first) first = false;
        else t = t + ",";
        t = t + tag.getId() + "=" + tag.getValue();
      }

      return BString.make(t);
    }

    return BString.make("the object is not Taggable");
  }

  /**
   * return a comma separated list of tags assigned to the object whose
   * tag dictionary name space matches the ns argument. Result includes
   * tag values. The ns argument is the short hand name space reference
   * for the dictionary.
   */
  public static BString tagsForNs(BObject obj, BString ns)
  {
    if(obj instanceof Taggable)
    {
      Tags tags = ((Taggable)obj).tags();
      Collection<Tag> collection = tags.getAll();
      Iterator<Tag> it = collection.iterator();

      String nameSpace = ns.toString(null);
      String t = "";
      boolean first = true;

      while (it.hasNext())
      {
        Tag tag = it.next();
        String dictionary = tag.getId().getDictionary();

        if(nameSpace!=null && nameSpace.length()>0)
        {
          if(dictionary.equals(nameSpace))
          {
            if (first) first = false;
            else t = t + ",";
            t = t + tag.getId() + "=" + tag.getValue();
          }
        }
      }

      return BString.make(t);
    }

    return BString.make("the object is not Taggable");
  }

  /**
   * return boolean indicating whether the obj has the tag specified
   * by the id argument assigned. The id argument should be a string
   * in the format <nameSpace>:<tagName>.
   */
  public static BBoolean hasTag(BObject obj, BString id)
  {
    if(obj instanceof Taggable)
    {
      Tags tags = ((Taggable)obj).tags();

      // public static Id Id.newId(String qname)
      // default boolean Tags.contains(Id id)

      Collection<Tag> collection = tags.getAll();
      Iterator<Tag> it = collection.iterator();

      while (it.hasNext())
      {
        Tag tag = it.next();
        if (tag.getId().toString().equals(id.toString()))
          return BBoolean.TRUE;
      }
    }

    return BBoolean.FALSE;
  }


  /**
   *
   * return the value of the tag specified by the id argument. The id
   * argument format is <nameSpace>:<tagName>
   */
  public static BIDataValue tagValue(BObject obj, BString id)
  {
    if(obj instanceof Taggable)
    {
      Tags tags = ((Taggable)obj).tags();

      // public static Id Id.newId(String qname)
      // default Collection<BIDataValue> Tags.getValues(Id id)
      // Optional<BIDataValue> Tags.get(Id id)
      Collection<Tag> collection = tags.getAll();
      Iterator<Tag> it = collection.iterator();

      while (it.hasNext())
      {
        Tag tag = it.next();
        if(tag.getId().toString().equals(id.toString())) return tag.getValue();
      }
    }

    return BString.make("");
  }


}
