package com.vykon.vykonPro.bql;

import javax.baja.status.BStatusEnum;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BIcon;
import javax.baja.sys.BMonth;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BTime;
import javax.baja.sys.BWeekday;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.tridium.bql.util.BDynamicTimeRange;
import com.vykon.vykonPro.enums.BBaseLineRangeEnum;

public class BRangeShifter
    extends BComponent
{
  /*-
   class BRangeShifter
   {
     properties
     {
       timeRangeIn: BDynamicTimeRange
         -- The configured time range used to calculate the Time Range Out
         default{[ BDynamicTimeRange.make("today") ]}
         flags{ summary }
       timeRangeOut: BDynamicTimeRange
         -- The calculated time range based on the configured Time Range In and Base Line Period
         default{[ BDynamicTimeRange.make("today") ]}
         flags{ readonly, summary }
       
       baseLinePeriod: BStatusEnum
         -- The configured base line period which will be used with the Time Range In to calculate
         -- the Time Range Out value.
         flags{  }
         default{[ new BStatusEnum(BDynamicEnum.make(0, BEnumRange.make(BBaseLineRangeEnum.TYPE))) ]}
        
       shift: BRelTime
          -- The relative time difference between the start time properties of the Time Range In and
          -- Time Range Out properties.
          default{[ BRelTime.make(0) ]}
          flags{ readonly, summary }
          
       updatePeriod: BRelTime
         -- used to confiugre how often the RangeShifter updates when the timeRangeIn is configured
         -- for last24Hours, weekToDate, monthToDate or yearToDate.
         default{[ BRelTime.makeMinutes(15) ]}
         flags{ hidden }
         
       
     }
     actions
     {
       timerExpired()
        flags { hidden }
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.bql.BRangeShifter(1555313211)1.0$ @*/
/* Generated Wed Nov 27 11:58:27 EST 2013 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "timeRangeIn"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeRangeIn</code> property.
   * The configured time range used to calculate the Time
   * Range Out
   * @see com.vykon.vykonPro.bql.BRangeShifter#getTimeRangeIn
   * @see com.vykon.vykonPro.bql.BRangeShifter#setTimeRangeIn
   */
  public static final Property timeRangeIn = newProperty(Flags.SUMMARY, BDynamicTimeRange.make("today"),null);
  
  /**
   * Get the <code>timeRangeIn</code> property.
   * The configured time range used to calculate the Time
   * Range Out
   * @see com.vykon.vykonPro.bql.BRangeShifter#timeRangeIn
   */
  public BDynamicTimeRange getTimeRangeIn() { return (BDynamicTimeRange)get(timeRangeIn); }
  
  /**
   * Set the <code>timeRangeIn</code> property.
   * The configured time range used to calculate the Time
   * Range Out
   * @see com.vykon.vykonPro.bql.BRangeShifter#timeRangeIn
   */
  public void setTimeRangeIn(BDynamicTimeRange v) { set(timeRangeIn,v,null); }

////////////////////////////////////////////////////////////////
// Property "timeRangeOut"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeRangeOut</code> property.
   * The calculated time range based on the configured Time Range In and Base Line Period
   * @see com.vykon.vykonPro.bql.BRangeShifter#getTimeRangeOut
   * @see com.vykon.vykonPro.bql.BRangeShifter#setTimeRangeOut
   */
  public static final Property timeRangeOut = newProperty(Flags.READONLY|Flags.SUMMARY, BDynamicTimeRange.make("today"),null);
  
  /**
   * Get the <code>timeRangeOut</code> property.
   * The calculated time range based on the configured Time Range In and Base Line Period
   * @see com.vykon.vykonPro.bql.BRangeShifter#timeRangeOut
   */
  public BDynamicTimeRange getTimeRangeOut() { return (BDynamicTimeRange)get(timeRangeOut); }
  
  /**
   * Set the <code>timeRangeOut</code> property.
   * The calculated time range based on the configured Time Range In and Base Line Period
   * @see com.vykon.vykonPro.bql.BRangeShifter#timeRangeOut
   */
  public void setTimeRangeOut(BDynamicTimeRange v) { set(timeRangeOut,v,null); }

////////////////////////////////////////////////////////////////
// Property "baseLinePeriod"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>baseLinePeriod</code> property.
   * The configured base line period which will be used
   * with the Time Range In to calculate the Time Range
   * Out value.
   * @see com.vykon.vykonPro.bql.BRangeShifter#getBaseLinePeriod
   * @see com.vykon.vykonPro.bql.BRangeShifter#setBaseLinePeriod
   */
  public static final Property baseLinePeriod = newProperty(0, new BStatusEnum(BDynamicEnum.make(0, BEnumRange.make(BBaseLineRangeEnum.TYPE))),null);
  
  /**
   * Get the <code>baseLinePeriod</code> property.
   * The configured base line period which will be used
   * with the Time Range In to calculate the Time Range
   * Out value.
   * @see com.vykon.vykonPro.bql.BRangeShifter#baseLinePeriod
   */
  public BStatusEnum getBaseLinePeriod() { return (BStatusEnum)get(baseLinePeriod); }
  
  /**
   * Set the <code>baseLinePeriod</code> property.
   * The configured base line period which will be used
   * with the Time Range In to calculate the Time Range
   * Out value.
   * @see com.vykon.vykonPro.bql.BRangeShifter#baseLinePeriod
   */
  public void setBaseLinePeriod(BStatusEnum v) { set(baseLinePeriod,v,null); }

////////////////////////////////////////////////////////////////
// Property "shift"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>shift</code> property.
   * The relative time difference between the start time
   * properties of the Time Range In and Time Range Out
   * properties.
   * @see com.vykon.vykonPro.bql.BRangeShifter#getShift
   * @see com.vykon.vykonPro.bql.BRangeShifter#setShift
   */
  public static final Property shift = newProperty(Flags.READONLY|Flags.SUMMARY, BRelTime.make(0),null);
  
  /**
   * Get the <code>shift</code> property.
   * The relative time difference between the start time
   * properties of the Time Range In and Time Range Out
   * properties.
   * @see com.vykon.vykonPro.bql.BRangeShifter#shift
   */
  public BRelTime getShift() { return (BRelTime)get(shift); }
  
  /**
   * Set the <code>shift</code> property.
   * The relative time difference between the start time
   * properties of the Time Range In and Time Range Out
   * properties.
   * @see com.vykon.vykonPro.bql.BRangeShifter#shift
   */
  public void setShift(BRelTime v) { set(shift,v,null); }

////////////////////////////////////////////////////////////////
// Property "updatePeriod"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>updatePeriod</code> property.
   * used to confiugre how often the RangeShifter updates
   * when the timeRangeIn is configured for last24Hours,
   * weekToDate, monthToDate or yearToDate.
   * @see com.vykon.vykonPro.bql.BRangeShifter#getUpdatePeriod
   * @see com.vykon.vykonPro.bql.BRangeShifter#setUpdatePeriod
   */
  public static final Property updatePeriod = newProperty(Flags.HIDDEN, BRelTime.makeMinutes(15),null);
  
  /**
   * Get the <code>updatePeriod</code> property.
   * used to confiugre how often the RangeShifter updates
   * when the timeRangeIn is configured for last24Hours,
   * weekToDate, monthToDate or yearToDate.
   * @see com.vykon.vykonPro.bql.BRangeShifter#updatePeriod
   */
  public BRelTime getUpdatePeriod() { return (BRelTime)get(updatePeriod); }
  
  /**
   * Set the <code>updatePeriod</code> property.
   * used to confiugre how often the RangeShifter updates
   * when the timeRangeIn is configured for last24Hours,
   * weekToDate, monthToDate or yearToDate.
   * @see com.vykon.vykonPro.bql.BRangeShifter#updatePeriod
   */
  public void setUpdatePeriod(BRelTime v) { set(updatePeriod,v,null); }

////////////////////////////////////////////////////////////////
// Action "timerExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timerExpired</code> action.
   * @see com.vykon.vykonPro.bql.BRangeShifter#timerExpired()
   */
  public static final Action timerExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>timerExpired</code> action.
   * @see com.vykon.vykonPro.bql.BRangeShifter#timerExpired
   */
  public void timerExpired() { invoke(timerExpired,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRangeShifter.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    if(!isRunning()) return;
    
    calculate();
    initTimer();
  }
  
  public void stopped()
  {
    if(updateTicket!=null) updateTicket.cancel();
  }
  
  public void changed(Property p, Context cx)
  {
    if(!isRunning()) return;
    
    if(p.equals(timeRangeIn))
    {
      calculate();
      initTimer();
    }
    else if(p.equals(baseLinePeriod))
    {
      if(getBaseLinePeriod().getEnum().getOrdinal()==BBaseLineRangeEnum.CUSTOM)
      {
        // make the slot timeRangeOut slot writable
        Slot s = this.getSlot("timeRangeOut");
        if(Flags.isReadonly(this, s)) this.setFlags(s, this.getFlags(s) &~Flags.READONLY);
      }
      else
      {
        Slot s = this.getSlot("timeRangeOut");
        if(!Flags.isReadonly(this, s)) this.setFlags(s, this.getFlags(s) | Flags.READONLY);
      }
      
      calculate();
      initTimer();
    }
    else if(p.equals(timeRangeOut))
    {
      Slot s = this.getSlot("timeRangeOut");
      if(!Flags.isReadonly(this, s))
      {
        calculate();
        initTimer();
      }
    }
    else if(p.equals(updatePeriod))
    {
        initTimer();
    }
  }
  
  public void clockChanged(BRelTime shift)
  {
    initTimer();
  }
  
  public void doTimerExpired()
  {
    calculate();
    initTimer();
  }
  
  private void calculate()
  {
    BAbsTime current = Clock.time();
    BRelTime difference = BRelTime.make(0);
    
    // get the start and end times from the timeRangeIn property
    BAbsTime start = getTimeRangeIn().getStartTime(current);
    BAbsTime stop = getTimeRangeIn().getEndTime(current);
    
    BAbsTime previousStart = BAbsTime.NULL;
    BAbsTime previousStop = BAbsTime.NULL;
    
    
    switch(getBaseLinePeriod().getEnum().getOrdinal())
    {
      case BBaseLineRangeEnum.NONE:
        setTimeRangeOut((BDynamicTimeRange)getTimeRangeIn().newCopy());
        break;
        
      case BBaseLineRangeEnum.WEEK_PRIOR:
        previousStart = start.prev(start.getWeekday());
		previousStop = stop.prev(stop.getWeekday());
        break;
        
      case BBaseLineRangeEnum.MONTH_PRIOR:
        previousStart = start.prevMonth();
		previousStop = stop.prevMonth();
        break;
        
      case BBaseLineRangeEnum.YEAR_PRIOR:
        previousStart = start.prevYear();
		previousStop = stop.prevYear();
        break;
        
      case BBaseLineRangeEnum.CUSTOM:
        // the user is manually setting the timeRangeOut value
        break;
    }
    
    if(previousStart!=BAbsTime.NULL)
    {
      difference = start.delta(previousStart);
      //previousStop = stop.add(difference);
      setTimeRangeOut(BDynamicTimeRange.make(previousStart,previousStop));
    }
    else
    {
      // using none or custom base line
      difference =start.delta(getTimeRangeOut().getStartTime(current));
    }
    
    // this looks odd, but we are shifting these timestamps back by the difference and 
    // need to tell the timeShift node to shift them forward by the same amount.
    setShift(BRelTime.make(difference.getMillis()*(-1)));
  }
  
  private void initTimer()
  {
    if(!isRunning()) return;
    
    int ordinal = getTimeRangeIn().getRangeType().getOrdinal();
    BAbsTime current = Clock.time();
    BAbsTime future;
    
    if(updateTicket!=null) updateTicket.cancel();
    
    switch(ordinal)
    {
      case 0: // fixed time range
        // no need to update because it is configured for a fixed time range
        break;
        
      case 1: // today
      case 3: // yesterday
      case 6: // last7Days
        // should update these as the day changes
        future = BAbsTime.make(current.nextDay(),BTime.MIDNIGHT);
        updateTicket = Clock.schedule(this,future,timerExpired,null);
        break;
        
      case 2: // last24Hours
      case 4: // weekToDate
      case 7: // monthToDate
      case 9: // yearToDate
        // should update as reasonably possible use hidden configuration parameter
        updateTicket = Clock.schedule(this,getUpdatePeriod(),timerExpired,null);
        break;
        
      case 5: // last week
        // should update on first day of week
        future = current.next(BWeekday.sunday);
        updateTicket = Clock.schedule(this,future,timerExpired,null);
        break;
        
      case 8: // last month
        // should update on the first day of the month
        future = BAbsTime.make(current.getYear(),current.getMonth(),1).nextMonth();
        updateTicket = Clock.schedule(this, future, timerExpired, null);
        break;
        
      case 10: // lastYear
        // should update on the first day of the year
        future = BAbsTime.make(current.getYear()+1,BMonth.make(0),1);
        updateTicket = Clock.schedule(this,future,timerExpired,null);
        break;
    }
  }
  
  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("clock.png");
  
  /////////////////////////////////////////
  // local variables
  /////////////////////////////////////////
  
  Clock.Ticket updateTicket;
  

}
