package com.vykon.vykonPro.bql;

import javax.baja.bql.BIAggregator;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BObject;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BString;
import javax.baja.sys.BTime;
import javax.baja.sys.BWeekday;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BAbsTimeRange;

import com.tridium.bql.BBqlTime;

public class BRuntime
    extends BObject
    implements BIAggregator
{
  /*-
   class BRuntime
   {
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.bql.BRuntime(2011728939)1.0$ @*/
/* Generated Wed Mar 20 10:40:52 EDT 2013 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRuntime.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void aggregate(BBoolean state, BAbsTime tstamp, BBoolean value)
  {
    aggregate(state.getBoolean(),tstamp,value.getBoolean());
  }
  
  public void aggregate(boolean state, BAbsTime tstamp, BBoolean value)
  {
    aggregate(state,tstamp,value.getBoolean());
  }
  
  public void aggregate(BBoolean state, BAbsTime tstamp, boolean value)
  {
    aggregate(state.getBoolean(), tstamp, value);
  }
    
  public void aggregate(boolean state, BAbsTime tstamp, boolean value)
  {
    if(startOf==BAbsTime.NULL)
    {
      if(value==state)
      {
        //first record being checked
        startOf = tstamp;
        currentState = value;
      }
    }
    else
    {
      if(currentState!=value && currentState==state)
      {
        //transitioned from the state calculating elapsed time for
        long diff = tstamp.getMillis()-startOf.getMillis();
        elapsed = BRelTime.make(elapsed.getMillis() + diff);
        currentState=value;
      }
      else if(currentState!=value && currentState!=state)
      {
        //transitioned to the state calculating elapsed time for
        currentState=value;
        startOf=tstamp;
      }
    }
  }
  
  public void aggregate(BString rollup, BBoolean state, BAbsTime tstamp, BBoolean value)
  {
    aggregate(rollup.toString(),state.getBoolean(),tstamp,value.getBoolean());
  }
  
  /*
   * valid rollup values are hourly, daily, weekly, monthly and yearly
   */
  public void aggregate(String rollup, boolean state, BAbsTime tstamp, boolean value)
  {
    range = calcRollup(rollup,tstamp);
    
    checkState = state;
    
    if(firstRecord)
    {
      if(value==state)
      {
        //first record being checked
        startOf = range.getStartTime();
        currentState = value;
        
        //calculate elapsed since start of rollup until this record
        long diff = tstamp.getMillis()-startOf.getMillis();
        elapsed = BRelTime.make(diff);
        
        System.out.println("aggregate startOf="+startOf + " | tstamp=" + tstamp + " | value=" + value + " | elapsed=" + elapsed);
        
        startOf = tstamp;
      }
      else
      {
        //not state being calculated for so update startOf
        startOf = tstamp;
        currentState = value;
        
        System.out.println("aggregate firstRecord tstamp=" + tstamp + " | value=" + value);
        
      }
      firstRecord = false;
    }
    else
    {
      if(currentState!=value && currentState==state)
      {
        //transitioned from the state calculating elapsed time for
        long diff = tstamp.getMillis()-startOf.getMillis();
        elapsed = BRelTime.make(elapsed.getMillis() + diff);
        currentState=value;
        
        System.out.println("aggregate startOf="+startOf + " | tstamp=" + tstamp + " | value=" + value + " | elapsed=" + elapsed);
        
        
      }
      else if(currentState!=value && currentState!=state)
      {
        //transitioned to the state calculating elapsed time for
        currentState=value;
        startOf=tstamp;
      }
      else
      {
        System.out.println("aggregate skipping tstamp=" + tstamp + " | value=" + value);
      }
    }
  }
    
  public BAbsTimeRange calcRollup(String rollup, BAbsTime tstamp)
  {
    BAbsTime start = BAbsTime.DEFAULT;
    BAbsTime end = BAbsTime.END_OF_TIME;
    
    if(rollup.equals("hourly"))
    {
      start = BAbsTime.make(tstamp, BTime.make(tstamp.getHour(),0,0,0));
      end = start.nextDay().subtract(BRelTime.make(1));
    }
    else if(rollup.equals("daily"))
    {
      start = BBqlTime.startofday(tstamp);
      end = BBqlTime.endofday(tstamp);
    }
    else if(rollup.equals("weekly"))
    {
      BWeekday first = BWeekday.getFirstDayOfWeek(null);
      if(tstamp.getWeekday()!=BWeekday.getFirstDayOfWeek(null)) start = tstamp.prev(first);
      else start = tstamp;
      //set to midnight
      start = BAbsTime.make(start,BTime.MIDNIGHT);
      end = start.next(first).subtract(BRelTime.make(1));
    }
    else if(rollup.equals("monthly"))
    {
      start = BBqlTime.startofmonth(tstamp);
      end = BBqlTime.endofmonth(tstamp);
    }
    else if(rollup.equals("yearly"))
    {
      start = BBqlTime.startofyear(tstamp);
      end = BBqlTime.endofyear(tstamp);
    }
    
    return new BAbsTimeRange(start,end); 
  }
  
  public BRelTime commit()
  {
    if(currentState==checkState)
    {
      //the last record is the state to calculate elapsed time for, so use end of timerange
      long diff = range.getEndTime().getMillis()-startOf.getMillis();
      lastElapsed = BRelTime.make(elapsed.getMillis() + diff);
      
      System.out.println("commit startOf="+startOf + " | end=" + range.getEndTime() + " | value=" + currentState + " | elapsed=" + elapsed + " | lastElapsed=" + lastElapsed);
    }
    
    //firstRecord = true;
    
    return lastElapsed;
  }
  
  private BAbsTime startOf = BAbsTime.NULL;
  private BAbsTimeRange range = new BAbsTimeRange();
  private boolean checkState;
  private boolean currentState;
  private boolean firstRecord = true;
  private BRelTime elapsed = BRelTime.DEFAULT ;
  private BRelTime lastElapsed = BRelTime.DEFAULT;
  
  
  

}
