package com.vykon.vykonPro.conversion;

import javax.baja.naming.SlotPath;
import javax.baja.status.BStatusString;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BIcon;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BFormat;

public class BAbsTimeToStatusString
    extends BComponent
{
  /*-
   class BAbsTimeToStatusString
   {
     properties
     {
       format: BFormat
         --String which when resolved is stored in the ord field
         flags{ }
         default {[ BFormat.make("%.%") ]}
         
       timestampIn: BAbsTime
         --BAbsTime input to convert to string output
         flags{ summary, operator }
         default{[ BAbsTime.NULL ]}
         
       timestampOut: BStatusString
         --The formated string output
         flags{ summary, readonly }
         default{[ new BStatusString() ]}
         
      
     }
     actions
     {
       calculate()
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.conversion.BAbsTimeToStatusString(3433082197)1.0$ @*/
/* Generated Tue Mar 16 15:46:33 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "format"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>format</code> property.
   * String which when resolved is stored in the ord field
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#getFormat
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#setFormat
   */
  public static final Property format = newProperty(0, BFormat.make("%.%"),null);
  
  /**
   * Get the <code>format</code> property.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#format
   */
  public BFormat getFormat() { return (BFormat)get(format); }
  
  /**
   * Set the <code>format</code> property.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#format
   */
  public void setFormat(BFormat v) { set(format,v,null); }

////////////////////////////////////////////////////////////////
// Property "timestampIn"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timestampIn</code> property.
   * BAbsTime input to convert to string output
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#getTimestampIn
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#setTimestampIn
   */
  public static final Property timestampIn = newProperty(Flags.SUMMARY|Flags.OPERATOR, BAbsTime.NULL,null);
  
  /**
   * Get the <code>timestampIn</code> property.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#timestampIn
   */
  public BAbsTime getTimestampIn() { return (BAbsTime)get(timestampIn); }
  
  /**
   * Set the <code>timestampIn</code> property.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#timestampIn
   */
  public void setTimestampIn(BAbsTime v) { set(timestampIn,v,null); }

////////////////////////////////////////////////////////////////
// Property "timestampOut"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timestampOut</code> property.
   * The formated string output
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#getTimestampOut
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#setTimestampOut
   */
  public static final Property timestampOut = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusString(),null);
  
  /**
   * Get the <code>timestampOut</code> property.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#timestampOut
   */
  public BStatusString getTimestampOut() { return (BStatusString)get(timestampOut); }
  
  /**
   * Set the <code>timestampOut</code> property.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#timestampOut
   */
  public void setTimestampOut(BStatusString v) { set(timestampOut,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#calculate()
   */
  public static final Action calculate = newAction(0,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.conversion.BAbsTimeToStatusString#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAbsTimeToStatusString.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started() throws Exception
  {
    calculate();
  }

  public void changed(Property property, Context context) 
  {
   super.changed(property, context);
    if( !Sys.atSteadyState() || !isRunning() )
     return;
   
   if(property.equals(format) || property.equals(timestampIn)) calculate();
    
  }
  
  private String resolveTimestamp()
  {
    BFormat pattern = getFormat();
    
    // This is a tricky issue.  It looks funny but it's correct.
    // The resolved pattern must be unescaped because it may include
    // slot names of ancestors (ex. "%parent.name%") which are already
    // escaped.  Sometimes the result needs to be escaped because
    // it may just be static test (ex. "My History").  By unescaping
    // the result first, the escape will always return the right result. 
    return SlotPath.unescape(SlotPath.escape(SlotPath.unescape(pattern.format(this.getTimestampIn()))));
  }
  
  public void doCalculate()
  {
    String tout = resolveTimestamp();
    getTimestampOut().setValue(tout);
  }

  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.std("clock.png");

}
