package com.vykon.vykonPro.conversion;

import javax.baja.status.BStatusBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BValue;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Topic;
import javax.baja.sys.Type;

public class BStatusBooleanToTrigger
    extends BComponent
{
  /*-
   class BStatusBooleanToTrigger
   {
     properties
     {
       in: BStatusBoolean
         -- StatusBoolean input
         flags{operator, summary}
         default{[ new BStatusBoolean() ]}
       
       fireOn: boolean
         -- When set to a true value, the trigger is fired whenever the in value transitions from false to true.
         -- When set to a false value, the trigger is fired whenever the in value transitions from true to false.
         flags{ operator }
         default{[ true ]}
       
     }
     actions
     {
     }
     topics
     {
       trigger
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.conversion.BStatusBooleanToTrigger(1174181188)1.0$ @*/
/* Generated Thu Apr 22 21:11:57 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "in"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in</code> property.
   * StatusBoolean input
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#getIn
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#setIn
   */
  public static final Property in = newProperty(Flags.OPERATOR|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>in</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#in
   */
  public BStatusBoolean getIn() { return (BStatusBoolean)get(in); }
  
  /**
   * Set the <code>in</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#in
   */
  public void setIn(BStatusBoolean v) { set(in,v,null); }

////////////////////////////////////////////////////////////////
// Property "fireOn"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>fireOn</code> property.
   * When set to a true value, the trigger is fired whenever
   * the in value transitions from false to true. When set to a false value, the trigger is fired whenever the in value transitions from true to false.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#getFireOn
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#setFireOn
   */
  public static final Property fireOn = newProperty(Flags.OPERATOR, true,null);
  
  /**
   * Get the <code>fireOn</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#fireOn
   */
  public boolean getFireOn() { return getBoolean(fireOn); }
  
  /**
   * Set the <code>fireOn</code> property.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#fireOn
   */
  public void setFireOn(boolean v) { setBoolean(fireOn,v,null); }

////////////////////////////////////////////////////////////////
// Topic "trigger"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>trigger</code> topic.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#fireTrigger
   */
  public static final Topic trigger = newTopic(0,null);
  
  /**
   * Fire an event for the <code>trigger</code> topic.
   * @see com.vykon.vykonPro.conversion.BStatusBooleanToTrigger#trigger
   */
  public void fireTrigger(BValue event) { fire(trigger, event, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BStatusBooleanToTrigger.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public void started()
  {
    lastIn = getIn().getValue();
  }
  
  public void changed(Property prop, Context cx)
  {
    if(prop.equals(in))
    {
      if(getIn().getValue() && lastIn==false)
      {
        lastIn = true;
        
        //transition from false to true
        if(getFireOn())
        {
          //should fire trigger on true
          fireTrigger(null);
        }
      }
      else if(!getIn().getValue() && lastIn==true)
      {
        
        lastIn = false;
        
        //transition from true to false
        if(!getFireOn())
        {
          //should fire trigger on false
          fireTrigger(null);
        }
      }
    }
  }
  
  ///////////////////////////////////////////
  // local variables
  //////////////////////////////////////////
  
  boolean lastIn;
}
