package com.vykon.vykonPro.history;

import javax.baja.history.BHistoryConfig;
import javax.baja.history.BHistoryId;
import javax.baja.history.BHistoryService;
import javax.baja.history.BIHistory;
import javax.baja.history.HistorySpaceConnection;
import javax.baja.history.db.BHistoryDatabase;
import javax.baja.history.db.HistoryDatabaseConnection;
import javax.baja.history.ext.BActivePeriod;
import javax.baja.history.ext.BBasicActivePeriod;
import javax.baja.naming.BOrd;
import javax.baja.naming.BOrdList;
import javax.baja.naming.SlotPath;
import javax.baja.space.BComponentSpace;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusBoolean;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.ServiceNotFoundException;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.timezone.BTimeZone;
import javax.baja.util.BFormat;
import javax.baja.util.BTypeSpec;


public class BBypassLogger
    extends BComponent
{
  /*-
   class BBypassLogger
   {
     properties
     {
       status: BStatus
        -- The status of the bypassLogger
        flags { readonly, transient }
        default {[ BStatus.ok ]}

      faultCause: String
        -- If the component is in a fault state, this provides
        -- a description of the problem.
        flags { readonly, transient }
        default {[ "" ]}
      
      enabled: boolean
        -- Used to manually enable and disable this component.
        flags { defaultOnClone }
        default {[ false ]}
            
      activePeriod: BActivePeriod
        -- Defines the time period when this component should be collecting
        -- history records.
        default {[ new BBasicActivePeriod() ]}

      active: boolean
        -- Indicates whether this component is currently in it's active period.
        flags { readonly, transient }
        default {[ false ]}
      
      historyName: BFormat
        -- This properties defines a pattern for deriving the
        -- name of the history created by this extension.
        -- It can be static text or a simple pattern that allows
        -- the actual history name to be derived from the context.
        -- The default value of this property is %parent.name% which
        -- sets the history name in the id to the name of the parent
        -- of this extension.<p>
        -- Changes to this property cause the format to be reapplied
        -- and the history id in the history config is updated.
        default {[ BFormat.make("%name%") ]}
      
      historyConfig: BHistoryConfig
        -- The configuration for the history created by this extension.
        default {[ new BHistoryConfig() ]}
		flags { defaultOnClone }
        
      elapsedTimeFacets: BFacets
        -- These facets are applied to the history record.
        flags { defaultOnClone }
        default {[ BFacets.make(BFacets.SHOW_SECONDS, BBoolean.FALSE) ]}
      
      timestampFacets: BFacets
        -- These facets are applied to the history record.
        flags { defaultOnClone }
        default {[ BFacets.NULL ]}
        
      bypassInput: BStatusBoolean
        flags { summary }
        default{[ new BStatusBoolean() ]}
      
	  lastInput: BStatusBoolean
        flags { hidden, readonly }
        default{[ new BStatusBoolean() ]}

      startTime: BAbsTime
        flags { hidden, readonly }
        default{[ BAbsTime.NULL ]}
        
      timestamp: BAbsTime
        flags { readonly }
        default{[ BAbsTime.NULL ]}
        
      timestampEnd: BAbsTime
        flags { readonly }
        default{[ BAbsTime.NULL ]}
        
      elapsedTime: BRelTime
        flags { readonly }
        default{[ BRelTime.make(0) ]}
     }
     actions
     {
       appendRecord()
        flags { hidden }
      
      syncConfig()
        -- Synchronize the history configuration of this component
        -- with the configuration that is stored with the history
        -- in the database.
        flags { hidden, async }

     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.history.BBypassLogger(2620605969)1.0$ @*/
/* Generated Fri Dec 09 09:29:53 EST 2016 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code status} property.
   * The status of the bypassLogger
   * @see #getStatus
   * @see #setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.TRANSIENT, BStatus.ok, null);
  
  /**
   * Get the {@code status} property.
   * The status of the bypassLogger
   * @see #status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the {@code status} property.
   * The status of the bypassLogger
   * @see #status
   */
  public void setStatus(BStatus v) { set(status, v, null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code faultCause} property.
   * If the component is in a fault state, this provides
   * a description of the problem.
   * @see #getFaultCause
   * @see #setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.TRANSIENT, "", null);
  
  /**
   * Get the {@code faultCause} property.
   * If the component is in a fault state, this provides
   * a description of the problem.
   * @see #faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the {@code faultCause} property.
   * If the component is in a fault state, this provides
   * a description of the problem.
   * @see #faultCause
   */
  public void setFaultCause(String v) { setString(faultCause, v, null); }

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code enabled} property.
   * Used to manually enable and disable this component.
   * @see #getEnabled
   * @see #setEnabled
   */
  public static final Property enabled = newProperty(Flags.DEFAULT_ON_CLONE, false, null);
  
  /**
   * Get the {@code enabled} property.
   * Used to manually enable and disable this component.
   * @see #enabled
   */
  public boolean getEnabled() { return getBoolean(enabled); }
  
  /**
   * Set the {@code enabled} property.
   * Used to manually enable and disable this component.
   * @see #enabled
   */
  public void setEnabled(boolean v) { setBoolean(enabled, v, null); }

////////////////////////////////////////////////////////////////
// Property "activePeriod"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code activePeriod} property.
   * Defines the time period when this component should be collecting
   * history records.
   * @see #getActivePeriod
   * @see #setActivePeriod
   */
  public static final Property activePeriod = newProperty(0, new BBasicActivePeriod(), null);
  
  /**
   * Get the {@code activePeriod} property.
   * Defines the time period when this component should be collecting
   * history records.
   * @see #activePeriod
   */
  public BActivePeriod getActivePeriod() { return (BActivePeriod)get(activePeriod); }
  
  /**
   * Set the {@code activePeriod} property.
   * Defines the time period when this component should be collecting
   * history records.
   * @see #activePeriod
   */
  public void setActivePeriod(BActivePeriod v) { set(activePeriod, v, null); }

////////////////////////////////////////////////////////////////
// Property "active"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code active} property.
   * Indicates whether this component is currently in it's active period.
   * @see #getActive
   * @see #setActive
   */
  public static final Property active = newProperty(Flags.READONLY|Flags.TRANSIENT, false, null);
  
  /**
   * Get the {@code active} property.
   * Indicates whether this component is currently in it's active period.
   * @see #active
   */
  public boolean getActive() { return getBoolean(active); }
  
  /**
   * Set the {@code active} property.
   * Indicates whether this component is currently in it's active period.
   * @see #active
   */
  public void setActive(boolean v) { setBoolean(active, v, null); }

////////////////////////////////////////////////////////////////
// Property "historyName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code historyName} property.
   * This properties defines a pattern for deriving the
   * name of the history created by this extension.
   * It can be static text or a simple pattern that allows
   * the actual history name to be derived from the context.
   * The default value of this property is %parent.name% which
   * sets the history name in the id to the name of the parent
   * of this extension.<p>
   * Changes to this property cause the format to be reapplied
   * and the history id in the history config is updated.
   * @see #getHistoryName
   * @see #setHistoryName
   */
  public static final Property historyName = newProperty(0, BFormat.make("%name%"), null);
  
  /**
   * Get the {@code historyName} property.
   * This properties defines a pattern for deriving the
   * name of the history created by this extension.
   * It can be static text or a simple pattern that allows
   * the actual history name to be derived from the context.
   * The default value of this property is %parent.name% which
   * sets the history name in the id to the name of the parent
   * of this extension.<p>
   * Changes to this property cause the format to be reapplied
   * and the history id in the history config is updated.
   * @see #historyName
   */
  public BFormat getHistoryName() { return (BFormat)get(historyName); }
  
  /**
   * Set the {@code historyName} property.
   * This properties defines a pattern for deriving the
   * name of the history created by this extension.
   * It can be static text or a simple pattern that allows
   * the actual history name to be derived from the context.
   * The default value of this property is %parent.name% which
   * sets the history name in the id to the name of the parent
   * of this extension.<p>
   * Changes to this property cause the format to be reapplied
   * and the history id in the history config is updated.
   * @see #historyName
   */
  public void setHistoryName(BFormat v) { set(historyName, v, null); }

////////////////////////////////////////////////////////////////
// Property "historyConfig"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code historyConfig} property.
   * The configuration for the history created by this extension.
   * @see #getHistoryConfig
   * @see #setHistoryConfig
   */
  public static final Property historyConfig = newProperty(Flags.DEFAULT_ON_CLONE, new BHistoryConfig(), null);
  
  /**
   * Get the {@code historyConfig} property.
   * The configuration for the history created by this extension.
   * @see #historyConfig
   */
  public BHistoryConfig getHistoryConfig() { return (BHistoryConfig)get(historyConfig); }
  
  /**
   * Set the {@code historyConfig} property.
   * The configuration for the history created by this extension.
   * @see #historyConfig
   */
  public void setHistoryConfig(BHistoryConfig v) { set(historyConfig, v, null); }

////////////////////////////////////////////////////////////////
// Property "elapsedTimeFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code elapsedTimeFacets} property.
   * These facets are applied to the history record.
   * @see #getElapsedTimeFacets
   * @see #setElapsedTimeFacets
   */
  public static final Property elapsedTimeFacets = newProperty(Flags.DEFAULT_ON_CLONE, BFacets.make(BFacets.SHOW_SECONDS, BBoolean.FALSE), null);
  
  /**
   * Get the {@code elapsedTimeFacets} property.
   * These facets are applied to the history record.
   * @see #elapsedTimeFacets
   */
  public BFacets getElapsedTimeFacets() { return (BFacets)get(elapsedTimeFacets); }
  
  /**
   * Set the {@code elapsedTimeFacets} property.
   * These facets are applied to the history record.
   * @see #elapsedTimeFacets
   */
  public void setElapsedTimeFacets(BFacets v) { set(elapsedTimeFacets, v, null); }

////////////////////////////////////////////////////////////////
// Property "timestampFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code timestampFacets} property.
   * These facets are applied to the history record.
   * @see #getTimestampFacets
   * @see #setTimestampFacets
   */
  public static final Property timestampFacets = newProperty(Flags.DEFAULT_ON_CLONE, BFacets.NULL, null);
  
  /**
   * Get the {@code timestampFacets} property.
   * These facets are applied to the history record.
   * @see #timestampFacets
   */
  public BFacets getTimestampFacets() { return (BFacets)get(timestampFacets); }
  
  /**
   * Set the {@code timestampFacets} property.
   * These facets are applied to the history record.
   * @see #timestampFacets
   */
  public void setTimestampFacets(BFacets v) { set(timestampFacets, v, null); }

////////////////////////////////////////////////////////////////
// Property "bypassInput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code bypassInput} property.
   * @see #getBypassInput
   * @see #setBypassInput
   */
  public static final Property bypassInput = newProperty(Flags.SUMMARY, new BStatusBoolean(), null);
  
  /**
   * Get the {@code bypassInput} property.
   * @see #bypassInput
   */
  public BStatusBoolean getBypassInput() { return (BStatusBoolean)get(bypassInput); }
  
  /**
   * Set the {@code bypassInput} property.
   * @see #bypassInput
   */
  public void setBypassInput(BStatusBoolean v) { set(bypassInput, v, null); }

////////////////////////////////////////////////////////////////
// Property "lastInput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code lastInput} property.
   * @see #getLastInput
   * @see #setLastInput
   */
  public static final Property lastInput = newProperty(Flags.HIDDEN|Flags.READONLY, new BStatusBoolean(), null);
  
  /**
   * Get the {@code lastInput} property.
   * @see #lastInput
   */
  public BStatusBoolean getLastInput() { return (BStatusBoolean)get(lastInput); }
  
  /**
   * Set the {@code lastInput} property.
   * @see #lastInput
   */
  public void setLastInput(BStatusBoolean v) { set(lastInput, v, null); }

////////////////////////////////////////////////////////////////
// Property "startTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code startTime} property.
   * @see #getStartTime
   * @see #setStartTime
   */
  public static final Property startTime = newProperty(Flags.HIDDEN|Flags.READONLY, BAbsTime.NULL, null);
  
  /**
   * Get the {@code startTime} property.
   * @see #startTime
   */
  public BAbsTime getStartTime() { return (BAbsTime)get(startTime); }
  
  /**
   * Set the {@code startTime} property.
   * @see #startTime
   */
  public void setStartTime(BAbsTime v) { set(startTime, v, null); }

////////////////////////////////////////////////////////////////
// Property "timestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code timestamp} property.
   * @see #getTimestamp
   * @see #setTimestamp
   */
  public static final Property timestamp = newProperty(Flags.READONLY, BAbsTime.NULL, null);
  
  /**
   * Get the {@code timestamp} property.
   * @see #timestamp
   */
  public BAbsTime getTimestamp() { return (BAbsTime)get(timestamp); }
  
  /**
   * Set the {@code timestamp} property.
   * @see #timestamp
   */
  public void setTimestamp(BAbsTime v) { set(timestamp, v, null); }

////////////////////////////////////////////////////////////////
// Property "timestampEnd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code timestampEnd} property.
   * @see #getTimestampEnd
   * @see #setTimestampEnd
   */
  public static final Property timestampEnd = newProperty(Flags.READONLY, BAbsTime.NULL, null);
  
  /**
   * Get the {@code timestampEnd} property.
   * @see #timestampEnd
   */
  public BAbsTime getTimestampEnd() { return (BAbsTime)get(timestampEnd); }
  
  /**
   * Set the {@code timestampEnd} property.
   * @see #timestampEnd
   */
  public void setTimestampEnd(BAbsTime v) { set(timestampEnd, v, null); }

////////////////////////////////////////////////////////////////
// Property "elapsedTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code elapsedTime} property.
   * @see #getElapsedTime
   * @see #setElapsedTime
   */
  public static final Property elapsedTime = newProperty(Flags.READONLY, BRelTime.make(0), null);
  
  /**
   * Get the {@code elapsedTime} property.
   * @see #elapsedTime
   */
  public BRelTime getElapsedTime() { return (BRelTime)get(elapsedTime); }
  
  /**
   * Set the {@code elapsedTime} property.
   * @see #elapsedTime
   */
  public void setElapsedTime(BRelTime v) { set(elapsedTime, v, null); }

////////////////////////////////////////////////////////////////
// Action "appendRecord"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code appendRecord} action.
   * @see #appendRecord()
   */
  public static final Action appendRecord = newAction(Flags.HIDDEN, null);
  
  /**
   * Invoke the {@code appendRecord} action.
   * @see #appendRecord
   */
  public void appendRecord() { invoke(appendRecord, null, null); }

////////////////////////////////////////////////////////////////
// Action "syncConfig"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code syncConfig} action.
   * Synchronize the history configuration of this component
   * with the configuration that is stored with the history
   * in the database.
   * @see #syncConfig()
   */
  public static final Action syncConfig = newAction(Flags.HIDDEN|Flags.ASYNC, null);
  
  /**
   * Invoke the {@code syncConfig} action.
   * Synchronize the history configuration of this component
   * with the configuration that is stored with the history
   * in the database.
   * @see #syncConfig
   */
  public void syncConfig() { invoke(syncConfig, null, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBypassLogger.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started() throws Exception
  {
    setActive(getActivePeriod().isActive(BAbsTime.make()));
	
	if (!getHistoryConfig().getTimeZone().equals(BTimeZone.getLocal()))
        getHistoryConfig().setTimeZone(BTimeZone.getLocal());
  }
  
  /**
   * Get the ord to use as the source for the history.
   */
  public BOrd getSourceOrd()
  {
    BComponentSpace cs = getComponentSpace();
    if (cs == null)
      return null;
    BOrd base = cs.getOrdInSession();
    if (base == null)
      return null;
    return BOrd.make(base, getSlotPathOrd());
  }

  public BFacets getSlotFacets(Slot slot)
  {
    if(slot.equals(elapsedTime))
      return getElapsedTimeFacets();
    else if(slot.equals(timestamp) || slot.equals(timestampEnd))
      return getTimestampFacets();
    
    return super.getSlotFacets(slot);
  }
  
  /**
   * Handle a property change.
   */
  public void changed(Property p, Context c)
  {
    if (c == Context.decoding)
      return;
    if (!isRunning())
      return;
    
    // handle a change to the enabled state
    if (p.equals(enabled))
    {
      if (getEnabled())
      {
        BHistoryDatabase localDb =
          ((BHistoryService) Sys.getService(BHistoryService.TYPE)).getDatabase();

        if (localDb == null)
        {
          System.out.println("Local history database not available.");
          return;
        }

        try(HistorySpaceConnection conn = localDb.getDbConnection(null) )
        {
          BHistoryId id = BHistoryId.make(Sys.getStation().getStationName(), resolveHistoryName());
          if (!conn.exists(id)) createHistory();
        }
        catch (Exception e)
        {
          System.out.println(getSlotPath() + " - error resolving history database connection");
          e.printStackTrace();
          return;
        }
        updateStatus();
      }
    }
    
    //check the input
    else if (p.equals(bypassInput))
    {
      if(getBypassInput().getValue() && !getLastInput().getValue())
      {
        // transition from false to true
        setStartTime(BAbsTime.make());
        getLastInput().setValue(getBypassInput().getValue());
      }
      else if(!getBypassInput().getValue() && getLastInput().getValue())
      {
        // transition from true to false
        getLastInput().setValue(getBypassInput().getValue());
        appendRecord();
      }
    }
    
    // check active period
    else if (p.equals(activePeriod))
    {
      setActive(getActivePeriod().isActive(BAbsTime.make()));
    }
    
    else if (p.equals(elapsedTimeFacets)|| p.equals(timestampFacets))
    {
      syncConfig();
    }
    /*
     * // it is important to check for status or fault cause // here because those properties are
     * updated in // updateStatus(). If I update the status on a change // to those properties ->
     * StackOverflow.
     */
    else if (!p.equals(status) && !p.equals(faultCause))
      updateStatus();

  }
  
  /**
   * Handle a history configuration change.
   */
  public void historyConfigChanged(BHistoryConfig config, Property p)
  {
    if (!isRunning())
      return;
    if (config != getHistoryConfig())
      return;

    syncConfig();
  }

  /**
   * Synchronize the history configuration of this extension with the configuration that is stored
   * with the history in the database.
   */
  public synchronized void doSyncConfig()
  {
    if (getEnabled())
    {
      BHistoryService service = (BHistoryService) Sys.getService(BHistoryService.TYPE);
      BHistoryDatabase db = service.getDatabase();
      
      // get the existing config here and then change the few things
      BHistoryConfig config = getHistoryConfig(); 
      config.setTimeZone(BTimeZone.getLocal());
      
      BFacets f1 = (BFacets) config.get(ELAPSED_TIME_FACETS);

      if (f1 != null)
        config.set(ELAPSED_TIME_FACETS, BFacets.make(getElapsedTimeFacets()));
      else
        config.add(ELAPSED_TIME_FACETS, BFacets.make(getElapsedTimeFacets()));
      
      BFacets f2 = (BFacets) config.get(TIMESTAMP_END_FACETS);
      
      if (f2 != null)
        config.set(TIMESTAMP_END_FACETS, BFacets.make(getTimestampFacets()));
      else
        config.add(TIMESTAMP_END_FACETS, BFacets.make(getTimestampFacets()));
      
      BFacets f3 = (BFacets) config.get(TIMESTAMP_FACETS);
      
      if (f3 != null)
        config.set(TIMESTAMP_FACETS,  BFacets.make(getTimestampFacets()));
      else
        config.add(TIMESTAMP_FACETS, BFacets.make(getTimestampFacets()));
      
      try(HistoryDatabaseConnection conn = db.getDbConnection(null))
      {
        conn.reconfigureHistory(getHistoryConfig());
      }
	  
	  setHistoryConfig(config);

    }
  }

  /**
   * Update the extension status based on the current configuration and state.
   */
  public void updateStatus()
  {
    if (!getEnabled())
    {
      setStatus(BStatus.disabled);
      setFaultCause("");
    }
    else
    {
      boolean validName = getHistoryConfig().getId().isValid();
      if (!validName)
      {
        setStatus(BStatus.fault);
        setFaultCause("Invalid history name.");
      }
      else
      { // Otherwise its business as usual, but be sure to clear
        // the fault cause when setting the status to OK
        setStatus(BStatus.ok);
        setFaultCause("");
      }
    }
  }
  
  public void createHistory() throws Exception
  {

    try
    {
      // set typespec and source on HistoryConfig
      getHistoryConfig().setRecordType(
                                       BTypeSpec
                                           .make("vykonPro", "BypassTimeRecord"));
      BOrdList source = BOrdList.make(getSourceOrd());
      getHistoryConfig().setSource(source);
      getHistoryConfig().setId(
                               BHistoryId.make(Sys.getStation().getStationName(),
                                               resolveHistoryName()));

      // create history config
      BHistoryConfig config = getHistoryConfig();
      
      BFacets f1 = (BFacets) config.get(ELAPSED_TIME_FACETS);
      if (f1 != null)
        config.set(ELAPSED_TIME_FACETS, BFacets.make(getElapsedTimeFacets()));
      else
        config.add(ELAPSED_TIME_FACETS, BFacets.make(getElapsedTimeFacets()));
      
      BFacets f2 = (BFacets) config.get(TIMESTAMP_END_FACETS);
      if (f2 != null)
        config.set(TIMESTAMP_END_FACETS, BFacets.make(getTimestampFacets()));
      else
        config.add(TIMESTAMP_END_FACETS, BFacets.make(getTimestampFacets()));
      
      BFacets f3 = (BFacets) config.get(TIMESTAMP_FACETS);
      if (f3 != null)
        config.set(TIMESTAMP_FACETS,  BFacets.make(getTimestampFacets()));
      else
        config.add(TIMESTAMP_FACETS, BFacets.make(getTimestampFacets()));

	  setHistoryConfig(config);
	  
      // get local history database
      BHistoryDatabase localDb =
          ((BHistoryService) Sys.getService(BHistoryService.TYPE)).getDatabase();

      if (localDb == null)
      {
        System.out.println("Local history database not available.");
        return;
      }

      try(HistoryDatabaseConnection conn = localDb.getDbConnection(null))
      {
        if(conn.getHistory(config.getId()) == null)
          conn.createHistory(config);
      }
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }
  
  public void doAppendRecord() throws Exception
  {
    if (getActivePeriod().isActive(BAbsTime.make()) && getEnabled())
    {
      HistoryDatabaseConnection conn = null;

      try
      {
        BHistoryDatabase localDb =
            ((BHistoryService) Sys.getService(BHistoryService.TYPE)).getDatabase();

        if (localDb == null)
        {
          System.out.println("Local history database not available.");
          return;
        }

        BHistoryId id = BHistoryId.make(Sys.getStation().getStationName(), resolveHistoryName());

        conn = localDb.getDbConnection(null);

        /*
         * * I don't think that I need this check because I am checking this in the changed function
         */
        if (!conn.exists(id))
          createHistory();

        BIHistory history = conn.getHistory(id);
                
        //calculate the elapsed time
        BAbsTime current = BAbsTime.make();
        elapsedMillis = current.getMillis() - getStartTime().getMillis();
        if(elapsedMillis <0) elapsedMillis = 0;
        elapTime = BRelTime.make(elapsedMillis);
        
        BAbsTime lastTimestamp = conn.getLastTimestamp(history);
        if (Clock.time().isAfter(lastTimestamp))
        {
          BBypassTimeRecord rec = new BBypassTimeRecord(getStartTime(),current,elapTime);

          // Append the record to the history
          conn.append(history, rec);
          
          setTimestamp(getStartTime());
          setTimestampEnd(current);
          setElapsedTime(elapTime);
        }

      } // end try
      catch (Exception e)
      {
        System.out.println("Error creating the history...");
        e.printStackTrace();
      }
      finally
      {
        if(conn!=null) conn.close();
      }
    }
  }
  
  public String resolveHistoryName()
  {
    BFormat pattern = getHistoryName();

    // This is a tricky issue. It looks funny but it's correct.
    // The resolved pattern must be unescaped because it may include
    // slot names of ancestors (ex. "%parent.name%") which are already
    // escaped. Sometimes the result needs to be escaped because
    // it may just be static test (ex. "My History"). By unescaping
    // the result first, the escape will always return the right result.
    return SlotPath.escape(SlotPath.unescape(pattern.format(this)));
  }

  ////////////////////////////////////////////
  // local variables
  ////////////////////////////////////////////
  
  long elapsedMillis;
  BRelTime elapTime;

  private static final String ELAPSED_TIME_FACETS = "elapsedTimeFacets";
  private static final String TIMESTAMP_END_FACETS = "timestampEndFacets";
  private static final String TIMESTAMP_FACETS = "timestampFacets";

}
