package com.vykon.vykonPro.history;

import java.io.DataInput;
import java.io.DataOutput;
import java.io.IOException;

import javax.baja.history.BHistoryRecord;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BFacets;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

public class BBypassTimeRecord
    extends BHistoryRecord
{
  /*-
   class BBypassTimeRecord
   {
     properties
     {
       timestamp: BAbsTime
         flags { summary }
         default{[ BAbsTime.NULL ]}
         slotfacets{[ BFacets.make(BFacets.SHOW_SECONDS, BBoolean.TRUE) ]}
                
       timestampEnd: BAbsTime
        flags { summary }
        default {[ BAbsTime.NULL ]}
        slotfacets {[ BFacets.make(BFacets.SHOW_SECONDS, BBoolean.TRUE) ]}
         
       elapsedTime: BRelTime
         flags { summary }
         default{[ BRelTime.make(0) ]}
         slotfacets {[ BFacets.make(BFacets.SHOW_SECONDS, BBoolean.FALSE) ]}
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.history.BBypassTimeRecord(2302577663)1.0$ @*/
/* Generated Wed Aug 11 15:28:28 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "timestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timestamp</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#getTimestamp
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#setTimestamp
   */
  public static final Property timestamp = newProperty(Flags.SUMMARY, BAbsTime.NULL,BFacets.make(BFacets.SHOW_SECONDS, BBoolean.TRUE));
  
  /**
   * Get the <code>timestamp</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#timestamp
   */
  public BAbsTime getTimestamp() { return (BAbsTime)get(timestamp); }
  
  /**
   * Set the <code>timestamp</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#timestamp
   */
  public void setTimestamp(BAbsTime v) { set(timestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "timestampEnd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timestampEnd</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#getTimestampEnd
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#setTimestampEnd
   */
  public static final Property timestampEnd = newProperty(Flags.SUMMARY, BAbsTime.NULL,BFacets.make(BFacets.SHOW_SECONDS, BBoolean.TRUE));
  
  /**
   * Get the <code>timestampEnd</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#timestampEnd
   */
  public BAbsTime getTimestampEnd() { return (BAbsTime)get(timestampEnd); }
  
  /**
   * Set the <code>timestampEnd</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#timestampEnd
   */
  public void setTimestampEnd(BAbsTime v) { set(timestampEnd,v,null); }

////////////////////////////////////////////////////////////////
// Property "elapsedTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>elapsedTime</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#getElapsedTime
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#setElapsedTime
   */
  public static final Property elapsedTime = newProperty(Flags.SUMMARY, BRelTime.make(0),BFacets.make(BFacets.SHOW_SECONDS, BBoolean.FALSE));
  
  /**
   * Get the <code>elapsedTime</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#elapsedTime
   */
  public BRelTime getElapsedTime() { return (BRelTime)get(elapsedTime); }
  
  /**
   * Set the <code>elapsedTime</code> property.
   * @see com.vykon.vykonPro.history.BBypassTimeRecord#elapsedTime
   */
  public void setElapsedTime(BRelTime v) { set(elapsedTime,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BBypassTimeRecord.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  /*
   * default constructor
   */
  public BBypassTimeRecord()
  {
    setTimestamp(BAbsTime.NULL);
    setTimestampEnd(BAbsTime.NULL);
    setElapsedTime(BRelTime.make(0));
  }
  
  /*
   * argument constructor
   */
  public BBypassTimeRecord(BAbsTime timestamp, BAbsTime timestampEnd, BRelTime elapsed)
  {
    setTimestamp(timestamp);
    setTimestampEnd(timestampEnd);
    setElapsedTime(elapsed);
  }
  
  public Property getElapsedTimeProperty()
  {
    return elapsedTime;
  }
  
  public Property getTimestampProperty()
  {
    return timestamp;
  }
  
  public Property getTimestampEndProperty()
  {
    return timestampEnd;
  }
  
  protected void doRead(DataInput in) throws IOException
  {
    setTimestamp((BAbsTime)BAbsTime.DEFAULT.decode(in));
    setTimestampEnd((BAbsTime)BAbsTime.DEFAULT.decode(in));
    setElapsedTime((BRelTime)BRelTime.DEFAULT.decode(in));
  }

  protected void doWrite(DataOutput out) throws IOException
  {
    getTimestamp().encode(out);
    getTimestampEnd().encode(out);
    getElapsedTime().encode(out);
  }

  public boolean isFixedSize()
  {
    return false;
  }
  
  public String toString(Context cx)
  {
    StringBuffer s = new StringBuffer(32);
    s.append(getTimestamp().toString(cx));
    s.append(" ");
    s.append(getTimestampEnd().toString(cx));
    s.append(" ");
    s.append(getElapsedTime().toString(cx));
    
    return s.toString();
  }

}
