package com.vykon.vykonPro.history;

import java.io.IOException;

import javax.baja.collection.BITable;
import javax.baja.collection.Column;
import javax.baja.collection.ColumnList;
import javax.baja.collection.TableCursor;
import javax.baja.history.BHistoryConfig;
import javax.baja.history.BIHistory;
import javax.baja.history.BNumericTrendRecord;
import javax.baja.history.BTrendFlags;
import javax.baja.naming.BOrd;
import javax.baja.naming.SlotPath;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusNumeric;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDouble;
import javax.baja.sys.BFacets;
import javax.baja.sys.BINumeric;
import javax.baja.sys.BIcon;
import javax.baja.sys.BValue;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BFormat;
import javax.baja.util.BTimeRange;
import javax.baja.util.BTypeSpec;
import javax.baja.util.IFuture;
import javax.baja.util.Invocation;

import com.tridium.bql.util.BDynamicTimeRange;
import com.tridium.history.BNumeric64BitTrendRecord;
import com.vykon.vykonPro.util.BTimeOfDay;
import com.vykon.vykonPro.util.BVykonProService;

public class BNumericHistoryCalc
    extends BComponent
{
  /*-
   class BNumericHistoryCalc
   {
     properties
     {
       status: BStatus
           -- The status of the component
           flags { readonly, defaultOnClone }
           default {[ BStatus.ok ]}
           
      faultCause: String
           -- The fault cause.
           flags { readonly, defaultOnClone }
           default {[ "" ]}
      
       historyName: BFormat
        --String which when resolved should be the historyId which will be queried.
        --%componentSpace.rootComponent.stationName% will resolve the station name.
        flags{ operator }
        default {[ BFormat.make("%componentSpace.rootComponent.stationName%/%parent.name%") ]}
       
       history: BOrd
         -- The ord to the history containing the lighting amperage values
         flags{ readonly }
         default{[ BOrd.make("history:/") ]}
       
       deltaLogged: boolean
         -- If source history is delta logged set this property value to "true".
         flags{ operator, defaultOnClone }
         default{[ true ]}
       
       excludeInvalidValues: boolean
        --boolean property if true will exclude values from calculation if the status in the history
        --record returns false for the BStatus.isValid() check.  This means that the status includes
        --a bit for disabled, fault, down, stale or null.
        default{[ true ]}
        slotfacets{[BFacets.makeBoolean("exclude", "include")]}
         
      excludeHiddenValues: boolean
        --boolean property if true will exclude values from calculation if the trend flag for the
        --record has the hidden bit set.
        default{[ true ]}
        slotfacets{[BFacets.makeBoolean("exclude", "include")]}
        
       includeTimeOfDay: BTimeOfDay
         -- The times of day for the history time stamps to include when calculating the average
         flags{ operator }
         default{[ new BTimeOfDay() ]}
         
       timeRange: BDynamicTimeRange
         -- The period of time for the history to include when calculating the average
         flags{ operator }
         default{[ BDynamicTimeRange.DEFAULT ]}
         slotfacets{[ BFacets.make(BFacets.FIELD_EDITOR, "workbench:DynamicTimeRangeFE") ]}
       
       facets: BFacets
        -- These facets are applied against the out properties.
        default {[ BFacets.makeNumeric() ]}
       
       total: BStatusNumeric
         -- The total of the history values for the configured time
         flags{ readonly, summary, defaultOnClone }
         default{[ new BStatusNumeric() ]}
         
       average: BStatusNumeric
         -- The average of the history values for the configured time
         flags{ readonly, summary, defaultOnClone }
         default{[ new BStatusNumeric() ]}
         
       maximum: BStatusNumeric
         -- The maximum value used in the calculation
         flags{ readonly, defaultOnClone }
         default{[ new BStatusNumeric() ]}
         
       minimum: BStatusNumeric
         -- The minimum value used in the calculation
         flags{ readonly, defaultOnClone }
         default{[ new BStatusNumeric() ]}
         
       count: int
         -- The number of history records used in the calculation that met the filter criteria
         flags{ readonly, defaultOnClone }
         default{[ 0 ]}
       
       calculating: boolean
         -- Readonly boolean property that indicates if the component is actively calculating values
         flags{ readonly }
         default{[ false ]}
         
       lastUpdateTime: BAbsTime
         -- The last time that the calculate method updated the calculated values
         flags{ readonly, defaultOnClone }
         default{[ BAbsTime.NULL ]}
     }
     actions
     {
       calculate()
         flags{ async }
         
       reset()  
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.history.BNumericHistoryCalc(889441653)1.0$ @*/
/* Generated Sat Mar 19 18:02:12 EDT 2011 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>status</code> property.
   * The status of the component
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getStatus
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, BStatus.ok,null);
  
  /**
   * Get the <code>status</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the <code>status</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#status
   */
  public void setStatus(BStatus v) { set(status,v,null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>faultCause</code> property.
   * The fault cause.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getFaultCause
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, "",null);
  
  /**
   * Get the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#faultCause
   */
  public void setFaultCause(String v) { setString(faultCause,v,null); }

////////////////////////////////////////////////////////////////
// Property "historyName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>historyName</code> property.
   * String which when resolved should be the historyId
   * which will be queried. %componentSpace.rootComponent.stationName%
   * will resolve the station name.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getHistoryName
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setHistoryName
   */
  public static final Property historyName = newProperty(Flags.OPERATOR, BFormat.make("%componentSpace.rootComponent.stationName%/%parent.name%"),null);
  
  /**
   * Get the <code>historyName</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#historyName
   */
  public BFormat getHistoryName() { return (BFormat)get(historyName); }
  
  /**
   * Set the <code>historyName</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#historyName
   */
  public void setHistoryName(BFormat v) { set(historyName,v,null); }

////////////////////////////////////////////////////////////////
// Property "history"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>history</code> property.
   * The ord to the history containing the lighting amperage
   * values
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getHistory
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setHistory
   */
  public static final Property history = newProperty(Flags.READONLY, BOrd.make("history:/"),null);
  
  /**
   * Get the <code>history</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#history
   */
  public BOrd getHistory() { return (BOrd)get(history); }
  
  /**
   * Set the <code>history</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#history
   */
  public void setHistory(BOrd v) { set(history,v,null); }

////////////////////////////////////////////////////////////////
// Property "deltaLogged"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>deltaLogged</code> property.
   * If source history is delta logged set this property
   * value to "true".
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getDeltaLogged
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setDeltaLogged
   */
  public static final Property deltaLogged = newProperty(Flags.OPERATOR|Flags.DEFAULT_ON_CLONE, true,null);
  
  /**
   * Get the <code>deltaLogged</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#deltaLogged
   */
  public boolean getDeltaLogged() { return getBoolean(deltaLogged); }
  
  /**
   * Set the <code>deltaLogged</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#deltaLogged
   */
  public void setDeltaLogged(boolean v) { setBoolean(deltaLogged,v,null); }

////////////////////////////////////////////////////////////////
// Property "excludeInvalidValues"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>excludeInvalidValues</code> property.
   * boolean property if true will exclude values from calculation if the status in the history record returns false for the BStatus.isValid() check.  This means that the status includes a bit for disabled, fault, down, stale or null.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getExcludeInvalidValues
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setExcludeInvalidValues
   */
  public static final Property excludeInvalidValues = newProperty(0, true,BFacets.makeBoolean("exclude", "include"));
  
  /**
   * Get the <code>excludeInvalidValues</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#excludeInvalidValues
   */
  public boolean getExcludeInvalidValues() { return getBoolean(excludeInvalidValues); }
  
  /**
   * Set the <code>excludeInvalidValues</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#excludeInvalidValues
   */
  public void setExcludeInvalidValues(boolean v) { setBoolean(excludeInvalidValues,v,null); }

////////////////////////////////////////////////////////////////
// Property "excludeHiddenValues"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>excludeHiddenValues</code> property.
   * boolean property if true will exclude values from calculation if the trend flag for the record has the hidden bit set.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getExcludeHiddenValues
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setExcludeHiddenValues
   */
  public static final Property excludeHiddenValues = newProperty(0, true,BFacets.makeBoolean("exclude", "include"));
  
  /**
   * Get the <code>excludeHiddenValues</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#excludeHiddenValues
   */
  public boolean getExcludeHiddenValues() { return getBoolean(excludeHiddenValues); }
  
  /**
   * Set the <code>excludeHiddenValues</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#excludeHiddenValues
   */
  public void setExcludeHiddenValues(boolean v) { setBoolean(excludeHiddenValues,v,null); }

////////////////////////////////////////////////////////////////
// Property "includeTimeOfDay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>includeTimeOfDay</code> property.
   * The times of day for the history time stamps to include
   * when calculating the average
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getIncludeTimeOfDay
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setIncludeTimeOfDay
   */
  public static final Property includeTimeOfDay = newProperty(Flags.OPERATOR, new BTimeOfDay(),null);
  
  /**
   * Get the <code>includeTimeOfDay</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#includeTimeOfDay
   */
  public BTimeOfDay getIncludeTimeOfDay() { return (BTimeOfDay)get(includeTimeOfDay); }
  
  /**
   * Set the <code>includeTimeOfDay</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#includeTimeOfDay
   */
  public void setIncludeTimeOfDay(BTimeOfDay v) { set(includeTimeOfDay,v,null); }

////////////////////////////////////////////////////////////////
// Property "timeRange"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeRange</code> property.
   * The period of time for the history to include when
   * calculating the average
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getTimeRange
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setTimeRange
   */
  public static final Property timeRange = newProperty(Flags.OPERATOR, BDynamicTimeRange.DEFAULT,BFacets.make(BFacets.FIELD_EDITOR, "workbench:DynamicTimeRangeFE"));
  
  /**
   * Get the <code>timeRange</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#timeRange
   */
  public BDynamicTimeRange getTimeRange() { return (BDynamicTimeRange)get(timeRange); }
  
  /**
   * Set the <code>timeRange</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#timeRange
   */
  public void setTimeRange(BDynamicTimeRange v) { set(timeRange,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * These facets are applied against the out properties.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getFacets
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.makeNumeric(),null);
  
  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "total"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>total</code> property.
   * The total of the history values for the configured
   * time
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getTotal
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setTotal
   */
  public static final Property total = newProperty(Flags.READONLY|Flags.SUMMARY|Flags.DEFAULT_ON_CLONE, new BStatusNumeric(),null);
  
  /**
   * Get the <code>total</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#total
   */
  public BStatusNumeric getTotal() { return (BStatusNumeric)get(total); }
  
  /**
   * Set the <code>total</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#total
   */
  public void setTotal(BStatusNumeric v) { set(total,v,null); }

////////////////////////////////////////////////////////////////
// Property "average"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>average</code> property.
   * The average of the history values for the configured
   * time
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getAverage
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setAverage
   */
  public static final Property average = newProperty(Flags.READONLY|Flags.SUMMARY|Flags.DEFAULT_ON_CLONE, new BStatusNumeric(),null);
  
  /**
   * Get the <code>average</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#average
   */
  public BStatusNumeric getAverage() { return (BStatusNumeric)get(average); }
  
  /**
   * Set the <code>average</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#average
   */
  public void setAverage(BStatusNumeric v) { set(average,v,null); }

////////////////////////////////////////////////////////////////
// Property "maximum"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>maximum</code> property.
   * The maximum value used in the calculation
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getMaximum
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setMaximum
   */
  public static final Property maximum = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, new BStatusNumeric(),null);
  
  /**
   * Get the <code>maximum</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#maximum
   */
  public BStatusNumeric getMaximum() { return (BStatusNumeric)get(maximum); }
  
  /**
   * Set the <code>maximum</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#maximum
   */
  public void setMaximum(BStatusNumeric v) { set(maximum,v,null); }

////////////////////////////////////////////////////////////////
// Property "minimum"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>minimum</code> property.
   * The minimum value used in the calculation
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getMinimum
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setMinimum
   */
  public static final Property minimum = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, new BStatusNumeric(),null);
  
  /**
   * Get the <code>minimum</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#minimum
   */
  public BStatusNumeric getMinimum() { return (BStatusNumeric)get(minimum); }
  
  /**
   * Set the <code>minimum</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#minimum
   */
  public void setMinimum(BStatusNumeric v) { set(minimum,v,null); }

////////////////////////////////////////////////////////////////
// Property "count"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>count</code> property.
   * The number of history records used in the calculation
   * that met the filter criteria
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getCount
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setCount
   */
  public static final Property count = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, 0,null);
  
  /**
   * Get the <code>count</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#count
   */
  public int getCount() { return getInt(count); }
  
  /**
   * Set the <code>count</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#count
   */
  public void setCount(int v) { setInt(count,v,null); }

////////////////////////////////////////////////////////////////
// Property "calculating"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculating</code> property.
   * Readonly boolean property that indicates if the component
   * is actively calculating values
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getCalculating
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setCalculating
   */
  public static final Property calculating = newProperty(Flags.READONLY, false,null);
  
  /**
   * Get the <code>calculating</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#calculating
   */
  public boolean getCalculating() { return getBoolean(calculating); }
  
  /**
   * Set the <code>calculating</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#calculating
   */
  public void setCalculating(boolean v) { setBoolean(calculating,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastUpdateTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastUpdateTime</code> property.
   * The last time that the calculate method updated the
   * calculated values
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#getLastUpdateTime
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#setLastUpdateTime
   */
  public static final Property lastUpdateTime = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, BAbsTime.NULL,null);
  
  /**
   * Get the <code>lastUpdateTime</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#lastUpdateTime
   */
  public BAbsTime getLastUpdateTime() { return (BAbsTime)get(lastUpdateTime); }
  
  /**
   * Set the <code>lastUpdateTime</code> property.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#lastUpdateTime
   */
  public void setLastUpdateTime(BAbsTime v) { set(lastUpdateTime,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#calculate()
   */
  public static final Action calculate = newAction(Flags.ASYNC,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Action "reset"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>reset</code> action.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#reset()
   */
  public static final Action reset = newAction(0,null);
  
  /**
   * Invoke the <code>reset</code> action.
   * @see com.vykon.vykonPro.history.BNumericHistoryCalc#reset
   */
  public void reset() { invoke(reset,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BNumericHistoryCalc.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    checkForService();
  }
  
  private final void checkForService()
  {
    if(BVykonProService.getInstance()==null)
    {
      setStatus(BStatus.fault);
      setFaultCause("This component requires the VykonPro service in the station");
    }
    else if(BVykonProService.getInstance().isDisabled())
    {
      setStatus(BStatus.fault);
      setFaultCause("The vykonPro service is disabled");
    }
    else
    {
      setStatus(BStatus.ok);
      setFaultCause("");
    }
  }
  
  public void changed(Property property, Context context) 
  {
    super.changed(property, context);
    if( !Sys.atSteadyState() || !isRunning() )
     return;
  
    if(property.equals(historyName) || property.equals(timeRange))
    {
      reset();
      calculate();
    }
  }
  
  public IFuture post(Action action, BValue arg, Context cx)
  {
    if (action == calculate)
    {
      return BVykonProService.getInstance().getWorker().post(new Invocation(this, action, arg, cx));
    }
    else
    {
      return super.post(action, arg, cx);
    }
  }
  
  public BFacets getSlotFacets(Slot slot)
  {
    if(slot.equals(maximum) || slot.equals(minimum) || slot.equals(average) || slot.equals(total))
      return getFacets();
    return super.getSlotFacets(slot);

  }
  
  public void doCalculate()
  {
    if (!isRunning()) return;
    
    try
    {
      BOrd hord = BOrd.make("history:/" + resolveHistoryName());
      setHistory(hord);
      BIHistory history = (BIHistory)hord.resolve(this).get();
      BHistoryConfig config = history.getConfig();
      if( !(config.getRecordType().equals(BTypeSpec.make(BNumericTrendRecord.TYPE))) && !(config.getRecordType().equals(BTypeSpec.make(BNumeric64BitTrendRecord.TYPE))))
      {
        setStatus(BStatus.fault);
        setFaultCause("Must specify a valid numeric type history.");
        reset();
        return;
      }
      
      if(getDeltaLogged()) deltaSyntax = ";delta=false;";
      else deltaSyntax = ";delta=true;";
      
      timeQuery = getTimeRange().toOrdParams();
      
      //get the history from the history property
      BOrd qord = BOrd.make(hord + "?" + timeQuery + deltaSyntax + "|bql:select timestamp, trendFlags, status, value");
      BITable result = (BITable)qord.resolve(this).get();
      
      setCalculating(true);
      
      ColumnList columns = result.getColumns();
      Column valueColumn = columns.get(3);
      Column statusColumn = columns.get(2);
      Column trendColumn = columns.get(1);
      Column tsColumn = columns.get(0);
      
      boolean excInvalid = getExcludeInvalidValues();
      boolean excHidden = getExcludeHiddenValues();
      
      BAbsTime ts = BAbsTime.NULL;
      BStatus status = BStatus.nullStatus;
      BTrendFlags flags = null;

      BTimeRange tr = getIncludeTimeOfDay().getTimeRange();
      
      double min = Double.POSITIVE_INFINITY;
      double max = Double.NEGATIVE_INFINITY;
      double total = 0;
      int cnt = 0;
      double value = 0;
      
      /*
      if(result.size()==1 & getDeltaLogged()==false)
      {
        //only 1 record so while loop won't pick it up
        c.next();
        value = (((BINumeric)c.get(valueColumn)).getNumeric());
        status = (((BStatus)c.get(statusColumn)).getStatus());
        flags = ((BTrendFlags)c.get(trendColumn));
        
        if( (excInvalid & !status.isValid()) || (excHidden & flags.getBit("hidden")) || BDouble.make(value)==BDouble.NaN)
        {
          //don't include
        }
        else
        {
          cnt++;
          min = value;
          max = value;
          total += value;
        }
      }
      */

      try(TableCursor c = result.cursor())
      {
        while (c.next())
        {
          ts = (BAbsTime) (c.cell(tsColumn));
          value = ((BINumeric) c.cell(valueColumn)).getNumeric();
          status = (((BStatus) c.cell(statusColumn)).getStatus());
          flags = ((BTrendFlags) c.cell(trendColumn));

          if (excInvalid & !status.isValid())
            continue;
          if (excHidden & flags.getBit("hidden"))
            continue;
          if (BDouble.make(value)==BDouble.NaN)
            continue;
          if (!tr.includes(ts))
            continue;

          if (value < min)
            min = value;
          if (value > max)
            max = value;
          total = total + value;
          cnt++;
        }
      }


      if (cnt > 0)
      {
        //store all of the values
        getMinimum().setValue(min);
        getMaximum().setValue(max);
        getTotal().setValue(total);
        getAverage().setValue(total / cnt);
        setCount(cnt);

        setCalculating(false);
        setLastUpdateTime(Clock.time());

        setStatus(BStatus.ok);
        setFaultCause("");
      }
      else
      {
        reset();
        setCalculating(false);
        setStatus(BStatus.fault);
        setFaultCause("No records found for " + getHistory() + " for the configured timeOfDay");
      }
    }
    catch(Exception e)
    {
      reset();
      System.out.println(this.getSlotPath() + " - " + e);
      setCalculating(false);
      setStatus(BStatus.fault);
      setFaultCause("Failed to calcualte values. " + e.getMessage()) ;
    }
  }
  
  public void doReset()
  {
    getMinimum().setValue(Double.POSITIVE_INFINITY);
    getMaximum().setValue(Double.NEGATIVE_INFINITY);
    getTotal().setValue(Double.NaN);
    getAverage().setValue(Double.NaN);
    setCount(0);
  }
  
  private String resolveHistoryName()
  {
    BFormat pattern = getHistoryName();
    BFormat station;
    BFormat history;
    try
    {
      String p = pattern.encodeToString();
      if(p.indexOf("/")>-1)
      {
        int firstSlash = p.indexOf("/");
        station = BFormat.make(p.substring(0, firstSlash));
        history = BFormat.make(p.substring(firstSlash+1));
        
        String s = SlotPath.escape(SlotPath.unescape(station.format(this)));
        String h = SlotPath.escape(SlotPath.unescape(history.format(this)));
        
        return s + "/" + h;
      }
      else
      {
        return p;
      }
    }
    catch (IOException e)
    {
      e.printStackTrace();
      return "couldn't resolve the historyName";
    }
  }
 
  ////////////////////////////////////////////////////////////////
  // Icon
  ////////////////////////////////////////////////////////////////
  
  /**
   * Get the icon.
   */
  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("historyDatabase.png");
  
  
  //////////////////////////////////////////
  // local variables
  /////////////////////////////////////////
  
  String deltaSyntax;
  String timeQuery;

}
