package com.vykon.vykonPro.history;

import java.io.IOException;

import javax.baja.history.BNumericTrendRecord;
import javax.baja.history.BRolloverValue;
import javax.baja.history.ext.BNumericIntervalHistoryExt;
import javax.baja.status.BStatusNumeric;
import javax.baja.status.BStatusValue;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.tridium.history.BNumeric64BitTrendRecord;

public class BNumericIntervalDeltaHistoryExt
    extends BNumericIntervalHistoryExt
{
  /*-
   class BNumericIntervalDeltaHistoryExt
   {
     properties
     {
       deltaLogging: boolean
         -- If true the history extension will log the change in value since of the parent
         -- numeric points's out property instead of the current value.
         default{[ false ]}
         flags{ operator }
       
       useRollover: boolean
         -- If true, when the currentValue is less than the lastValue the delta is 
         -- calculated using the maxRolloverValue from the history extension.
         -- delta = (maxRolloverValue - lastValue) + currentValue
         -- otherwise the delta value is calculated as the difference between 
         -- the currentValue and lastValue, which could potentially be a negative value.
         -- delta = currentValue - lastValue
         default{[ true ]}
         flags{ operator }
       
       initialized: boolean
         -- If false initializes lastCurrent from parent control point's out property
         default{[ false ]}
         flags{ readonly, hidden, defaultOnClone }
         
       lastCurrent: double
         -- The value of the parent numeric point's out property the last time a record
         -- was written.
         default{[ 0 ]}
         flags{ readonly, hidden, defaultOnClone }
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt(4271269710)1.0$ @*/
/* Generated Thu Mar 08 16:11:13 EST 2012 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "deltaLogging"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>deltaLogging</code> property.
   * If true the history extension will log the change in value since of the parent numeric points's out property instead of the current value.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#getDeltaLogging
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#setDeltaLogging
   */
  public static final Property deltaLogging = newProperty(Flags.OPERATOR, false,null);
  
  /**
   * Get the <code>deltaLogging</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#deltaLogging
   */
  public boolean getDeltaLogging() { return getBoolean(deltaLogging); }
  
  /**
   * Set the <code>deltaLogging</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#deltaLogging
   */
  public void setDeltaLogging(boolean v) { setBoolean(deltaLogging,v,null); }

////////////////////////////////////////////////////////////////
// Property "useRollover"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>useRollover</code> property.
   * If true, when the currentValue is less than the lastValue
   * the delta is calculated using the maxRolloverValue
   * from the history extension. delta = (maxRolloverValue
   * - lastValue) + currentValue otherwise the delta value
   * is calculated as the difference between the currentValue
   * and lastValue, which could potentially be a negative
   * value. delta = currentValue - lastValue
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#getUseRollover
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#setUseRollover
   */
  public static final Property useRollover = newProperty(Flags.OPERATOR, true,null);
  
  /**
   * Get the <code>useRollover</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#useRollover
   */
  public boolean getUseRollover() { return getBoolean(useRollover); }
  
  /**
   * Set the <code>useRollover</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#useRollover
   */
  public void setUseRollover(boolean v) { setBoolean(useRollover,v,null); }

////////////////////////////////////////////////////////////////
// Property "initialized"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>initialized</code> property.
   * If false initializes lastCurrent from parent control
   * point's out property
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#getInitialized
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#setInitialized
   */
  public static final Property initialized = newProperty(Flags.READONLY|Flags.HIDDEN|Flags.DEFAULT_ON_CLONE, false,null);
  
  /**
   * Get the <code>initialized</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#initialized
   */
  public boolean getInitialized() { return getBoolean(initialized); }
  
  /**
   * Set the <code>initialized</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#initialized
   */
  public void setInitialized(boolean v) { setBoolean(initialized,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastCurrent"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastCurrent</code> property.
   * The value of the parent numeric point's out property
   * the last time a record was written.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#getLastCurrent
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#setLastCurrent
   */
  public static final Property lastCurrent = newProperty(Flags.READONLY|Flags.HIDDEN|Flags.DEFAULT_ON_CLONE, 0,null);
  
  /**
   * Get the <code>lastCurrent</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#lastCurrent
   */
  public double getLastCurrent() { return getDouble(lastCurrent); }
  
  /**
   * Set the <code>lastCurrent</code> property.
   * @see com.vykon.vykonPro.history.BNumericIntervalDeltaHistoryExt#lastCurrent
   */
  public void setLastCurrent(double v) { setDouble(lastCurrent,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BNumericIntervalDeltaHistoryExt.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started() throws Exception
  {
    super.started();
    if (getPrecision() == 64)
      rec = new BNumeric64BitTrendRecord();
    else
      rec = new BNumericTrendRecord();
    //syncProperties();
    
    if(!getInitialized())
    {
      double current = ((BStatusNumeric)getParentPoint().getStatusValue()).getValue();
      if(!Double.isInfinite(current) && !Double.isNaN(current))
      {
        setLastCurrent(((BStatusNumeric)getParentPoint().getStatusValue()).getValue());
        setInitialized(true);
      }
    }
  }

  /**
   * Write a record for the specified timestamp and value.
   */
  protected void writeRecord(BAbsTime timestamp, BStatusValue out)
    throws IOException
  {
    double current = ((BStatusNumeric)out).getValue();
    
    if(getDeltaLogging())
    {
      if(!Double.isInfinite(current) && !Double.isNaN(current))
      {
        double delta = current - getLastCurrent();
        
        if(getUseRollover())
        {
          BRolloverValue maxrv = getMaxRolloverValue();
          BRolloverValue minrv = getMinRolloverValue();
          
          if(!maxrv.getUnspecified())
          {
            double minValue = 0d;
            if(!minrv.getUnspecified()) minValue = minrv.getValue();
            
            if(current < getLastCurrent())
            {
              delta = (maxrv.getValue()-getLastCurrent()) + (current - minValue) + 1;
            }
          }
        }
        
        setLastCurrent(current);
        append(rec.set(timestamp, delta, ((BStatusNumeric)out).getStatus()));
      }
    }
    else
    {
      if(!Double.isInfinite(current) && !Double.isNaN(current)) setLastCurrent(current);
      append(rec.set(timestamp, ((BStatusNumeric)out).getValue(), ((BStatusNumeric)out).getStatus()));
    }
      
  }
  
////////////////////////////////////////////////////////////////
//Attributes
////////////////////////////////////////////////////////////////

 private BNumericTrendRecord rec;

}
