package com.vykon.vykonPro.history;

import javax.baja.status.BStatusNumeric;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BMonth;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.vykon.vykonPro.enums.BDateModeEnum;


/**
 * BPeakTracker records the peak value and timestamp of the connected input value
 * for each month of the year.  
 *
 *
 * @author    
 * @creation  9 Nov 00
 * @version   $Revision: 29$ $Date: 3/28/2005 12:40:33 PM$
 * @since     Baja 1.0
 */

public class BPeakTracker
    extends BComponent
{
  /*-
   class BPeakTracker
   {
     properties
     {
       enabled: boolean
         -- Property which controls whether the component functions.
         default {[ true ]}
         slotfacets{[BFacets.makeBoolean("enabled", "disabled")]}
         
       facets: BFacets
        -- These facets are applied against the out property.
        default {[ BFacets.makeNumeric() ]}
      
       dateMode: BEnum
         -- The mode determines how the peak value is tracked.
         flags{ operator }
         default{[ ( BDynamicEnum.make(0, BEnumRange.make(BDateModeEnum.TYPE))) ]}
         
       billingCycleStartDay: int
         -- The day of the month which the billing cycle starts.
         flags{ operator }
         default{[ 1 ]}
         slotfacets{[ BFacets.makeInt(null, 1, 28) ]}
         
       in: BStatusNumeric
       flags {summary, transient}
       default {[ new BStatusNumeric() ]}
       
       lastReset: BAbsTime
       flags { summary, readonly }
       default {[ BAbsTime.NULL ]}
       
       januaryPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       januaryTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       februaryPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       februaryTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       marchPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       marchTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       aprilPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       aprilTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       mayPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       mayTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       junePeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       juneTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       julyPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       julyTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       augustPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       augustTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       septemberPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       septemberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       octoberPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       octoberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       novemberPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       novemberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
       
       decemberPeak: BStatusNumeric
       flags {summary, readonly }
       default {[ new BStatusNumeric() ]}
       
       decemberTimestamp: BAbsTime
       flags { readonly }
       default {[ BAbsTime.NULL ]}
     }
     actions
     {
       calculate()
         flags{hidden}
       
       ticketExpired()
         flags{hidden}
         
       resetPeaks()
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.history.BPeakTracker(2423676140)1.0$ @*/
/* Generated Sat Oct 02 22:06:18 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>enabled</code> property.
   * Property which controls whether the component functions.
   * @see com.vykon.vykonPro.history.BPeakTracker#getEnabled
   * @see com.vykon.vykonPro.history.BPeakTracker#setEnabled
   */
  public static final Property enabled = newProperty(0, true,BFacets.makeBoolean("enabled", "disabled"));
  
  /**
   * Get the <code>enabled</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#enabled
   */
  public boolean getEnabled() { return getBoolean(enabled); }
  
  /**
   * Set the <code>enabled</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#enabled
   */
  public void setEnabled(boolean v) { setBoolean(enabled,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getFacets
   * @see com.vykon.vykonPro.history.BPeakTracker#setFacets
   */
  public static final Property facets = newProperty(0, BFacets.makeNumeric(),null);
  
  /**
   * Get the <code>facets</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "dateMode"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>dateMode</code> property.
   * The mode determines how the peak value is tracked.
   * @see com.vykon.vykonPro.history.BPeakTracker#getDateMode
   * @see com.vykon.vykonPro.history.BPeakTracker#setDateMode
   */
  public static final Property dateMode = newProperty(Flags.OPERATOR, ( BDynamicEnum.make(0, BEnumRange.make(BDateModeEnum.TYPE))),null);
  
  /**
   * Get the <code>dateMode</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#dateMode
   */
  public BEnum getDateMode() { return (BEnum)get(dateMode); }
  
  /**
   * Set the <code>dateMode</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#dateMode
   */
  public void setDateMode(BEnum v) { set(dateMode,v,null); }

////////////////////////////////////////////////////////////////
// Property "billingCycleStartDay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>billingCycleStartDay</code> property.
   * The day of the month which the billing cycle starts.
   * @see com.vykon.vykonPro.history.BPeakTracker#getBillingCycleStartDay
   * @see com.vykon.vykonPro.history.BPeakTracker#setBillingCycleStartDay
   */
  public static final Property billingCycleStartDay = newProperty(Flags.OPERATOR, 1,BFacets.makeInt(null, 1, 28));
  
  /**
   * Get the <code>billingCycleStartDay</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#billingCycleStartDay
   */
  public int getBillingCycleStartDay() { return getInt(billingCycleStartDay); }
  
  /**
   * Set the <code>billingCycleStartDay</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#billingCycleStartDay
   */
  public void setBillingCycleStartDay(int v) { setInt(billingCycleStartDay,v,null); }

////////////////////////////////////////////////////////////////
// Property "in"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>in</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getIn
   * @see com.vykon.vykonPro.history.BPeakTracker#setIn
   */
  public static final Property in = newProperty(Flags.SUMMARY|Flags.TRANSIENT, new BStatusNumeric(),null);
  
  /**
   * Get the <code>in</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#in
   */
  public BStatusNumeric getIn() { return (BStatusNumeric)get(in); }
  
  /**
   * Set the <code>in</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#in
   */
  public void setIn(BStatusNumeric v) { set(in,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastReset"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastReset</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getLastReset
   * @see com.vykon.vykonPro.history.BPeakTracker#setLastReset
   */
  public static final Property lastReset = newProperty(Flags.SUMMARY|Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>lastReset</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#lastReset
   */
  public BAbsTime getLastReset() { return (BAbsTime)get(lastReset); }
  
  /**
   * Set the <code>lastReset</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#lastReset
   */
  public void setLastReset(BAbsTime v) { set(lastReset,v,null); }

////////////////////////////////////////////////////////////////
// Property "januaryPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>januaryPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getJanuaryPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setJanuaryPeak
   */
  public static final Property januaryPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>januaryPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#januaryPeak
   */
  public BStatusNumeric getJanuaryPeak() { return (BStatusNumeric)get(januaryPeak); }
  
  /**
   * Set the <code>januaryPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#januaryPeak
   */
  public void setJanuaryPeak(BStatusNumeric v) { set(januaryPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "januaryTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>januaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getJanuaryTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setJanuaryTimestamp
   */
  public static final Property januaryTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>januaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#januaryTimestamp
   */
  public BAbsTime getJanuaryTimestamp() { return (BAbsTime)get(januaryTimestamp); }
  
  /**
   * Set the <code>januaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#januaryTimestamp
   */
  public void setJanuaryTimestamp(BAbsTime v) { set(januaryTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "februaryPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>februaryPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getFebruaryPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setFebruaryPeak
   */
  public static final Property februaryPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>februaryPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#februaryPeak
   */
  public BStatusNumeric getFebruaryPeak() { return (BStatusNumeric)get(februaryPeak); }
  
  /**
   * Set the <code>februaryPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#februaryPeak
   */
  public void setFebruaryPeak(BStatusNumeric v) { set(februaryPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "februaryTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>februaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getFebruaryTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setFebruaryTimestamp
   */
  public static final Property februaryTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>februaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#februaryTimestamp
   */
  public BAbsTime getFebruaryTimestamp() { return (BAbsTime)get(februaryTimestamp); }
  
  /**
   * Set the <code>februaryTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#februaryTimestamp
   */
  public void setFebruaryTimestamp(BAbsTime v) { set(februaryTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "marchPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>marchPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getMarchPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setMarchPeak
   */
  public static final Property marchPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>marchPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#marchPeak
   */
  public BStatusNumeric getMarchPeak() { return (BStatusNumeric)get(marchPeak); }
  
  /**
   * Set the <code>marchPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#marchPeak
   */
  public void setMarchPeak(BStatusNumeric v) { set(marchPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "marchTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>marchTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getMarchTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setMarchTimestamp
   */
  public static final Property marchTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>marchTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#marchTimestamp
   */
  public BAbsTime getMarchTimestamp() { return (BAbsTime)get(marchTimestamp); }
  
  /**
   * Set the <code>marchTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#marchTimestamp
   */
  public void setMarchTimestamp(BAbsTime v) { set(marchTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "aprilPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>aprilPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getAprilPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setAprilPeak
   */
  public static final Property aprilPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>aprilPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#aprilPeak
   */
  public BStatusNumeric getAprilPeak() { return (BStatusNumeric)get(aprilPeak); }
  
  /**
   * Set the <code>aprilPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#aprilPeak
   */
  public void setAprilPeak(BStatusNumeric v) { set(aprilPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "aprilTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>aprilTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getAprilTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setAprilTimestamp
   */
  public static final Property aprilTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>aprilTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#aprilTimestamp
   */
  public BAbsTime getAprilTimestamp() { return (BAbsTime)get(aprilTimestamp); }
  
  /**
   * Set the <code>aprilTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#aprilTimestamp
   */
  public void setAprilTimestamp(BAbsTime v) { set(aprilTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "mayPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>mayPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getMayPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setMayPeak
   */
  public static final Property mayPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>mayPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#mayPeak
   */
  public BStatusNumeric getMayPeak() { return (BStatusNumeric)get(mayPeak); }
  
  /**
   * Set the <code>mayPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#mayPeak
   */
  public void setMayPeak(BStatusNumeric v) { set(mayPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "mayTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>mayTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getMayTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setMayTimestamp
   */
  public static final Property mayTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>mayTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#mayTimestamp
   */
  public BAbsTime getMayTimestamp() { return (BAbsTime)get(mayTimestamp); }
  
  /**
   * Set the <code>mayTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#mayTimestamp
   */
  public void setMayTimestamp(BAbsTime v) { set(mayTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "junePeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>junePeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getJunePeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setJunePeak
   */
  public static final Property junePeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>junePeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#junePeak
   */
  public BStatusNumeric getJunePeak() { return (BStatusNumeric)get(junePeak); }
  
  /**
   * Set the <code>junePeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#junePeak
   */
  public void setJunePeak(BStatusNumeric v) { set(junePeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "juneTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>juneTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getJuneTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setJuneTimestamp
   */
  public static final Property juneTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>juneTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#juneTimestamp
   */
  public BAbsTime getJuneTimestamp() { return (BAbsTime)get(juneTimestamp); }
  
  /**
   * Set the <code>juneTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#juneTimestamp
   */
  public void setJuneTimestamp(BAbsTime v) { set(juneTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "julyPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>julyPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getJulyPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setJulyPeak
   */
  public static final Property julyPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>julyPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#julyPeak
   */
  public BStatusNumeric getJulyPeak() { return (BStatusNumeric)get(julyPeak); }
  
  /**
   * Set the <code>julyPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#julyPeak
   */
  public void setJulyPeak(BStatusNumeric v) { set(julyPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "julyTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>julyTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getJulyTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setJulyTimestamp
   */
  public static final Property julyTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>julyTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#julyTimestamp
   */
  public BAbsTime getJulyTimestamp() { return (BAbsTime)get(julyTimestamp); }
  
  /**
   * Set the <code>julyTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#julyTimestamp
   */
  public void setJulyTimestamp(BAbsTime v) { set(julyTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "augustPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>augustPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getAugustPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setAugustPeak
   */
  public static final Property augustPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>augustPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#augustPeak
   */
  public BStatusNumeric getAugustPeak() { return (BStatusNumeric)get(augustPeak); }
  
  /**
   * Set the <code>augustPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#augustPeak
   */
  public void setAugustPeak(BStatusNumeric v) { set(augustPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "augustTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>augustTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getAugustTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setAugustTimestamp
   */
  public static final Property augustTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>augustTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#augustTimestamp
   */
  public BAbsTime getAugustTimestamp() { return (BAbsTime)get(augustTimestamp); }
  
  /**
   * Set the <code>augustTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#augustTimestamp
   */
  public void setAugustTimestamp(BAbsTime v) { set(augustTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "septemberPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>septemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getSeptemberPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setSeptemberPeak
   */
  public static final Property septemberPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>septemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#septemberPeak
   */
  public BStatusNumeric getSeptemberPeak() { return (BStatusNumeric)get(septemberPeak); }
  
  /**
   * Set the <code>septemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#septemberPeak
   */
  public void setSeptemberPeak(BStatusNumeric v) { set(septemberPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "septemberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>septemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getSeptemberTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setSeptemberTimestamp
   */
  public static final Property septemberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>septemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#septemberTimestamp
   */
  public BAbsTime getSeptemberTimestamp() { return (BAbsTime)get(septemberTimestamp); }
  
  /**
   * Set the <code>septemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#septemberTimestamp
   */
  public void setSeptemberTimestamp(BAbsTime v) { set(septemberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "octoberPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>octoberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getOctoberPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setOctoberPeak
   */
  public static final Property octoberPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>octoberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#octoberPeak
   */
  public BStatusNumeric getOctoberPeak() { return (BStatusNumeric)get(octoberPeak); }
  
  /**
   * Set the <code>octoberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#octoberPeak
   */
  public void setOctoberPeak(BStatusNumeric v) { set(octoberPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "octoberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>octoberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getOctoberTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setOctoberTimestamp
   */
  public static final Property octoberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>octoberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#octoberTimestamp
   */
  public BAbsTime getOctoberTimestamp() { return (BAbsTime)get(octoberTimestamp); }
  
  /**
   * Set the <code>octoberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#octoberTimestamp
   */
  public void setOctoberTimestamp(BAbsTime v) { set(octoberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "novemberPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>novemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getNovemberPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setNovemberPeak
   */
  public static final Property novemberPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>novemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#novemberPeak
   */
  public BStatusNumeric getNovemberPeak() { return (BStatusNumeric)get(novemberPeak); }
  
  /**
   * Set the <code>novemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#novemberPeak
   */
  public void setNovemberPeak(BStatusNumeric v) { set(novemberPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "novemberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>novemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getNovemberTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setNovemberTimestamp
   */
  public static final Property novemberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>novemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#novemberTimestamp
   */
  public BAbsTime getNovemberTimestamp() { return (BAbsTime)get(novemberTimestamp); }
  
  /**
   * Set the <code>novemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#novemberTimestamp
   */
  public void setNovemberTimestamp(BAbsTime v) { set(novemberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "decemberPeak"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>decemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getDecemberPeak
   * @see com.vykon.vykonPro.history.BPeakTracker#setDecemberPeak
   */
  public static final Property decemberPeak = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>decemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#decemberPeak
   */
  public BStatusNumeric getDecemberPeak() { return (BStatusNumeric)get(decemberPeak); }
  
  /**
   * Set the <code>decemberPeak</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#decemberPeak
   */
  public void setDecemberPeak(BStatusNumeric v) { set(decemberPeak,v,null); }

////////////////////////////////////////////////////////////////
// Property "decemberTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>decemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#getDecemberTimestamp
   * @see com.vykon.vykonPro.history.BPeakTracker#setDecemberTimestamp
   */
  public static final Property decemberTimestamp = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>decemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#decemberTimestamp
   */
  public BAbsTime getDecemberTimestamp() { return (BAbsTime)get(decemberTimestamp); }
  
  /**
   * Set the <code>decemberTimestamp</code> property.
   * @see com.vykon.vykonPro.history.BPeakTracker#decemberTimestamp
   */
  public void setDecemberTimestamp(BAbsTime v) { set(decemberTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>calculate</code> action.
   * @see com.vykon.vykonPro.history.BPeakTracker#calculate()
   */
  public static final Action calculate = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>calculate</code> action.
   * @see com.vykon.vykonPro.history.BPeakTracker#calculate
   */
  public void calculate() { invoke(calculate,null,null); }

////////////////////////////////////////////////////////////////
// Action "ticketExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>ticketExpired</code> action.
   * @see com.vykon.vykonPro.history.BPeakTracker#ticketExpired()
   */
  public static final Action ticketExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>ticketExpired</code> action.
   * @see com.vykon.vykonPro.history.BPeakTracker#ticketExpired
   */
  public void ticketExpired() { invoke(ticketExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "resetPeaks"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>resetPeaks</code> action.
   * @see com.vykon.vykonPro.history.BPeakTracker#resetPeaks()
   */
  public static final Action resetPeaks = newAction(0,null);
  
  /**
   * Invoke the <code>resetPeaks</code> action.
   * @see com.vykon.vykonPro.history.BPeakTracker#resetPeaks
   */
  public void resetPeaks() { invoke(resetPeaks,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BPeakTracker.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  
  public void started()
  {
    if(!getEnabled()) return;
    calculate();
    initClockTicket();
    
  }
  
  public void stopped() throws Exception
  {
    if (ticket != null)
      ticket.cancel();
  }
  
  public void atSteadyState()
  {
    calculate();
  }
  
  public BFacets getSlotFacets(Slot slot)
  {
    if(slot.equals(in) ||
        slot.equals(januaryPeak) ||
        slot.equals(februaryPeak) ||
        slot.equals(marchPeak) ||
        slot.equals(aprilPeak) ||
        slot.equals(mayPeak) ||
        slot.equals(junePeak) ||
        slot.equals(julyPeak) ||
        slot.equals(augustPeak) ||
        slot.equals(septemberPeak) ||
        slot.equals(octoberPeak) ||
        slot.equals(novemberPeak) ||
        slot.equals(decemberPeak))
      return getFacets();
    return super.getSlotFacets(slot);

  }

  
  public void clockChanged(BRelTime value)
  {
    if(getEnabled()) initClockTicket();
  }

  
  private void initClockTicket()
  {
    if (ticket != null) ticket.cancel();
    
    //need to calculate the BAbsTime for the start of next month to call
    //the component in case no change in value, but there has been a change
    //in the current month.
    now = Clock.time();
    BMonth currentMonth = now.getMonth();
    int currentYear = now.getYear();
    int currentDay = now.getDay();
    
    BAbsTime firstOfMonth = null;
    BAbsTime nextMonth = null;
    
    if(getDateMode().getOrdinal()==BDateModeEnum.FIRST_OF_MONTH)
    {
      firstOfMonth = BAbsTime.make(currentYear, currentMonth, 1, 0, 0, 15, 0);
      nextMonth = firstOfMonth.nextMonth();
    }
    else
    {
      //using billing cycle
      if(currentDay < getBillingCycleStartDay())
      {
        nextMonth = BAbsTime.make(currentYear, currentMonth, getBillingCycleStartDay(), 0, 0, 15, 0);
      }
      else
      {
        firstOfMonth = BAbsTime.make(currentYear, currentMonth, getBillingCycleStartDay(), 0, 0, 15, 0);
        nextMonth = firstOfMonth.nextMonth();
      }
    }
    
    //schedule object to execute next month
    ticket = Clock.schedule(this, nextMonth, ticketExpired, null);
  }
  
  
  public void doTicketExpired()
  {
    doCalculate();
    initClockTicket();
  }
  
  
  public void changed(Property prop, Context context)
  {
    super.changed(prop, context);
    if (!Sys.atSteadyState() || !isRunning())
      return;

    if(prop.equals(in) && getEnabled())
    {
      //check if new peak is set
      if(getIn().getStatus().isValid())
      {
        calculate();
      }
    }
    else if(prop.equals(enabled))
    {
      if(getEnabled())
      {
        //transitioned from disabled to enabled
        initClockTicket();
        
        //check current value
        doCalculate();
        
      }
      else
      {
        //transitioned from enabled to disabled so clean up
        if (ticket != null)
          ticket.cancel();
      }
    }
    else if(prop.equals(dateMode))
    {
      initClockTicket();
    }
    else if(prop.equals(billingCycleStartDay))
    {
      if(getDateMode().getOrdinal()==BDateModeEnum.BILLING_CYCLE)
        initClockTicket();
    }
  }
  
  public void doCalculate()
  {
  //check current value
    now = Clock.time();
    int month = now.getMonth().getMonthOfYear();
    int year = now.getYear();
    int day = now.getDay();
    double inValue = getIn().getValue();
    
    if(getDateMode().getOrdinal()==BDateModeEnum.FIRST_OF_MONTH)
    {
      checkPeak(inValue, month, year);
    }
    else
    {
      int billDay = getBillingCycleStartDay();
      if(day<billDay)
      {
        //still previous month so shift month back
        BAbsTime prevMonth = now.prevMonth();
        checkPeak(inValue, prevMonth.getMonth().getMonthOfYear(), prevMonth.getYear());
      }
      else
      {
        //at least the bill day, so check this month's peak
        checkPeak(inValue, month, year);
      }
    }
  }
  
  
  public void doResetPeaks()
  {
    now = Clock.time();
    setLastReset(now);
    getJanuaryPeak().setValue(0);
    setJanuaryTimestamp(BAbsTime.NULL);
    getFebruaryPeak().setValue(0);
    setFebruaryTimestamp(BAbsTime.NULL);
    getMarchPeak().setValue(0);
    setMarchTimestamp(BAbsTime.NULL);
    getAprilPeak().setValue(0);
    setAprilTimestamp(BAbsTime.NULL);
    getMayPeak().setValue(0);
    setMayTimestamp(BAbsTime.NULL);
    getJunePeak().setValue(0);
    setJuneTimestamp(BAbsTime.NULL);
    getJulyPeak().setValue(0);
    setJulyTimestamp(BAbsTime.NULL);
    getAugustPeak().setValue(0);
    setAugustTimestamp(BAbsTime.NULL);
    getSeptemberPeak().setValue(0);
    setSeptemberTimestamp(BAbsTime.NULL);
    getOctoberPeak().setValue(0);
    setOctoberTimestamp(BAbsTime.NULL);
    getNovemberPeak().setValue(0);
    setNovemberTimestamp(BAbsTime.NULL);
    getDecemberPeak().setValue(0);
    setDecemberTimestamp(BAbsTime.NULL);
    
    calculate();
  }
  
  
  private void checkPeak(double v, int m, int y)
  {
    switch(m)
    {
      case 1: //January
        if(v >= getJanuaryPeak().getValue() || getJanuaryTimestamp().getYear()!=y)
        {
          getJanuaryPeak().setValue(v);
          setJanuaryTimestamp(now);
        }
        break;
        
      case 2: //February
        if(v >= getFebruaryPeak().getValue() || getFebruaryTimestamp().getYear()!=y)
        {
          getFebruaryPeak().setValue(v);
          setFebruaryTimestamp(now);
        }
        break;
        
      case 3: //March
        if(v >= getMarchPeak().getValue() || getMarchTimestamp().getYear()!=y)
        {
          getMarchPeak().setValue(v);
          setMarchTimestamp(now);
        }
        break;
        
      case 4: //April
        if(v >= getAprilPeak().getValue() || getAprilTimestamp().getYear()!=y)
        {
          getAprilPeak().setValue(v);
          setAprilTimestamp(now);
        }
        break;
        
      case 5: //May
        if(v >= getMayPeak().getValue() || getMayTimestamp().getYear()!=y)
        {
          getMayPeak().setValue(v);
          setMayTimestamp(now);
        }
        break;
        
      case 6: //June
        if(v >= getJunePeak().getValue() || getJuneTimestamp().getYear()!=y)
        {
          getJunePeak().setValue(v);
          setJuneTimestamp(now);
        }
        break;
        
      case 7: //July
        if(v >= getJulyPeak().getValue() || getJulyTimestamp().getYear()!=y)
        {
          getJulyPeak().setValue(v);
          setJulyTimestamp(now);
        }
        break;
        
      case 8: //August
        if(v >= getAugustPeak().getValue() || getAugustTimestamp().getYear()!=y)
        {
          getAugustPeak().setValue(v);
          setAugustTimestamp(now);
        }
        break;
        
      case 9: //September
        if(v >= getSeptemberPeak().getValue() || getSeptemberTimestamp().getYear()!=y)
        {
          getSeptemberPeak().setValue(v);
          setSeptemberTimestamp(now);
        }
        break;
        
      case 10: //October
        if(v >= getOctoberPeak().getValue() || getOctoberTimestamp().getYear()!=y)
        {
          getOctoberPeak().setValue(v);
          setOctoberTimestamp(now);
        }
        break;
        
      case 11: //November
        if(v >= getNovemberPeak().getValue() || getNovemberTimestamp().getYear()!=y)
        {
          getNovemberPeak().setValue(v);
          setNovemberTimestamp(now);
        }
        break;
        
      case 12: //December
        if(v >= getDecemberPeak().getValue() || getDecemberTimestamp().getYear()!=y)
        {
          getDecemberPeak().setValue(v);
          setDecemberTimestamp(now);
        }
        break;
    }
    
  }

  public BStatusNumeric[] getPeaks()
  {
    BStatusNumeric[] peaks = new BStatusNumeric[12];
    peaks[0]=(BStatusNumeric)getJanuaryPeak().newCopy();
    peaks[1]=(BStatusNumeric)getFebruaryPeak().newCopy();
    peaks[2]=(BStatusNumeric)getMarchPeak().newCopy();
    peaks[3]=(BStatusNumeric)getAprilPeak().newCopy();
    peaks[4]=(BStatusNumeric)getMayPeak().newCopy();
    peaks[5]=(BStatusNumeric)getJunePeak().newCopy();
    peaks[6]=(BStatusNumeric)getJulyPeak().newCopy();
    peaks[7]=(BStatusNumeric)getAugustPeak().newCopy();
    peaks[8]=(BStatusNumeric)getSeptemberPeak().newCopy();
    peaks[9]=(BStatusNumeric)getOctoberPeak().newCopy();
    peaks[10]=(BStatusNumeric)getNovemberPeak().newCopy();
    peaks[11]=(BStatusNumeric)getDecemberPeak().newCopy();
    return peaks;
  }

  public BAbsTime[] getTimestamps()
  {
    BAbsTime[] tstamps = new BAbsTime[12];
    tstamps[0]=(BAbsTime)getJanuaryTimestamp().newCopy();
    tstamps[1]=(BAbsTime)getFebruaryTimestamp().newCopy();
    tstamps[2]=(BAbsTime)getMarchTimestamp().newCopy();
    tstamps[3]=(BAbsTime)getAprilTimestamp().newCopy();
    tstamps[4]=(BAbsTime)getMayTimestamp().newCopy();
    tstamps[5]=(BAbsTime)getJuneTimestamp().newCopy();
    tstamps[6]=(BAbsTime)getJulyTimestamp().newCopy();
    tstamps[7]=(BAbsTime)getAugustTimestamp().newCopy();
    tstamps[8]=(BAbsTime)getSeptemberTimestamp().newCopy();
    tstamps[9]=(BAbsTime)getOctoberTimestamp().newCopy();
    tstamps[10]=(BAbsTime)getNovemberTimestamp().newCopy();
    tstamps[11]=(BAbsTime)getDecemberTimestamp().newCopy();
    return tstamps;
  }
//////////////////////////////////////////////////
// local variables
//////////////////////////////////////////////////
  BAbsTime now = null;
  Clock.Ticket ticket = null;

  
////////////////////////////////////////////////////////////////
// Icon
////////////////////////////////////////////////////////////////
  
  /**
   * Get the icon.
   */
  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("arrowUp.png");
}
