package com.vykon.vykonPro.hvac;

import javax.baja.status.BStatus;
import javax.baja.status.BStatusBoolean;
import javax.baja.sys.Action;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BInteger;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.nre.util.TextUtil;

import com.vykon.vykonPro.enums.BSequencerOutputEnum;
import com.vykon.vykonPro.util.BDisabledLoadsBitString;

public class BLoadSequencer
    extends BComponent
{
  /*-
   class BLoadSequencer
   {
     properties
    {
      status: BStatus
        -- Status of the component
        flags{ readonly, defaultOnClone }
        default{[ BStatus.ok ]}
        
      faultCause: String
        -- The fault cause.
        flags{ readonly, defaultOnClone }
        default{[ "" ]}
        
      facets: BFacets
        -- These facets are applied against the out property.
        flags{ operator }
        default {[ BFacets.makeBoolean() ]}
      
      actionFacets: BFacets
        -- These facets are applied against the enableOutput and disableOutput actions
        flags{ operator }
        default{[ BFacets.makeEnum(BEnumRange.make(BSequencerOutputEnum.TYPE)) ]}
        
      schedule: BStatusBoolean
        -- When schedule input is false, all loads will be de-engergized.
        flags { operator, summary }
        default {[ new BStatusBoolean() ]}
      
      loadFailed: BStatusBoolean
        -- If any load fails to run when commanded, the loadFailed output will be set to true.
        flags { summary, readonly }
        default {[ new BStatusBoolean() ]}
        
      numberOutputs: int
        -- The number of loads to be controlled.
        flags{ operator }
        default {[ 2 ]}
        slotfacets {[ BFacets.makeInt(null, 2, 10) ]}
        
      requiredLoads: int
        -- The required number of loads that need to be energized, such as with parallel pumping.
        flags{ operator }
        default {[ 1 ]}
        slotfacets {[ BFacets.makeInt(null, 0, 10) ]}
      
      rotationOrder: BRotationOrder
        -- The configured order in which the loads are started
        flags{ operator, readonly }
        default{[ new BRotationOrder() ]}
      
      lastActiveLoad: String
       -- the last output which was started
       flags{ readonly, transient }
       default{[ "" ]}
       
      feedbackDelay: BRelTime
        -- The amount of time after commanding a load on after which if the feedback has not registered that the load
        -- will be considered failed.
        flags{ operator }
        default {[ BRelTime.make(30000) ]}

      outA: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}

      outB: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}

      outC: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outD: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outE: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outF: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outG: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outH: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outI: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      outJ: BStatusBoolean
        flags { transient }
        default {[ new BStatusBoolean() ]}
    
      feedbackA: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackB: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackC: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackD: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackE: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackF: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackG: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackH: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackI: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      feedbackJ: BStatusBoolean
        flags { transient, summary }
        default {[ new BStatusBoolean() ]}
      
      disabledLoads: BDisabledLoadsBitString
        flags { readonly, hidden, defaultOnClone }
        default {[ new BDisabledLoadsBitString(0) ]}
      
      debug: boolean
        flags{ hidden }
        default {[ false ]}
    }

    actions
    {
      startupTimerExpired()
        flags { hidden }
        
      feedbackTimerExpired()
        flags { hidden }
        
      disableOutput(output:BEnum)
         default {[ ( BDynamicEnum.make(1, BEnumRange.make( BSequencerOutputEnum.TYPE))) ]}
         
      enableOutput(output:BEnum)
         default {[ ( BDynamicEnum.make(1, BEnumRange.make( BSequencerOutputEnum.TYPE))) ]}
      
      manualCmd(manCmd:BManualSequencerCmd)
        default {[ new BManualSequencerCmd() ]}
        
      loadsChanged()
        flags { hidden }
        
      
    }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BLoadSequencer(1339858961)1.0$ @*/
/* Generated Tue Jan 27 16:48:33 EST 2015 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>status</code> property.
   * Status of the component
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getStatus
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, BStatus.ok,null);
  
  /**
   * Get the <code>status</code> property.
   * Status of the component
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the <code>status</code> property.
   * Status of the component
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#status
   */
  public void setStatus(BStatus v) { set(status,v,null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>faultCause</code> property.
   * The fault cause.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFaultCause
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, "",null);
  
  /**
   * Get the <code>faultCause</code> property.
   * The fault cause.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the <code>faultCause</code> property.
   * The fault cause.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#faultCause
   */
  public void setFaultCause(String v) { setString(faultCause,v,null); }

////////////////////////////////////////////////////////////////
// Property "facets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>facets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFacets
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFacets
   */
  public static final Property facets = newProperty(Flags.OPERATOR, BFacets.makeBoolean(),null);
  
  /**
   * Get the <code>facets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#facets
   */
  public BFacets getFacets() { return (BFacets)get(facets); }
  
  /**
   * Set the <code>facets</code> property.
   * These facets are applied against the out property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#facets
   */
  public void setFacets(BFacets v) { set(facets,v,null); }

////////////////////////////////////////////////////////////////
// Property "actionFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>actionFacets</code> property.
   * These facets are applied against the enableOutput and disableOutput actions
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getActionFacets
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setActionFacets
   */
  public static final Property actionFacets = newProperty(Flags.OPERATOR, BFacets.makeEnum(BEnumRange.make(BSequencerOutputEnum.TYPE)),null);
  
  /**
   * Get the <code>actionFacets</code> property.
   * These facets are applied against the enableOutput and disableOutput actions
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#actionFacets
   */
  public BFacets getActionFacets() { return (BFacets)get(actionFacets); }
  
  /**
   * Set the <code>actionFacets</code> property.
   * These facets are applied against the enableOutput and disableOutput actions
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#actionFacets
   */
  public void setActionFacets(BFacets v) { set(actionFacets,v,null); }

////////////////////////////////////////////////////////////////
// Property "schedule"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>schedule</code> property.
   * When schedule input is false, all loads will be de-engergized.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getSchedule
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setSchedule
   */
  public static final Property schedule = newProperty(Flags.OPERATOR|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>schedule</code> property.
   * When schedule input is false, all loads will be de-engergized.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#schedule
   */
  public BStatusBoolean getSchedule() { return (BStatusBoolean)get(schedule); }
  
  /**
   * Set the <code>schedule</code> property.
   * When schedule input is false, all loads will be de-engergized.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#schedule
   */
  public void setSchedule(BStatusBoolean v) { set(schedule,v,null); }

////////////////////////////////////////////////////////////////
// Property "loadFailed"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>loadFailed</code> property.
   * If any load fails to run when commanded, the loadFailed
   * output will be set to true.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getLoadFailed
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setLoadFailed
   */
  public static final Property loadFailed = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>loadFailed</code> property.
   * If any load fails to run when commanded, the loadFailed
   * output will be set to true.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#loadFailed
   */
  public BStatusBoolean getLoadFailed() { return (BStatusBoolean)get(loadFailed); }
  
  /**
   * Set the <code>loadFailed</code> property.
   * If any load fails to run when commanded, the loadFailed
   * output will be set to true.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#loadFailed
   */
  public void setLoadFailed(BStatusBoolean v) { set(loadFailed,v,null); }

////////////////////////////////////////////////////////////////
// Property "numberOutputs"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>numberOutputs</code> property.
   * The number of loads to be controlled.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getNumberOutputs
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setNumberOutputs
   */
  public static final Property numberOutputs = newProperty(Flags.OPERATOR, 2,BFacets.makeInt(null, 2, 10));
  
  /**
   * Get the <code>numberOutputs</code> property.
   * The number of loads to be controlled.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#numberOutputs
   */
  public int getNumberOutputs() { return getInt(numberOutputs); }
  
  /**
   * Set the <code>numberOutputs</code> property.
   * The number of loads to be controlled.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#numberOutputs
   */
  public void setNumberOutputs(int v) { setInt(numberOutputs,v,null); }

////////////////////////////////////////////////////////////////
// Property "requiredLoads"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>requiredLoads</code> property.
   * The required number of loads that need to be energized,
   * such as with parallel pumping.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getRequiredLoads
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setRequiredLoads
   */
  public static final Property requiredLoads = newProperty(Flags.OPERATOR, 1,BFacets.makeInt(null, 0, 10));
  
  /**
   * Get the <code>requiredLoads</code> property.
   * The required number of loads that need to be energized,
   * such as with parallel pumping.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#requiredLoads
   */
  public int getRequiredLoads() { return getInt(requiredLoads); }
  
  /**
   * Set the <code>requiredLoads</code> property.
   * The required number of loads that need to be energized,
   * such as with parallel pumping.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#requiredLoads
   */
  public void setRequiredLoads(int v) { setInt(requiredLoads,v,null); }

////////////////////////////////////////////////////////////////
// Property "rotationOrder"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>rotationOrder</code> property.
   * The configured order in which the loads are started
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getRotationOrder
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setRotationOrder
   */
  public static final Property rotationOrder = newProperty(Flags.OPERATOR|Flags.READONLY, new BRotationOrder(),null);
  
  /**
   * Get the <code>rotationOrder</code> property.
   * The configured order in which the loads are started
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#rotationOrder
   */
  public BRotationOrder getRotationOrder() { return (BRotationOrder)get(rotationOrder); }
  
  /**
   * Set the <code>rotationOrder</code> property.
   * The configured order in which the loads are started
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#rotationOrder
   */
  public void setRotationOrder(BRotationOrder v) { set(rotationOrder,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastActiveLoad"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastActiveLoad</code> property.
   * the last output which was started
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getLastActiveLoad
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setLastActiveLoad
   */
  public static final Property lastActiveLoad = newProperty(Flags.READONLY|Flags.TRANSIENT, "",null);
  
  /**
   * Get the <code>lastActiveLoad</code> property.
   * the last output which was started
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#lastActiveLoad
   */
  public String getLastActiveLoad() { return getString(lastActiveLoad); }
  
  /**
   * Set the <code>lastActiveLoad</code> property.
   * the last output which was started
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#lastActiveLoad
   */
  public void setLastActiveLoad(String v) { setString(lastActiveLoad,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackDelay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackDelay</code> property.
   * The amount of time after commanding a load on after
   * which if the feedback has not registered that the load will be considered failed.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackDelay
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackDelay
   */
  public static final Property feedbackDelay = newProperty(Flags.OPERATOR, BRelTime.make(30000),null);
  
  /**
   * Get the <code>feedbackDelay</code> property.
   * The amount of time after commanding a load on after
   * which if the feedback has not registered that the load will be considered failed.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackDelay
   */
  public BRelTime getFeedbackDelay() { return (BRelTime)get(feedbackDelay); }
  
  /**
   * Set the <code>feedbackDelay</code> property.
   * The amount of time after commanding a load on after
   * which if the feedback has not registered that the load will be considered failed.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackDelay
   */
  public void setFeedbackDelay(BRelTime v) { set(feedbackDelay,v,null); }

////////////////////////////////////////////////////////////////
// Property "outA"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outA</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutA
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutA
   */
  public static final Property outA = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outA</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outA
   */
  public BStatusBoolean getOutA() { return (BStatusBoolean)get(outA); }
  
  /**
   * Set the <code>outA</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outA
   */
  public void setOutA(BStatusBoolean v) { set(outA,v,null); }

////////////////////////////////////////////////////////////////
// Property "outB"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outB</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutB
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutB
   */
  public static final Property outB = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outB</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outB
   */
  public BStatusBoolean getOutB() { return (BStatusBoolean)get(outB); }
  
  /**
   * Set the <code>outB</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outB
   */
  public void setOutB(BStatusBoolean v) { set(outB,v,null); }

////////////////////////////////////////////////////////////////
// Property "outC"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outC</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutC
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutC
   */
  public static final Property outC = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outC</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outC
   */
  public BStatusBoolean getOutC() { return (BStatusBoolean)get(outC); }
  
  /**
   * Set the <code>outC</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outC
   */
  public void setOutC(BStatusBoolean v) { set(outC,v,null); }

////////////////////////////////////////////////////////////////
// Property "outD"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outD</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutD
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutD
   */
  public static final Property outD = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outD</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outD
   */
  public BStatusBoolean getOutD() { return (BStatusBoolean)get(outD); }
  
  /**
   * Set the <code>outD</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outD
   */
  public void setOutD(BStatusBoolean v) { set(outD,v,null); }

////////////////////////////////////////////////////////////////
// Property "outE"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outE</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutE
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutE
   */
  public static final Property outE = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outE</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outE
   */
  public BStatusBoolean getOutE() { return (BStatusBoolean)get(outE); }
  
  /**
   * Set the <code>outE</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outE
   */
  public void setOutE(BStatusBoolean v) { set(outE,v,null); }

////////////////////////////////////////////////////////////////
// Property "outF"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outF</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutF
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutF
   */
  public static final Property outF = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outF</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outF
   */
  public BStatusBoolean getOutF() { return (BStatusBoolean)get(outF); }
  
  /**
   * Set the <code>outF</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outF
   */
  public void setOutF(BStatusBoolean v) { set(outF,v,null); }

////////////////////////////////////////////////////////////////
// Property "outG"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outG</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutG
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutG
   */
  public static final Property outG = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outG</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outG
   */
  public BStatusBoolean getOutG() { return (BStatusBoolean)get(outG); }
  
  /**
   * Set the <code>outG</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outG
   */
  public void setOutG(BStatusBoolean v) { set(outG,v,null); }

////////////////////////////////////////////////////////////////
// Property "outH"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outH</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutH
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutH
   */
  public static final Property outH = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outH</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outH
   */
  public BStatusBoolean getOutH() { return (BStatusBoolean)get(outH); }
  
  /**
   * Set the <code>outH</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outH
   */
  public void setOutH(BStatusBoolean v) { set(outH,v,null); }

////////////////////////////////////////////////////////////////
// Property "outI"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outI</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutI
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutI
   */
  public static final Property outI = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outI</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outI
   */
  public BStatusBoolean getOutI() { return (BStatusBoolean)get(outI); }
  
  /**
   * Set the <code>outI</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outI
   */
  public void setOutI(BStatusBoolean v) { set(outI,v,null); }

////////////////////////////////////////////////////////////////
// Property "outJ"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>outJ</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getOutJ
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setOutJ
   */
  public static final Property outJ = newProperty(Flags.TRANSIENT, new BStatusBoolean(),null);
  
  /**
   * Get the <code>outJ</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outJ
   */
  public BStatusBoolean getOutJ() { return (BStatusBoolean)get(outJ); }
  
  /**
   * Set the <code>outJ</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#outJ
   */
  public void setOutJ(BStatusBoolean v) { set(outJ,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackA"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackA</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackA
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackA
   */
  public static final Property feedbackA = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackA</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackA
   */
  public BStatusBoolean getFeedbackA() { return (BStatusBoolean)get(feedbackA); }
  
  /**
   * Set the <code>feedbackA</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackA
   */
  public void setFeedbackA(BStatusBoolean v) { set(feedbackA,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackB"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackB</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackB
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackB
   */
  public static final Property feedbackB = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackB</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackB
   */
  public BStatusBoolean getFeedbackB() { return (BStatusBoolean)get(feedbackB); }
  
  /**
   * Set the <code>feedbackB</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackB
   */
  public void setFeedbackB(BStatusBoolean v) { set(feedbackB,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackC"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackC</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackC
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackC
   */
  public static final Property feedbackC = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackC</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackC
   */
  public BStatusBoolean getFeedbackC() { return (BStatusBoolean)get(feedbackC); }
  
  /**
   * Set the <code>feedbackC</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackC
   */
  public void setFeedbackC(BStatusBoolean v) { set(feedbackC,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackD"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackD</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackD
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackD
   */
  public static final Property feedbackD = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackD</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackD
   */
  public BStatusBoolean getFeedbackD() { return (BStatusBoolean)get(feedbackD); }
  
  /**
   * Set the <code>feedbackD</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackD
   */
  public void setFeedbackD(BStatusBoolean v) { set(feedbackD,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackE"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackE</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackE
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackE
   */
  public static final Property feedbackE = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackE</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackE
   */
  public BStatusBoolean getFeedbackE() { return (BStatusBoolean)get(feedbackE); }
  
  /**
   * Set the <code>feedbackE</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackE
   */
  public void setFeedbackE(BStatusBoolean v) { set(feedbackE,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackF"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackF</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackF
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackF
   */
  public static final Property feedbackF = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackF</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackF
   */
  public BStatusBoolean getFeedbackF() { return (BStatusBoolean)get(feedbackF); }
  
  /**
   * Set the <code>feedbackF</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackF
   */
  public void setFeedbackF(BStatusBoolean v) { set(feedbackF,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackG"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackG</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackG
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackG
   */
  public static final Property feedbackG = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackG</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackG
   */
  public BStatusBoolean getFeedbackG() { return (BStatusBoolean)get(feedbackG); }
  
  /**
   * Set the <code>feedbackG</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackG
   */
  public void setFeedbackG(BStatusBoolean v) { set(feedbackG,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackH"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackH</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackH
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackH
   */
  public static final Property feedbackH = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackH</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackH
   */
  public BStatusBoolean getFeedbackH() { return (BStatusBoolean)get(feedbackH); }
  
  /**
   * Set the <code>feedbackH</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackH
   */
  public void setFeedbackH(BStatusBoolean v) { set(feedbackH,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackI"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackI</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackI
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackI
   */
  public static final Property feedbackI = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackI</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackI
   */
  public BStatusBoolean getFeedbackI() { return (BStatusBoolean)get(feedbackI); }
  
  /**
   * Set the <code>feedbackI</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackI
   */
  public void setFeedbackI(BStatusBoolean v) { set(feedbackI,v,null); }

////////////////////////////////////////////////////////////////
// Property "feedbackJ"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackJ</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getFeedbackJ
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setFeedbackJ
   */
  public static final Property feedbackJ = newProperty(Flags.TRANSIENT|Flags.SUMMARY, new BStatusBoolean(),null);
  
  /**
   * Get the <code>feedbackJ</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackJ
   */
  public BStatusBoolean getFeedbackJ() { return (BStatusBoolean)get(feedbackJ); }
  
  /**
   * Set the <code>feedbackJ</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackJ
   */
  public void setFeedbackJ(BStatusBoolean v) { set(feedbackJ,v,null); }

////////////////////////////////////////////////////////////////
// Property "disabledLoads"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>disabledLoads</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getDisabledLoads
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setDisabledLoads
   */
  public static final Property disabledLoads = newProperty(Flags.READONLY|Flags.HIDDEN|Flags.DEFAULT_ON_CLONE, new BDisabledLoadsBitString(0),null);
  
  /**
   * Get the <code>disabledLoads</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#disabledLoads
   */
  public BDisabledLoadsBitString getDisabledLoads() { return (BDisabledLoadsBitString)get(disabledLoads); }
  
  /**
   * Set the <code>disabledLoads</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#disabledLoads
   */
  public void setDisabledLoads(BDisabledLoadsBitString v) { set(disabledLoads,v,null); }

////////////////////////////////////////////////////////////////
// Property "debug"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>debug</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#getDebug
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#setDebug
   */
  public static final Property debug = newProperty(Flags.HIDDEN, false,null);
  
  /**
   * Get the <code>debug</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#debug
   */
  public boolean getDebug() { return getBoolean(debug); }
  
  /**
   * Set the <code>debug</code> property.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#debug
   */
  public void setDebug(boolean v) { setBoolean(debug,v,null); }

////////////////////////////////////////////////////////////////
// Action "startupTimerExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>startupTimerExpired</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#startupTimerExpired()
   */
  public static final Action startupTimerExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>startupTimerExpired</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#startupTimerExpired
   */
  public void startupTimerExpired() { invoke(startupTimerExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "feedbackTimerExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>feedbackTimerExpired</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackTimerExpired()
   */
  public static final Action feedbackTimerExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>feedbackTimerExpired</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#feedbackTimerExpired
   */
  public void feedbackTimerExpired() { invoke(feedbackTimerExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "disableOutput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>disableOutput</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#disableOutput()
   */
  public static final Action disableOutput = newAction(0,( BDynamicEnum.make(1, BEnumRange.make( BSequencerOutputEnum.TYPE))),null);
  
  /**
   * Invoke the <code>disableOutput</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#disableOutput
   */
  public void disableOutput(BEnum output) { invoke(disableOutput,output,null); }

////////////////////////////////////////////////////////////////
// Action "enableOutput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>enableOutput</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#enableOutput()
   */
  public static final Action enableOutput = newAction(0,( BDynamicEnum.make(1, BEnumRange.make( BSequencerOutputEnum.TYPE))),null);
  
  /**
   * Invoke the <code>enableOutput</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#enableOutput
   */
  public void enableOutput(BEnum output) { invoke(enableOutput,output,null); }

////////////////////////////////////////////////////////////////
// Action "manualCmd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>manualCmd</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#manualCmd()
   */
  public static final Action manualCmd = newAction(0,new BManualSequencerCmd(),null);
  
  /**
   * Invoke the <code>manualCmd</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#manualCmd
   */
  public void manualCmd(BManualSequencerCmd manCmd) { invoke(manualCmd,manCmd,null); }

////////////////////////////////////////////////////////////////
// Action "loadsChanged"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>loadsChanged</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#loadsChanged()
   */
  public static final Action loadsChanged = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>loadsChanged</code> action.
   * @see com.vykon.vykonPro.hvac.BLoadSequencer#loadsChanged
   */
  public void loadsChanged() { invoke(loadsChanged,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BLoadSequencer.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BLoadSequencer()
  {
  }
  
  /**
   * Init if started after steady state has been reached.
   */
  public void started()
  {
    if(startupTicket!=null) startupTicket.cancel();
    startupTicket = Clock.schedule(this, BRelTime.makeSeconds(30), startupTimerExpired, null);
    numOutputs = getNumberOutputs();
    
    initNumberOutputs();
  }

  public void stopped()
  {
    if (feedbackTicket != null) feedbackTicket.cancel();
    if (startupTicket != null) startupTicket.cancel();
  }
  
  
/**
   * setoutput on in change.
   */
  public void changed(Property p, Context cx)
  {
    super.changed(p, cx);
    if (!Sys.atSteadyState() || !isRunning())
      return;

    if(p == numberOutputs)
    {
      initNumberOutputs();
    }
    else if(p == schedule) 
    {
      calculate();
    }
    else if(p == requiredLoads)
    {
      if(getSchedule().getValue()) startOutput();
    }
    else if (p == feedbackA || p == feedbackB || p == feedbackC || p == feedbackD ||
        p == feedbackE || p == feedbackF || p == feedbackG || p == feedbackH || p == feedbackI ||
        p == feedbackJ)
    {
      if (!currentIn)
        return;
      if (feedbackTimerActive)
        return;
      checkRunningStatus();
    }
  }

  public void initNumberOutputs()
  {
    numOutputs = getNumberOutputs();
    
    int setFlags;
    boolean used = false;
    
    for(int i = 0; i < 10; i++)
    {
      if(i >= numOutputs)
      {
        setFlags = Flags.HIDDEN | Flags.TRANSIENT;
        used = false;
      }
      else
      {
        setFlags = Flags.SUMMARY | Flags.TRANSIENT;
        used = true;
      }
      switch(i)
      {
        //should possibly check if runtime or feedback slots are linked and delete the links
        case 0: initSlot("outA", setFlags | Flags.READONLY); initSlot("feedbackA", setFlags); initLoads("outA", used,1); break;
        case 1: initSlot("outB", setFlags | Flags.READONLY); initSlot("feedbackB", setFlags); initLoads("outB", used,2); break;
        case 2: initSlot("outC", setFlags | Flags.READONLY); initSlot("feedbackC", setFlags); initLoads("outC", used,3); break;
        case 3: initSlot("outD", setFlags | Flags.READONLY); initSlot("feedbackD", setFlags); initLoads("outD", used,4); break;
        case 4: initSlot("outE", setFlags | Flags.READONLY); initSlot("feedbackE", setFlags); initLoads("outE", used,5); break;
        case 5: initSlot("outF", setFlags | Flags.READONLY); initSlot("feedbackF", setFlags); initLoads("outF", used,6); break;
        case 6: initSlot("outG", setFlags | Flags.READONLY); initSlot("feedbackG", setFlags); initLoads("outG", used,7); break;
        case 7: initSlot("outH", setFlags | Flags.READONLY); initSlot("feedbackH", setFlags); initLoads("outH", used,8); break;
        case 8: initSlot("outI", setFlags | Flags.READONLY); initSlot("feedbackI", setFlags); initLoads("outI", used,9); break;
        case 9: initSlot("outJ", setFlags | Flags.READONLY); initSlot("feedbackJ", setFlags); initLoads("outJ", used,10); break;
      }
      
      //check for any previously disabled loads and disable them on start
      int[] disabledLoads = getDisabledLoads().getOrdinals();
      
      for(int k=0; k<disabledLoads.length; k++)
      {
        if(getDisabledLoads().getBit(disabledLoads[k]))
        {
          //the bitString contains this bit so disable the load
          String loadName = getDisabledLoads().getTag(disabledLoads[k]);
          ((BStatusBoolean)this.get(loadName)).setStatusDisabled(true);
        }
      }
    }
  }

  void initSlot(String slot, int flags)
  {
      try { setFlags(getSlot(slot), flags, null);} catch(Exception e) {};
  }
  
  void initLoads(String name, boolean used, int value)
  {
    int setFlags = Flags.HIDDEN | Flags.READONLY;
    BRotationOrder  ro = getRotationOrder();
    
    if(used)
    {
      //slot is being used so make sure it is there
      if(ro.get(name)==null)
      {
        ro.add(name, BInteger.make(value));
        ro.setFlags(ro.getSlot(name), setFlags);
      }
    }
    else
    {
      //not using this output so need to remove the slot
      if(ro.get(name)!=null) ro.remove(name);
    }
  }


  //////////////////////////////////////////////////////////////////////
  // actions
  //////////////////////////////////////////////////////////////////////
  
  public void doStartupTimerExpired()
  {
    if(startupTicket!=null) startupTicket.cancel();
    calculate();
  }
  
  
  public void doFeedbackTimerExpired()
  {
    feedbackTimerActive = false;
    if(!currentIn) return;
    checkRunningStatus();
  }
  
  public void doDisableOutput(BEnum output)
  {
    int outNmbr = output.getEnum().getOrdinal();
    getStatusOutput(outNmbr).setStatusDisabled(true);
    
    //update the disabledLoads bits
    int loadBit = getLoadBit(outNmbr);
    setDisabledLoads(BDisabledLoadsBitString.make(getDisabledLoads().getBits() | loadBit));
    
    startOutput();  //shift loads if necessary
  }
  
  public void doEnableOutput(BEnum output)
  {
    int outNmbr = output.getEnum().getOrdinal();
    getStatusOutput(outNmbr).setStatusDisabled(false);
    
    //update the disabledLoads bits
    int loadBit = getLoadBit(outNmbr);
    setDisabledLoads(BDisabledLoadsBitString.make(getDisabledLoads().getBits() & ~loadBit));
    
    startOutput();  //normalize loads
  }
  
  
  public void doManualCmd(BManualSequencerCmd manCmd)
  {
    
    int outNmbr = manCmd.getOutput().getOrdinal();
    
    if(manCmd.getCommand())
    {
      //command value is true so disable output
      getStatusOutput(outNmbr).setStatusDisabled(true);
      
      //update the disabledLoads bits
      int loadBit = getLoadBit(outNmbr);
      setDisabledLoads(BDisabledLoadsBitString.make(getDisabledLoads().getBits() | loadBit));
    }
    else
    {
      //command value is false so enable output
      getStatusOutput(outNmbr).setStatusDisabled(false);
      
      //update the disabledLoads bits
      int loadBit = getLoadBit(outNmbr);
      setDisabledLoads(BDisabledLoadsBitString.make(getDisabledLoads().getBits() & ~loadBit));
    }
	
	startOutput();  //shift loads if necessary
  }
  
  public void doLoadsChanged()
  {
    startOutput();
  }
  
  
  ////////////////////////////////////////////////////////
  // methods
  ////////////////////////////////////////////////////////
  
  void calculate()
  { 
    currentIn = getSchedule().getValue();
    
    if(currentIn)  // if controlIn is active
    {
      if(!wasOn)   // and was not active on last execute
      {
        startOutput();          // start the required loads
        wasOn = true;           // set was on flag.
      }
    }
    else  // control in is not active
    {
      if(wasOn)  // if was active on last execute
      {
        if(feedbackTicket != null) feedbackTicket.cancel();
        wasOn = false;             // clear was on flag.
      }
      
      stopOutput();              // stop all outputs
    }
  }

  boolean getOutValue(int index)
  {
    switch(index)
    {
    case 1: return getOutA().getValue();
    case 2: return getOutB().getValue();
    case 3: return getOutC().getValue();
    case 4: return getOutD().getValue();
    case 5: return getOutE().getValue();
    case 6: return getOutF().getValue();
    case 7: return getOutG().getValue();
    case 8: return getOutH().getValue();
    case 9: return getOutI().getValue();
    case 10: return getOutJ().getValue();
    }
    return false; 
  }
  
  boolean getOutStatus(int index)
  {
    switch(index)
    {
      //changed from isValid to isOk
      case 1: return getOutA().getStatus().isOk();
      case 2: return getOutB().getStatus().isOk();
      case 3: return getOutC().getStatus().isOk();
      case 4: return getOutD().getStatus().isOk();
      case 5: return getOutE().getStatus().isOk();
      case 6: return getOutF().getStatus().isOk();
      case 7: return getOutG().getStatus().isOk();
      case 8: return getOutH().getStatus().isOk();
      case 9: return getOutI().getStatus().isOk();
      case 10: return getOutJ().getStatus().isOk();
      
    }
    return false;
  }
  
  boolean getFeedbackValue(int index)
  {
    switch(index)
    {
    case 1: return getFeedbackA().getValue();
    case 2: return getFeedbackB().getValue();
    case 3: return getFeedbackC().getValue();
    case 4: return getFeedbackD().getValue();
    case 5: return getFeedbackE().getValue();
    case 6: return getFeedbackF().getValue();
    case 7: return getFeedbackG().getValue();
    case 8: return getFeedbackH().getValue();
    case 9: return getFeedbackI().getValue();
    case 10: return getFeedbackJ().getValue();
    }
    return false; 
  }
  
  // This method will start the required outputs beginning with the 
  // lead load.
  void startOutput()
  {
    if(getDebug()) System.out.println(this.getSlotPath() + " - running start output");
    
    if(!getSchedule().getValue())
    {
      //stopOutput();
      return;
    }
    
    String load = "";
    
    int req = getRequiredLoads();
    int started = 0;
    boolean outputChanged = false;
    
    BRotationOrder ro = getRotationOrder();
    String current = ro.getOrder();
    String[] loads = TextUtil.splitAndTrim(current, ',');
    
    //iterate through loads in configured order, don't start a load until the lead load is found
    //then continue starting loads until the end of the for loop
    for(int k=0; k<loads.length; k++)
    {
      
      if(ro.get("out"+loads[k])==null) continue;
      
      int id = ((BInteger)ro.get("out"+loads[k])).getInt();
      
      if(started < req && getStatusOutput(id).getStatus().isOk())
      {
        //this is the lead output and ok to run
        if(getStatusOutput(id).getValue()==false)
          {
            getStatusOutput(id).setValue(true);
            outputChanged=true;
          }
          started = started + 1;
          load = "out"+loads[k];
          if(getDebug()) System.out.println("checked load " + id + " , started " + started);
      }
      else if(started==req)
      {
        //we have enough loads running so turn off any remaining loads
        getStatusOutput(id).setValue(false);
        if(getDebug()) System.out.println("checking " + loads[k] + " , enough loads already started");
      }
    }
            
    if(started < req)
    {
      if(getDebug()) System.out.println("didn't start the required number of loads");
      
      setStatus(BStatus.make(getStatus(), BStatus.ALARM, true));
      setFaultCause("Not enough loads available to start the required number!");
    }
    else
    {
      if(getDebug()) System.out.println("started the required number of loads");
      
      setStatus(BStatus.make(getStatus(), BStatus.ALARM, false));
      if(!getStatus().isFault()) setFaultCause("");
    }
    
    if(outputChanged) startFeedbackTimer();
    setLastActiveLoad(load);
  }
    
  BStatusBoolean getStatusOutput(int index)
  {
    switch(index)
    {
    case 1: return getOutA();
    case 2: return getOutB();
    case 3: return getOutC();
    case 4: return getOutD();
    case 5: return getOutE();
    case 6: return getOutF();
    case 7: return getOutG();
    case 8: return getOutH();
    case 9: return getOutI();
    case 10: return getOutJ();
    }
    if(index < 1) return getOutA();
    return getOutJ();
  }

  
  // Turn off all outputs
  void stopOutput()
  {
    for(int i = 1; i <= numOutputs; i++)
    {
      getStatusOutput(i).setValue(false);
      //checkRunningStatus();
      //TODO not sure about this change
    }
    checkRunningStatus();
    setLastActiveLoad("");
      
  }
  
  // start feedback timer. It will call back execute when it expires.
  void startFeedbackTimer()
  {            
    if (feedbackTicket != null) feedbackTicket.cancel();
    feedbackTimerActive = true;
    feedbackTicket = Clock.schedule(this, getFeedbackDelay(), feedbackTimerExpired, null);
  }    
  
  void checkRunningStatus()
  {
    if(getDebug()) System.out.println(this.getSlotPath() + "checking running status");
    
    startedLoads = 0;
    runningLoads = 0;
    
    BStatusBoolean out;
    boolean feedback;
    boolean isFailed=false;
    
    for(int i=1; i <= numOutputs; i++)
    {
      out = getStatusOutput(i);
      feedback = getFeedbackValue(i);
      
      if(getDebug()) System.out.println("load " + i + " out - " + out.getValue() + " | feedback - " + feedback);
      
      if(out.getValue() && !feedback)
      {
        out.setStatusInAlarm(true);
        isFailed = true;
        startedLoads = startedLoads + 1;
      }
      else if(out.getValue() && feedback)
      {
        out.setStatusInAlarm(false);
        startedLoads = startedLoads + 1;
        runningLoads = runningLoads + 1;
      }
      else if(!out.getValue() && feedback)
      {
        
      }
      else 
      {
        out.setStatusInAlarm(false);
      }
    }
    
    if(isFailed || startedLoads > getRequiredLoads()) 
    {  
      if(getDebug()) System.out.println(startedLoads + " loads started, " + getRequiredLoads() + " loads required, or a load is failed");
      getLoadFailed().setValue(true);
      startOutput();
    }
    else 
    {
      getLoadFailed().setValue(false);
    }
  }

  private int getLoadBit(int ordinal)
  {
    //using the enum ordinal get the load bit value
    int loadBit = 0;
    switch(ordinal)
    {
      case 1:
        loadBit = BDisabledLoadsBitString.OUT_A;
        break;
        
      case 2:
        loadBit = BDisabledLoadsBitString.OUT_B;
        break;
        
      case 3:
        loadBit = BDisabledLoadsBitString.OUT_C;
        break;
        
      case 4:
        loadBit = BDisabledLoadsBitString.OUT_D;
        break;
        
      case 5:
        loadBit = BDisabledLoadsBitString.OUT_E;
        break;
        
      case 6:
        loadBit = BDisabledLoadsBitString.OUT_F;
        break;
        
      case 7:
        loadBit = BDisabledLoadsBitString.OUT_G;
        break;
        
      case 8:
        loadBit = BDisabledLoadsBitString.OUT_H;
        break;
        
      case 9:
        loadBit = BDisabledLoadsBitString.OUT_I;
        break;
        
      case 10:
        loadBit = BDisabledLoadsBitString.OUT_J;
        break;
    }
    
    return loadBit;
  }
  
  /**
   * Apply the "facets" property to the "out" property.
   */
  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.getName().startsWith("out")) return getFacets();
    else if (slot.getName()=="enableOutput" || slot.getName()=="disableOutput")
      return getActionFacets();
    
    return super.getSlotFacets(slot);
  }


  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("reorder.png");

////////////////////////////////////////////////////////////////
// Attributes
////////////////////////////////////////////////////////////////
  int numOutputs;
  int startedLoads;
  int runningLoads;
  boolean feedbackTimerActive = false;
  boolean currentIn;
  boolean wasOn = false;
  boolean isFirst = false;
  
  Clock.Ticket feedbackTicket;    // Used to manage the on delay timer
  Clock.Ticket startupTicket;
  
}
