package com.vykon.vykonPro.hvac;

import com.vykon.vykonPro.enums.BInUseEnum;

import javax.baja.control.BNumericPoint;
import javax.baja.nre.annotations.Facet;
import javax.baja.nre.annotations.NiagaraAction;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusBoolean;
import javax.baja.status.BStatusNumeric;
import javax.baja.status.BStatusValue;
import javax.baja.sys.*;
import javax.baja.units.BUnit;

/**
 * Created by james on 12/18/2018.
 */

@NiagaraType

@NiagaraProperty(
        name = "input",
        type = "BStatusNumeric",
        defaultValue = "new BStatusNumeric()",
        flags = Flags.SUMMARY | Flags.TRANSIENT
)

@NiagaraProperty(
        name = "propagateFlags",
        type = "BStatus",
        defaultValue = "BStatus.ok"
)

@NiagaraProperty(
        name = "deviationFacets",
        type = "BFacets",
        defaultValue = "BFacets.makeNumeric(BUnit.DEFAULT, 1)"
)

@NiagaraProperty(
        name = "averageDeviation",
        type = "BStatusNumeric",
        defaultValue = "new BStatusNumeric()",
        flags = Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY
)

@NiagaraProperty(
        name = "maximumDeviation",
        type = "BStatusNumeric",
        defaultValue = "new BStatusNumeric()",
        flags = Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY
)

@NiagaraProperty(
        name = "inServiceFacets",
        type = "BFacets",
        defaultValue = "BFacets.makeBoolean()"
)

@NiagaraProperty(
        name = "inService",
        type = "BStatusBoolean",
        defaultValue = "new BStatusBoolean()",
        flags = Flags.SUMMARY
)

@NiagaraProperty(
        name = "masterSelected",
        type = "boolean",
        defaultValue = "false",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE
)

@NiagaraProperty(
        name = "masterInUse",
        type = "BDynamicEnum",
        defaultValue = "BDynamicEnum.make(0)",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE
)

@NiagaraProperty(
        name = "sampleCount",
        type = "BInteger",
        defaultValue = "BInteger.make(12)",
        flags = Flags.SUMMARY,
        facets =
        {
                @Facet(name="BFacets.MIN", value="BInteger.make(2)"),
                @Facet(name="BFacets.MAX", value="BInteger.make(60)")
        }
)

@NiagaraProperty(
        name = "sampleRate",
        type = "BRelTime",
        defaultValue = "BRelTime.makeSeconds(5)",
        flags = Flags.SUMMARY,
        facets =                                 //Any facets that the property may have.  The facet annotation works as a name-value pair.
        {
                @Facet(name = "BFacets.MIN", value = "BRelTime.makeSeconds(1)")
        }
)

@NiagaraProperty(
    name = "debug",
        type = "boolean",
        defaultValue = "false",
        flags = Flags.HIDDEN
)

@NiagaraAction(
        name = "calculate",
        flags = Flags.HIDDEN
)

@NiagaraAction(
        name="reset",
        flags = Flags.OPERATOR
)

public class BRollingAvg
    extends BNumericPoint{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BRollingAvg(2570232630)1.0$ @*/
/* Generated Wed Feb 13 10:25:58 EST 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "input"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code input} property.
   * @see #getInput
   * @see #setInput
   */
  public static final Property input = newProperty(Flags.SUMMARY | Flags.TRANSIENT, new BStatusNumeric(), null);
  
  /**
   * Get the {@code input} property.
   * @see #input
   */
  public BStatusNumeric getInput() { return (BStatusNumeric)get(input); }
  
  /**
   * Set the {@code input} property.
   * @see #input
   */
  public void setInput(BStatusNumeric v) { set(input, v, null); }

////////////////////////////////////////////////////////////////
// Property "propagateFlags"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code propagateFlags} property.
   * @see #getPropagateFlags
   * @see #setPropagateFlags
   */
  public static final Property propagateFlags = newProperty(0, BStatus.ok, null);
  
  /**
   * Get the {@code propagateFlags} property.
   * @see #propagateFlags
   */
  public BStatus getPropagateFlags() { return (BStatus)get(propagateFlags); }
  
  /**
   * Set the {@code propagateFlags} property.
   * @see #propagateFlags
   */
  public void setPropagateFlags(BStatus v) { set(propagateFlags, v, null); }

////////////////////////////////////////////////////////////////
// Property "deviationFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code deviationFacets} property.
   * @see #getDeviationFacets
   * @see #setDeviationFacets
   */
  public static final Property deviationFacets = newProperty(0, BFacets.makeNumeric(BUnit.DEFAULT, 1), null);
  
  /**
   * Get the {@code deviationFacets} property.
   * @see #deviationFacets
   */
  public BFacets getDeviationFacets() { return (BFacets)get(deviationFacets); }
  
  /**
   * Set the {@code deviationFacets} property.
   * @see #deviationFacets
   */
  public void setDeviationFacets(BFacets v) { set(deviationFacets, v, null); }

////////////////////////////////////////////////////////////////
// Property "averageDeviation"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code averageDeviation} property.
   * @see #getAverageDeviation
   * @see #setAverageDeviation
   */
  public static final Property averageDeviation = newProperty(Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY, new BStatusNumeric(), null);
  
  /**
   * Get the {@code averageDeviation} property.
   * @see #averageDeviation
   */
  public BStatusNumeric getAverageDeviation() { return (BStatusNumeric)get(averageDeviation); }
  
  /**
   * Set the {@code averageDeviation} property.
   * @see #averageDeviation
   */
  public void setAverageDeviation(BStatusNumeric v) { set(averageDeviation, v, null); }

////////////////////////////////////////////////////////////////
// Property "maximumDeviation"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code maximumDeviation} property.
   * @see #getMaximumDeviation
   * @see #setMaximumDeviation
   */
  public static final Property maximumDeviation = newProperty(Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY, new BStatusNumeric(), null);
  
  /**
   * Get the {@code maximumDeviation} property.
   * @see #maximumDeviation
   */
  public BStatusNumeric getMaximumDeviation() { return (BStatusNumeric)get(maximumDeviation); }
  
  /**
   * Set the {@code maximumDeviation} property.
   * @see #maximumDeviation
   */
  public void setMaximumDeviation(BStatusNumeric v) { set(maximumDeviation, v, null); }

////////////////////////////////////////////////////////////////
// Property "inServiceFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code inServiceFacets} property.
   * @see #getInServiceFacets
   * @see #setInServiceFacets
   */
  public static final Property inServiceFacets = newProperty(0, BFacets.makeBoolean(), null);
  
  /**
   * Get the {@code inServiceFacets} property.
   * @see #inServiceFacets
   */
  public BFacets getInServiceFacets() { return (BFacets)get(inServiceFacets); }
  
  /**
   * Set the {@code inServiceFacets} property.
   * @see #inServiceFacets
   */
  public void setInServiceFacets(BFacets v) { set(inServiceFacets, v, null); }

////////////////////////////////////////////////////////////////
// Property "inService"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code inService} property.
   * @see #getInService
   * @see #setInService
   */
  public static final Property inService = newProperty(Flags.SUMMARY, new BStatusBoolean(), null);
  
  /**
   * Get the {@code inService} property.
   * @see #inService
   */
  public BStatusBoolean getInService() { return (BStatusBoolean)get(inService); }
  
  /**
   * Set the {@code inService} property.
   * @see #inService
   */
  public void setInService(BStatusBoolean v) { set(inService, v, null); }

////////////////////////////////////////////////////////////////
// Property "masterSelected"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code masterSelected} property.
   * @see #getMasterSelected
   * @see #setMasterSelected
   */
  public static final Property masterSelected = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE, false, null);
  
  /**
   * Get the {@code masterSelected} property.
   * @see #masterSelected
   */
  public boolean getMasterSelected() { return getBoolean(masterSelected); }
  
  /**
   * Set the {@code masterSelected} property.
   * @see #masterSelected
   */
  public void setMasterSelected(boolean v) { setBoolean(masterSelected, v, null); }

////////////////////////////////////////////////////////////////
// Property "masterInUse"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code masterInUse} property.
   * @see #getMasterInUse
   * @see #setMasterInUse
   */
  public static final Property masterInUse = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE, BDynamicEnum.make(0), null);
  
  /**
   * Get the {@code masterInUse} property.
   * @see #masterInUse
   */
  public BDynamicEnum getMasterInUse() { return (BDynamicEnum)get(masterInUse); }
  
  /**
   * Set the {@code masterInUse} property.
   * @see #masterInUse
   */
  public void setMasterInUse(BDynamicEnum v) { set(masterInUse, v, null); }

////////////////////////////////////////////////////////////////
// Property "sampleCount"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code sampleCount} property.
   * @see #getSampleCount
   * @see #setSampleCount
   */
  public static final Property sampleCount = newProperty(Flags.SUMMARY, ((BInteger)(BInteger.make(12))).getInt(), BFacets.make(BFacets.make(BFacets.MIN, BInteger.make(2)), BFacets.make(BFacets.MAX, BInteger.make(60))));
  
  /**
   * Get the {@code sampleCount} property.
   * @see #sampleCount
   */
  public int getSampleCount() { return getInt(sampleCount); }
  
  /**
   * Set the {@code sampleCount} property.
   * @see #sampleCount
   */
  public void setSampleCount(int v) { setInt(sampleCount, v, null); }

////////////////////////////////////////////////////////////////
// Property "sampleRate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code sampleRate} property.
   * @see #getSampleRate
   * @see #setSampleRate
   */
  public static final Property sampleRate = newProperty(Flags.SUMMARY, BRelTime.makeSeconds(5), BFacets.make(BFacets.MIN, BRelTime.makeSeconds(1)));
  
  /**
   * Get the {@code sampleRate} property.
   * @see #sampleRate
   */
  public BRelTime getSampleRate() { return (BRelTime)get(sampleRate); }
  
  /**
   * Set the {@code sampleRate} property.
   * @see #sampleRate
   */
  public void setSampleRate(BRelTime v) { set(sampleRate, v, null); }

////////////////////////////////////////////////////////////////
// Property "debug"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code debug} property.
   * @see #getDebug
   * @see #setDebug
   */
  public static final Property debug = newProperty(Flags.HIDDEN, false, null);
  
  /**
   * Get the {@code debug} property.
   * @see #debug
   */
  public boolean getDebug() { return getBoolean(debug); }
  
  /**
   * Set the {@code debug} property.
   * @see #debug
   */
  public void setDebug(boolean v) { setBoolean(debug, v, null); }

////////////////////////////////////////////////////////////////
// Action "calculate"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code calculate} action.
   * @see #calculate()
   */
  public static final Action calculate = newAction(Flags.HIDDEN, null);
  
  /**
   * Invoke the {@code calculate} action.
   * @see #calculate
   */
  public void calculate() { invoke(calculate, null, null); }

////////////////////////////////////////////////////////////////
// Action "reset"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code reset} action.
   * @see #reset()
   */
  public static final Action reset = newAction(Flags.OPERATOR, null);
  
  /**
   * Invoke the {@code reset} action.
   * @see #reset
   */
  public void reset() { invoke(reset, null, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRollingAvg.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

    public void started()
    {
        initialize();
        updateTimer();
    }

    public void stopped()
    {
        // clean up ticket
        if(ticket!=null) ticket.cancel();
    }

    public BFacets getSlotFacets(Slot slot)
    {
        if (slot.equals(input) || slot.equals(out))
        {
            return getFacets();
        }
        else if(slot.equals(averageDeviation) || slot.equals(maximumDeviation))
        {
            return getDeviationFacets();
        }
        else if (slot.equals(propagateFlags))
        {
            return PROPAGATE_FACETS;
        }
        else if(slot.equals(inService))
        {
            return getInServiceFacets();
        }
        else if(slot.equals(masterInUse))
        {
            return BFacets.makeEnum(BEnumRange.make(BInUseEnum.TYPE));
        }
        else return super.getSlotFacets(slot);
    }

    public void changed(Property property, Context context)
    {
        super.changed(property, context);

        if (!Sys.atSteadyState() || !isRunning())
            return;

        if (property.equals(sampleRate))
        {
          updateTimer();
        }
        else if (property.equals(sampleCount))
        {
            initialize();
        }
    }

    void updateTimer()
    {
        if (ticket != null) ticket.cancel();
        BRelTime interval = getSampleRate().getMillis()>=BRelTime.MILLIS_IN_SECOND ? getSampleRate() : DEF_TIME;
        ticket = Clock.schedule(this, interval, calculate, null);
    }

    public void onExecute(BStatusValue out, Context cx)
    {
        if(!isRunning())
            return; // should never get here, but return if we do.

        out.setStatus(averageOutput.getStatus());
        ((BStatusNumeric)out).setValue(averageOutput.getValue());
    }

    public void doReset()
    {
        initialize();
        calculate();
    }

    public void doCalculate()
    {
        updateTimer();

        //Roll out oldest reading, insert newest. work from bottom to top of table
        for(int i = (count-1); i >= 1; i-- )
        {
            sensorSample[i] = sensorSample[i-1];
        }

        // store the current input value in the array
        sensorSample[0] = (BStatusNumeric)getInput().newCopy();
        if(elements<count) elements = elements + 1;

        // initialize variables for each execution
        double total = 0;
        double deviationTotal = 0;
        double deviationMax = Double.NEGATIVE_INFINITY;
        int valid = 0;
        int lastValid = -1;
        BStatus mergedStatus = BStatus.ok;

        //averageOutput.setStatus(BStatus.ok);

        // iterate the elements in the array to calculate COV between each element, rolling avg and propagate status bits
        for(int j = 0; j <= (elements-1); j++)
        {
            if(sensorSample[j].getStatus().isNull() || Double.isInfinite(sensorSample[j].getValue()) || Double.isNaN(sensorSample[j].getValue()))
            {
                // don't process Null, NaN or infinite values
                continue;
            }

            total += sensorSample[j].getValue();

            // propagate status bits from each sample to the working averageOutput
            //averageOutput.setStatus(BStatus.make(averageOutput.getStatus(), sensorSample[j].getStatus().getBits()));
            mergedStatus = BStatus.make(mergedStatus.getBits() | sensorSample[j].getStatus().getBits());

            if(valid>0)
            {
                double deviation = Math.abs(sensorSample[lastValid].getValue() - sensorSample[j].getValue());
                deviationTotal = deviationTotal + deviation;
                if(deviation>deviationMax) deviationMax = deviation;

                if(getDebug()) System.out.println(j + " - value = " + sensorSample[j] + " | deviation = " + deviation);
            }
            else
            {
                if(getDebug()) System.out.println(j + " - value = " + sensorSample[j]);

            }

            valid = valid + 1;
            lastValid=j;
        }

        if(valid>0)
        {
            averageOutput.setValue(total/valid);
            averageOutput.setStatus(propagate(mergedStatus));

            if(valid>1)
            {
                this.set("averageDeviation", new BStatusNumeric((deviationTotal/(valid-1)), BStatus.ok), noExecuteContext);
            }
            else
            {
                this.set("averageDeviation", new BStatusNumeric(Double.NaN, BStatus.nullStatus), noExecuteContext);
            }

        }
        else
        {
            // no valid inputs so need to set out and averageDeviation slots to NaN and null status
            averageOutput.setValue(Double.NaN);
            averageOutput.setStatus(BStatus.nullStatus);

            this.set("averageDeviation", new BStatusNumeric(Double.NaN, BStatus.nullStatus), noExecuteContext);
        }

        this.set("maximumDeviation", new BStatusNumeric(deviationMax), noExecuteContext);

        if(getDebug()) System.out.println("avg = " + averageOutput + " | avgDeviation = " + getAverageDeviation() + " | maxDeviation = " + getMaximumDeviation());

        //doExecute();
    }

    void initialize()
    {
        count = getSampleCount();
        sensorSample = new BStatusNumeric[count];
        elements = 0;
    }

    /**
     * Create a new status by masking out only the standard
     * flags which should be propagated from inputs to outputs.
     * See PROPOGATE_MASK for the flags which are propagated.
     *
     * @return <code>make(s.getBits() & PROPOGATE_MASK)</code>
     */
    public BStatus propagate(BStatus s)
    {
        return BStatus.make(s.getBits() & getPropagateFlags().getBits());
    }

    public BIcon getIcon()
    {
        return icon;
    }

    private static final BIcon icon = BIcon.std("control/math/average.png");

    private static final BFacets PROPAGATE_FACETS =
            BFacets.make(BFacets.FIELD_EDITOR, BString.make("kitControl:PropagateFlagsFE"));

    ////////////////////////////////////////////////
    // local variables
    ////////////////////////////////////////////////

    private Clock.Ticket ticket;
    private BStatusNumeric[] sensorSample;
    private int elements;
    private int count;
    private BStatusNumeric averageOutput = new BStatusNumeric();
    private static BRelTime DEF_TIME = BRelTime.makeSeconds(5);
    static final Context noExecuteContext = new BasicContext();

}
