package com.vykon.vykonPro.hvac;

import com.vykon.vykonPro.enums.BInUseEnum;
import com.vykon.vykonPro.enums.BMasterModeEnum;

import javax.baja.control.BNumericPoint;
import javax.baja.naming.BOrd;
import javax.baja.naming.SlotPath;
import javax.baja.nre.annotations.Facet;
import javax.baja.nre.annotations.NiagaraAction;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.nre.util.Array;
import javax.baja.nre.util.IntHashMap;
import javax.baja.nre.util.TextUtil;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusNumeric;
import javax.baja.status.BStatusValue;
import javax.baja.sys.*;
import javax.baja.units.BUnit;
import javax.baja.util.BFormat;
import javax.baja.util.BNameMap;
import java.util.*;


/**
 * Created by james on 12/21/2018.
 */

@NiagaraType

@NiagaraProperty(
        name = "noValidInput",
        type = "boolean",
        defaultValue = "false",
        flags = Flags.READONLY | Flags.TRANSIENT | Flags.SUMMARY | Flags.OPERATOR
)

@NiagaraProperty(
        name = "deviationFacets",
        type = "BFacets",
        defaultValue = "BFacets.makeNumeric(BUnit.DEFAULT, 1)"
)

@NiagaraProperty(
        name = "maximumDeviation",
        type = "BStatusNumeric",
        defaultValue = "new BStatusNumeric()",
        flags = Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY | Flags.OPERATOR
)

@NiagaraProperty(
        name = "maximumDeviationInput",
        type = "String",
        defaultValue = "",
        flags = Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY | Flags.OPERATOR
)

@NiagaraProperty(
        name = "configStatus",
        type = "BStatus",
        defaultValue = "BStatus.DEFAULT",
        flags = Flags.READONLY
)
@NiagaraProperty(
        name = "faultCause",
        type = "String",
        defaultValue = "",
        flags = Flags.READONLY
)

@NiagaraProperty(
        name = "selectFault",
        type = "boolean",
        defaultValue = "false",
        flags = Flags.READONLY | Flags.HIDDEN
)

@NiagaraProperty(
        name = "inputFault",
        type = "boolean",
        defaultValue = "false",
        flags = Flags.READONLY | Flags.HIDDEN
)

@NiagaraProperty(
        name = "mode",
        type = "BDynamicEnum",
        defaultValue = "BDynamicEnum.make(0)",
        flags = Flags.OPERATOR
)

@NiagaraProperty(
        name = "propagateFlags",
        type = "BStatus",
        defaultValue = "BStatus.ok"
)

@NiagaraProperty(
        name = "numberOfInputs",
        type = "int",
        defaultValue = "0",
        facets =
        {
          @Facet(name = "BFacets.MIN", value = "BInteger.make(0)"),
          @Facet(name = "BFacets.MAX", value = "BInteger.make(50)")
        }
)

@NiagaraProperty(
        name = "inputSlotName",
        type = "String",
        defaultValue = "input"
)

@NiagaraProperty(
        name = "singleInputSelect",
        type = "BDynamicEnum",
        defaultValue = "BDynamicEnum.make(1)",
        flags = Flags.READONLY | Flags.OPERATOR
)

@NiagaraProperty(
        name = "multipleInputSelect",
        type = "BEnumRange",
        defaultValue = "BEnumRange.DEFAULT",
        flags = Flags.READONLY | Flags.OPERATOR,
        facets =
                {
                        @Facet(name = "BFacets.FIELD_EDITOR", value = "\"alarm:EnumAlarmRangeFE\""),
                        @Facet(name = "BFacets.UX_FIELD_EDITOR", value = "\"alarm:EnumAlarmRangeEditor\"")
                }
)

@NiagaraProperty(
        name = "ignoreInFault",
        type = "boolean",
        defaultValue = "true"
)

@NiagaraProperty(
        name = "ignoreInAlarm",
        type = "boolean",
        defaultValue = "false"
)

@NiagaraAction(
        name = "setSingleInput",
        parameterType = "BDynamicEnum",
        defaultValue = "BDynamicEnum.make(1)",
        flags = Flags.OPERATOR
)

@NiagaraAction(
        name = "setMultipleInput",
        parameterType = "BEnumRange",
        defaultValue = "BEnumRange.DEFAULT",
        flags = Flags.OPERATOR,
        facets =
        {
                @Facet(name = "BFacets.FIELD_EDITOR", value = "\"alarm:EnumAlarmRangeFE\""),
                @Facet(name = "BFacets.UX_FIELD_EDITOR", value = "\"alarm:EnumAlarmRangeEditor\"")
        }
)


public class BRollingAvgMaster
    extends BNumericPoint
{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BRollingAvgMaster(3465480770)1.0$ @*/
/* Generated Thu Feb 14 15:29:41 EST 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "noValidInput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code noValidInput} property.
   * @see #getNoValidInput
   * @see #setNoValidInput
   */
  public static final Property noValidInput = newProperty(Flags.READONLY | Flags.TRANSIENT | Flags.SUMMARY| Flags.OPERATOR, false, null);
  
  /**
   * Get the {@code noValidInput} property.
   * @see #noValidInput
   */
  public boolean getNoValidInput() { return getBoolean(noValidInput); }
  
  /**
   * Set the {@code noValidInput} property.
   * @see #noValidInput
   */
  public void setNoValidInput(boolean v) { setBoolean(noValidInput, v, null); }

////////////////////////////////////////////////////////////////
// Property "deviationFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code deviationFacets} property.
   * @see #getDeviationFacets
   * @see #setDeviationFacets
   */
  public static final Property deviationFacets = newProperty(0, BFacets.makeNumeric(BUnit.DEFAULT, 1), null);
  
  /**
   * Get the {@code deviationFacets} property.
   * @see #deviationFacets
   */
  public BFacets getDeviationFacets() { return (BFacets)get(deviationFacets); }
  
  /**
   * Set the {@code deviationFacets} property.
   * @see #deviationFacets
   */
  public void setDeviationFacets(BFacets v) { set(deviationFacets, v, null); }

////////////////////////////////////////////////////////////////
// Property "maximumDeviation"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code maximumDeviation} property.
   * @see #getMaximumDeviation
   * @see #setMaximumDeviation
   */
  public static final Property maximumDeviation = newProperty(Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY| Flags.OPERATOR, new BStatusNumeric(), null);
  
  /**
   * Get the {@code maximumDeviation} property.
   * @see #maximumDeviation
   */
  public BStatusNumeric getMaximumDeviation() { return (BStatusNumeric)get(maximumDeviation); }
  
  /**
   * Set the {@code maximumDeviation} property.
   * @see #maximumDeviation
   */
  public void setMaximumDeviation(BStatusNumeric v) { set(maximumDeviation, v, null); }

////////////////////////////////////////////////////////////////
// Property "maximumDeviationInput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code maximumDeviationInput} property.
   * @see #getMaximumDeviationInput
   * @see #setMaximumDeviationInput
   */
  public static final Property maximumDeviationInput = newProperty(Flags.SUMMARY | Flags.TRANSIENT | Flags.READONLY| Flags.OPERATOR, "", null);
  
  /**
   * Get the {@code maximumDeviationInput} property.
   * @see #maximumDeviationInput
   */
  public String getMaximumDeviationInput() { return getString(maximumDeviationInput); }
  
  /**
   * Set the {@code maximumDeviationInput} property.
   * @see #maximumDeviationInput
   */
  public void setMaximumDeviationInput(String v) { setString(maximumDeviationInput, v, null); }

////////////////////////////////////////////////////////////////
// Property "configStatus"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code configStatus} property.
   * @see #getConfigStatus
   * @see #setConfigStatus
   */
  public static final Property configStatus = newProperty(Flags.READONLY, BStatus.DEFAULT, null);
  
  /**
   * Get the {@code configStatus} property.
   * @see #configStatus
   */
  public BStatus getConfigStatus() { return (BStatus)get(configStatus); }
  
  /**
   * Set the {@code configStatus} property.
   * @see #configStatus
   */
  public void setConfigStatus(BStatus v) { set(configStatus, v, null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code faultCause} property.
   * @see #getFaultCause
   * @see #setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY, "", null);
  
  /**
   * Get the {@code faultCause} property.
   * @see #faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the {@code faultCause} property.
   * @see #faultCause
   */
  public void setFaultCause(String v) { setString(faultCause, v, null); }

////////////////////////////////////////////////////////////////
// Property "selectFault"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code selectFault} property.
   * @see #getSelectFault
   * @see #setSelectFault
   */
  public static final Property selectFault = newProperty(Flags.READONLY | Flags.HIDDEN, false, null);
  
  /**
   * Get the {@code selectFault} property.
   * @see #selectFault
   */
  public boolean getSelectFault() { return getBoolean(selectFault); }
  
  /**
   * Set the {@code selectFault} property.
   * @see #selectFault
   */
  public void setSelectFault(boolean v) { setBoolean(selectFault, v, null); }

////////////////////////////////////////////////////////////////
// Property "inputFault"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code inputFault} property.
   * @see #getInputFault
   * @see #setInputFault
   */
  public static final Property inputFault = newProperty(Flags.READONLY | Flags.HIDDEN, false, null);
  
  /**
   * Get the {@code inputFault} property.
   * @see #inputFault
   */
  public boolean getInputFault() { return getBoolean(inputFault); }
  
  /**
   * Set the {@code inputFault} property.
   * @see #inputFault
   */
  public void setInputFault(boolean v) { setBoolean(inputFault, v, null); }

////////////////////////////////////////////////////////////////
// Property "mode"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code mode} property.
   * @see #getMode
   * @see #setMode
   */
  public static final Property mode = newProperty(Flags.OPERATOR, BDynamicEnum.make(0), null);
  
  /**
   * Get the {@code mode} property.
   * @see #mode
   */
  public BDynamicEnum getMode() { return (BDynamicEnum)get(mode); }
  
  /**
   * Set the {@code mode} property.
   * @see #mode
   */
  public void setMode(BDynamicEnum v) { set(mode, v, null); }

////////////////////////////////////////////////////////////////
// Property "propagateFlags"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code propagateFlags} property.
   * @see #getPropagateFlags
   * @see #setPropagateFlags
   */
  public static final Property propagateFlags = newProperty(0, BStatus.ok, null);
  
  /**
   * Get the {@code propagateFlags} property.
   * @see #propagateFlags
   */
  public BStatus getPropagateFlags() { return (BStatus)get(propagateFlags); }
  
  /**
   * Set the {@code propagateFlags} property.
   * @see #propagateFlags
   */
  public void setPropagateFlags(BStatus v) { set(propagateFlags, v, null); }

////////////////////////////////////////////////////////////////
// Property "numberOfInputs"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code numberOfInputs} property.
   * @see #getNumberOfInputs
   * @see #setNumberOfInputs
   */
  public static final Property numberOfInputs = newProperty(0, 0, BFacets.make(BFacets.make(BFacets.MIN, BInteger.make(0)), BFacets.make(BFacets.MAX, BInteger.make(50))));
  
  /**
   * Get the {@code numberOfInputs} property.
   * @see #numberOfInputs
   */
  public int getNumberOfInputs() { return getInt(numberOfInputs); }
  
  /**
   * Set the {@code numberOfInputs} property.
   * @see #numberOfInputs
   */
  public void setNumberOfInputs(int v) { setInt(numberOfInputs, v, null); }

////////////////////////////////////////////////////////////////
// Property "inputSlotName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code inputSlotName} property.
   * @see #getInputSlotName
   * @see #setInputSlotName
   */
  public static final Property inputSlotName = newProperty(0, "input", null);
  
  /**
   * Get the {@code inputSlotName} property.
   * @see #inputSlotName
   */
  public String getInputSlotName() { return getString(inputSlotName); }
  
  /**
   * Set the {@code inputSlotName} property.
   * @see #inputSlotName
   */
  public void setInputSlotName(String v) { setString(inputSlotName, v, null); }

////////////////////////////////////////////////////////////////
// Property "singleInputSelect"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code singleInputSelect} property.
   * @see #getSingleInputSelect
   * @see #setSingleInputSelect
   */
  public static final Property singleInputSelect = newProperty(Flags.READONLY | Flags.OPERATOR, BDynamicEnum.make(1), null);
  
  /**
   * Get the {@code singleInputSelect} property.
   * @see #singleInputSelect
   */
  public BDynamicEnum getSingleInputSelect() { return (BDynamicEnum)get(singleInputSelect); }
  
  /**
   * Set the {@code singleInputSelect} property.
   * @see #singleInputSelect
   */
  public void setSingleInputSelect(BDynamicEnum v) { set(singleInputSelect, v, null); }

////////////////////////////////////////////////////////////////
// Property "multipleInputSelect"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code multipleInputSelect} property.
   * @see #getMultipleInputSelect
   * @see #setMultipleInputSelect
   */
  public static final Property multipleInputSelect = newProperty(Flags.READONLY | Flags.OPERATOR, BEnumRange.DEFAULT, BFacets.make(BFacets.make(BFacets.FIELD_EDITOR, "alarm:EnumAlarmRangeFE"), BFacets.make(BFacets.UX_FIELD_EDITOR, "alarm:EnumAlarmRangeEditor")));
  
  /**
   * Get the {@code multipleInputSelect} property.
   * @see #multipleInputSelect
   */
  public BEnumRange getMultipleInputSelect() { return (BEnumRange)get(multipleInputSelect); }
  
  /**
   * Set the {@code multipleInputSelect} property.
   * @see #multipleInputSelect
   */
  public void setMultipleInputSelect(BEnumRange v) { set(multipleInputSelect, v, null); }

////////////////////////////////////////////////////////////////
// Property "ignoreInFault"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code ignoreInFault} property.
   * @see #getIgnoreInFault
   * @see #setIgnoreInFault
   */
  public static final Property ignoreInFault = newProperty(0, true, null);
  
  /**
   * Get the {@code ignoreInFault} property.
   * @see #ignoreInFault
   */
  public boolean getIgnoreInFault() { return getBoolean(ignoreInFault); }
  
  /**
   * Set the {@code ignoreInFault} property.
   * @see #ignoreInFault
   */
  public void setIgnoreInFault(boolean v) { setBoolean(ignoreInFault, v, null); }

////////////////////////////////////////////////////////////////
// Property "ignoreInAlarm"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code ignoreInAlarm} property.
   * @see #getIgnoreInAlarm
   * @see #setIgnoreInAlarm
   */
  public static final Property ignoreInAlarm = newProperty(0, false, null);
  
  /**
   * Get the {@code ignoreInAlarm} property.
   * @see #ignoreInAlarm
   */
  public boolean getIgnoreInAlarm() { return getBoolean(ignoreInAlarm); }
  
  /**
   * Set the {@code ignoreInAlarm} property.
   * @see #ignoreInAlarm
   */
  public void setIgnoreInAlarm(boolean v) { setBoolean(ignoreInAlarm, v, null); }

////////////////////////////////////////////////////////////////
// Action "setSingleInput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code setSingleInput} action.
   * @see #setSingleInput(BDynamicEnum parameter)
   */
  public static final Action setSingleInput = newAction(Flags.OPERATOR, BDynamicEnum.make(1), null);
  
  /**
   * Invoke the {@code setSingleInput} action.
   * @see #setSingleInput
   */
  public void setSingleInput(BDynamicEnum parameter) { invoke(setSingleInput, parameter, null); }

////////////////////////////////////////////////////////////////
// Action "setMultipleInput"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code setMultipleInput} action.
   * @see #setMultipleInput(BEnumRange parameter)
   */
  public static final Action setMultipleInput = newAction(Flags.OPERATOR, BEnumRange.DEFAULT, BFacets.make(BFacets.make(BFacets.FIELD_EDITOR, "alarm:EnumAlarmRangeFE"), BFacets.make(BFacets.UX_FIELD_EDITOR, "alarm:EnumAlarmRangeEditor")));
  
  /**
   * Invoke the {@code setMultipleInput} action.
   * @see #setMultipleInput
   */
  public void setMultipleInput(BEnumRange parameter) { invoke(setMultipleInput, parameter, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BRollingAvgMaster.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public void started()
  {
    lastInputName = getInputSlotName();
    inputSub = new MySubscriber();
    initArray();
  }

  public void stopped()
  {
    if(inputSub!=null)
    {
      inputSub.unsubscribeAll();
      inputSub = null;
    }
  }

  public void changed(Property prop, Context cx)
  {
    if(!isRunning()) return;

    if(prop.equals(numberOfInputs))
    {
      initSlots();
    }
    else if(prop.equals(inputSlotName))
    {
      updateSlots();
    }
    else if(prop.equals(mode) || prop.equals(singleInputSelect))
    {
      initArray();
      calculate();
    }
    else if(prop.equals(multipleInputSelect))
    {
      checkConfig();
      initArray();
      calculate();
    }
    else if(prop.getName().startsWith(SlotPath.escape(getInputSlotName())))
    {
      checkInput(prop.getName());
      initArray();
    }
  }

  // initialize comps array based on input ords
  private void initArray()
  {
    comps = new BRollingAvg[getNumberOfInputs()];
    inUse = new BDynamicEnum[getNumberOfInputs()];
    if(inputSub!=null) inputSub.unsubscribeAll();
    int[] selectedOrdinals = getMultipleInputSelect().getOrdinals();
    // subtract 1 from the ordinal value because the comps array is zero based
    int singleSelected = getSingleInputSelect().getOrdinal();
    int mode = getMode().getOrdinal();

    for(int i=1; i<=getNumberOfInputs(); i++)
    {
      boolean selected = false;
      String slotName = SlotPath.escape(getInputSlotName()) + i;
      BOrd objOrd = (BOrd)get(slotName);
      if(objOrd!=BOrd.DEFAULT)
      {
        BObject object = objOrd.resolve().get();
        if(object instanceof BRollingAvg)
        {
          BRollingAvg comp = (BRollingAvg)object;
          comps[i-1] = comp;

          // TODO evaluate impact of subscribing all inputs versus only required inputs
          inputSub.subscribe(comps[i-1]);

          if(mode==BMasterModeEnum.SINGLE_INPUT)
          {
            if(i==singleSelected) selected = true;
          }
          else if(mode==BMasterModeEnum.MULTIPLE_INPUT)
          {
            for(int j=0; j<selectedOrdinals.length; j++)
            {
              if(selectedOrdinals[j]==i)
              {
                selected = true;
                break;
              }
            }
          }
          else
          {
            // All Inputs
            selected = true;
          }

          comp.setMasterSelected(selected);
        }
        else
        {
          comps[i-1] = null;
        }
      }
    }
  }


  // create a BEnumRange with ordinals starting at 1 and include
  // an ordinal for each input slot on the component
  private BEnumRange makeRange()
  {
    //check the number of existing slots
    int numSlots = getNumberOfInputs();

    if(numSlots>0)
    {
      String[] tags = new String[numSlots];
      int[] ordinals = new int[numSlots];
      for(int i=0; i<numSlots; i++)
      {
        Slot s = getSlot(SlotPath.escape(getInputSlotName()+(i+1)));
        tags[i] = SlotPath.escape(getDisplayName(s, null));
        ordinals[i] = (i+1);
      }

      return BEnumRange.make(ordinals, tags);
    }

    else return BEnumRange.DEFAULT;
  }

  public void onExecute(BStatusValue out, Context cx)
  {
    if(!isRunning())
      return; // should never get here, but return if we do.

    BStatus fault = BStatus.makeFault(BStatus.DEFAULT, (getInputFault() || getSelectFault()));
    setConfigStatus(fault);

    out.setStatus(averageOutput.getStatus());
    ((BStatusNumeric)out).setValue(averageOutput.getValue());
  }

  public void calculate()
  {
    int mode = getMode().getOrdinal();
    boolean success = false;

    // initialize inUse array as false
    for(int i=0; i<getNumberOfInputs(); i++)
    {
      inUse[i] = BDynamicEnum.make(BInUseEnum.NO);
    }

    if(mode==BMasterModeEnum.SINGLE_INPUT)
    {
      // don't use maxDeviation in this mode, so clear slot values
      getMaximumDeviation().setValue(Double.NaN);
      setMaximumDeviationInput("");

      // subtract 1 from the ordinal value because the comps array is zero based
      int selected = getSingleInputSelect().getOrdinal()-1;

      if(comps[selected]!=null && checkInputValid(selected))
      {
        // input is valid so just set averageOutput
        averageOutput.setValue(comps[selected].getOut().getValue());
        averageOutput.setStatus(propagate(comps[selected].getStatus()));
        fallback = -1;
        success = true;
        inUse[selected]=BDynamicEnum.make(BInUseEnum.YES);
      }
      else
      {
        // input is not valid to use, if fallback!=-1 use latched fallback input
        if(fallback!=-1 && comps[fallback]!=null && checkInputValid(fallback))
        {
          averageOutput.setValue(comps[fallback].getOut().getValue());
          averageOutput.setStatus(propagate(comps[fallback].getStatus()));
          success = true;
          inUse[fallback]=BDynamicEnum.make(BInUseEnum.YES);
        }
        else
        {
          // fallback isn't set yet, or the fallback input is invalid so iterate inputs and use input with lowest valid input value
          double min = Double.POSITIVE_INFINITY;
          boolean fallbackChanged = false;

          for(int i=0; i<getNumberOfInputs(); i++)
          {
            // this is the failed selected or fallback item, so skip
            if(i==selected || i==fallback) continue;

            if(comps[i]!=null && checkInputValid(i))
            {
              if(comps[i].getOut().getValue()<min)
              {
                min = comps[i].getOut().getValue();
                fallback=i;
                fallbackChanged = true;
              }
            }

            if(fallbackChanged)
            {
              // found a new valid fallback input
              averageOutput.setValue(comps[fallback].getOut().getValue());
              averageOutput.setStatus(propagate(comps[fallback].getStatus()));
              success = true;
              inUse[fallback]=BDynamicEnum.make(BInUseEnum.YES);
            }
            else
            {
              // no valid input available
            }
          }
        } // end else for new fallback evaluation
      }
    } // end if SINGLE_INPUT mode
    else if(mode==BMasterModeEnum.MULTIPLE_INPUT)
    {
      // TODO consider using a fallback mechanism or just fail if all multi-selected are invalid
      int[] selectedInputs = getMultipleInputSelect().getOrdinals();
      double total = 0;
      double validCount = 0;
      double average = 0;
      BStatus mergedStatus = BStatus.ok;
      double maxDeviation = Double.NEGATIVE_INFINITY;
      int maxLookup = -1;

      // iterate through selected inputs and calculate the total and count of valid inputs
      for(int i=0; i<selectedInputs.length; i++)
      {
        // subtract 1 from ordinal because comps array is zero based
        int lookup = selectedInputs[i] - 1;
        if(comps[lookup]!=null && checkInputValid(lookup))
        {
          total = total + comps[lookup].getOut().getValue();
          validCount = validCount + 1;
          inUse[lookup]=BDynamicEnum.make(BInUseEnum.YES);
        }
      }

      if(validCount>0)
      {
        // if three or more valid inputs, only use n-1 inputs so find input with maximum deviation
        if(validCount>2)
        {

          average = total/validCount;

          // first pass to find the input with largest deviation
          for(int i=0; i<selectedInputs.length; i++)
          {
            // subtract 1 from ordinal because comps array is zero based
            int lookup = selectedInputs[i] - 1;
            if(comps[lookup]!=null && checkInputValid(lookup))
            {
              double value = comps[lookup].getOut().getValue();
              if(Math.abs(value-average)>maxDeviation)
              {
                maxDeviation = Math.abs(value-average);
                maxLookup = lookup;
              }
            }
          }
        }

        // second pass to merge status and subtract input with max deviation from total
        for(int i=0; i<selectedInputs.length; i++)
        {
          // subtract 1 from ordinal because comps array is zero based
          int lookup = selectedInputs[i] - 1;
          if(comps[lookup]!=null && checkInputValid(lookup))
          {
            // subtract input with max deviation from total
            if(lookup==maxLookup)
            {
              total = total - comps[lookup].getOut().getValue();
              validCount = validCount -1;
              inUse[lookup]=BDynamicEnum.make(BInUseEnum.DEVIATION);
            }
            else
            {
              // propagate status bits from each sample to the working averageOutput
              mergedStatus = BStatus.make(mergedStatus.getBits() | comps[lookup].getStatus().getBits());
            }
          }
        }

        // have more at least 1 valid input, so calculate average
        averageOutput.setValue(total/validCount);
        averageOutput.setStatus(propagate(mergedStatus));
        success = true;

        if(maxLookup!=-1)
        {
          getMaximumDeviation().setValue(Math.abs((total/validCount)-comps[maxLookup].getOut().getValue()));
          setMaximumDeviationInput(comps[maxLookup].getDisplayName(null));
        }
        else
        {
          getMaximumDeviation().setValue(Double.NaN);
          setMaximumDeviationInput("");
        }
      }
      else
      {
        // no valid inputs
        getMaximumDeviation().setValue(Double.NaN);
        setMaximumDeviationInput("");
      }
    }
    else
    {
      // must be All_INPUTS, just make sure they are not null and not invalid and calculate average
      double total = 0;
      int validCount = 0;
      BStatus mergedStatus = BStatus.ok;

      // don't use maxDeviation in this mode, so clear slot values
      getMaximumDeviation().setValue(Double.NaN);
      setMaximumDeviationInput("");

      for(int i=0; i<getNumberOfInputs(); i++)
      {
        if(comps[i]!=null && checkInputValid(i))
        {
          total = total + comps[i].getOut().getValue();
          validCount = validCount+1;
          inUse[i]=BDynamicEnum.make(BInUseEnum.YES);

          // propagate status bits from each sample to the working averageOutput
          mergedStatus = BStatus.make(mergedStatus.getBits() | comps[i].getStatus().getBits());
        }
      }

      if(validCount>0)
      {
        averageOutput.setValue(total/validCount);
        averageOutput.setStatus(propagate(mergedStatus));
        success = true;
      }
      else
      {
        // no valid input available
      }
    }

    setNoValidInput(!success);

    // update masterInUse in RollingAvg components
    for(int i=0; i<getNumberOfInputs(); i++)
    {
      comps[i].setMasterInUse(inUse[i]);
    }

    doExecute();
  }

  public void doSetSingleInput(BDynamicEnum value)
  {
    setSingleInputSelect(value);
  }

  public void doSetMultipleInput(BEnumRange value)
  {
    setMultipleInputSelect(value);
  }

  public BValue getActionParameterDefault(Action action)
  {
    if(action==setSingleInput)
    {
      return BDynamicEnum.make(getSingleInputSelect().getOrdinal(), makeActionRange());
    }
    else if(action==setMultipleInput)
    {
      return getMultipleInputSelect();
    }

    return super.getActionParameterDefault(action);
  }

  // create a BEnumRange with ordinals starting at 1 and include
  // an ordinal for each input slot on the component which is valid
  private BEnumRange makeActionRange()
  {
    //check the number of existing slots
    int numSlots = getNumberOfInputs();
    ArrayList<Integer> ordinals = new ArrayList<Integer>();
    ArrayList<String> tags = new ArrayList<String>();

    if(numSlots>0)
    {
      for(int i=0; i<numSlots; i++)
      {
        BOrd ord = (BOrd)get(SlotPath.escape(getInputSlotName()+(i+1)));
        if(ord!=BOrd.DEFAULT)
        {
          BObject obj = ord.resolve(this).get();
          if(obj!=null && obj instanceof BRollingAvg)
          {
            BRollingAvg input = (BRollingAvg)obj;
            if(input.getInService().getValue() &&
                    !Double.isNaN(input.getOut().getValue()) &&
                    !(getIgnoreInAlarm() && input.getStatus().isAlarm()) &&
                    !(getIgnoreInFault() && input.getStatus().isFault()))
            {
              Slot s = getSlot(SlotPath.escape(getInputSlotName()+(i+1)));
              tags.add(SlotPath.escape(getDisplayName(s, null)));
              ordinals.add((i+1));
            }
          }
        }
      }

      String[] tag = new String[tags.size()];
      tag = tags.toArray(tag);

      int[] ordinal = ordinals.stream().mapToInt(i -> i).toArray();
      BEnumRange range = BEnumRange.make(ordinal, tags.toArray(tag));

      BFacets actionFacets = BFacets.make(ACTION_FACETS, BFacets.makeEnum(range));
      setFacets(getSlot("setMultipleInput"), actionFacets);

      return range;
    }

    else return BEnumRange.DEFAULT;
  }


  public BStatus propagate(BStatus s)
  {
    return BStatus.make(s.getBits() & getPropagateFlags().getBits());
  }

  private boolean checkInputValid(int ordinal)
  {
    BRollingAvg input = comps[ordinal];

    // return true if BRollingAvg inService and not in alarm or fault
    boolean valid = (input.getInService().getValue() &&
            !Double.isNaN(input.getOut().getValue()) &&
            !(getIgnoreInAlarm() && input.getStatus().isAlarm()) &&
            !(getIgnoreInFault() && input.getStatus().isFault()));

    if(!valid) inUse[ordinal]=BDynamicEnum.make(BInUseEnum.INVALID);

    return valid;
  }

  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(singleInputSelect))
    {
      return BFacets.makeEnum(makeRange());
    }
    else if(slot.equals(multipleInputSelect))
    {
      return BFacets.make(BFacets.makeEnum(makeRange()), super.getSlotFacets(slot));
    }
    else if(slot.equals(mode))
    {
      return BFacets.makeEnum(BEnumRange.make(BMasterModeEnum.TYPE));
    }
    else if (slot.equals(propagateFlags))
    {
      return PROPAGATE_FACETS;
    }
    else if(slot.equals(maximumDeviation))
    {
      return getDeviationFacets();
    }
    else return super.getSlotFacets(slot);
  }

  // add or remove slots because of numberOfInputs value change
  public void initSlots()
  {
    //check the required number of links
    int numOrds = getNumberOfInputs();

    //check the number of existing slots
    int numSlots = this.getChildren(BOrd.class).length;

    //need to decide if adding or removing links
    if(numOrds > numSlots)
    {
      //we are adding more links
      for(int i=1; i<=numOrds; i++)
      {
        if(i>numSlots)
        {
          //gotten to the ones that we need to add
          String slotName = SlotPath.escape(getInputSlotName()) + i;
          this.add(slotName, makeDefaultOrd());
        }
      }
    }
    else if(numOrds < numSlots)
    {
      HashMap map = new HashMap();

      //we are removing links
      for(int i=1; i<=numSlots; i++) //int i=0; i<lastNumLinks; i++
      {
        if(i>numOrds)
        {
          //gotten to the ones that we need to remove
          String slotName = SlotPath.escape(getInputSlotName()) + i;
          this.remove(slotName);
          map.put(slotName, BFormat.make(slotName));
        }
      }
      updateDisplayNames(map, false);
    }

    initArray();
  }

  // update input slots because of inputSlotName value change
  public void updateSlots()
  {
    BNameMap currentMap = BNameMap.DEFAULT;
    boolean existingMap = false;
    String[] keys = new String[0];
    if(get("displayNames")!=null)
    {
      existingMap = true;
      currentMap = (BNameMap)get("displayNames");
      keys = currentMap.list();
    }

    for(int i=1; i<=getNumberOfInputs(); i++)
    {
      String slotName = SlotPath.escape(getInputSlotName()) + i;
      String oldSlotName = lastInputName+i;
      rename(getProperty(oldSlotName), slotName);
      if (existingMap)
      {
        for(int j=0; j<keys.length; j++)
        {
          if(keys[j].equals(oldSlotName))
          {
            BFormat format = currentMap.get(oldSlotName);
            currentMap = BNameMap.remove(currentMap, oldSlotName);
            currentMap = BNameMap.make(currentMap, slotName, format);
          }
        }
      }
    }

    if(existingMap) set("displayNames", currentMap);
    lastInputName = SlotPath.escape(getInputSlotName());
  }

  private void updateDisplayNames(HashMap map, boolean add)
  {
    if(get("displayNames")!=null)
    {
      // the slot exists so update
      BNameMap current = (BNameMap)get("displayNames");

      if(!add)
      {
        // removing entries
        Iterator cursor = map.keySet().iterator();
        while(cursor.hasNext())
        {
          current = BNameMap.remove(current, cursor.next().toString());
        }
        this.set("displayNames", current);
      }
    }
  }

  private static BOrd makeDefaultOrd()
  {
    BOrd o = BOrd.NULL;
    return o;
  }

  // called when multipleInputSelect changed
  private void checkConfig()
  {
    // check there is at least one input selected in the multipleInputSelect and the
    // ord is not null, references a BRollinAvg component and inService is true
    int validSelected = 0;
    int[] selectedOrdinals = getMultipleInputSelect().getOrdinals();

    // nothing selected so just bail and set fault cause
    if(selectedOrdinals.length==0)
    {
      setFaultCause("Multiple Input Selection must have at least one input selected.");
      setSelectFault(true);
      doExecute();
      return;
    }

    BOrd checkOrd;
    BObject comp;
    // check ords for selected inputs are not null and reference a BRollingAvg component
    for(int i=0; i<selectedOrdinals.length; i++)
    {
      checkOrd = (BOrd)get(SlotPath.escape(getInputSlotName())+selectedOrdinals[i]);
      if(checkOrd.equals(BOrd.DEFAULT))
      {
        setFaultCause(SlotPath.escape(getInputSlotName())+selectedOrdinals[i] + " ord is not configured");
        setSelectFault(true);
        doExecute();
        return;
      }
      else
      {
        comp = checkOrd.resolve().get();
        if(comp==null || !(comp instanceof BRollingAvg))
        {
          setFaultCause(SlotPath.escape(getInputSlotName())+selectedOrdinals[i] + " ord does not resolve to a RollingAvg component.");
          setSelectFault(true);
          doExecute();
          return;
        }
      }
    }

    setFaultCause("");
    setSelectFault(false);
    doExecute();
  }

  private void checkInput(String input)
  {
    // check the ord references a BRollingAvg component
    BOrd checkOrd = (BOrd)get(input);
    if(checkOrd==BOrd.DEFAULT)
    {
      setFaultCause(input + " ord is not configured");
      setInputFault(true);
      doExecute();
      return;
    }
    else
    {
      BObject comp = checkOrd.resolve().get();
      if(comp==null || !(comp instanceof BRollingAvg))
      {
        setFaultCause(input + " ord does not resolve to a RolllingAvg component");
        setInputFault(true);
        doExecute();
        return;
      }
    }

    BOrd inputOrd;
    for(int i=1; i<=getNumberOfInputs(); i++)
    {
      String slotName = SlotPath.escape(getInputSlotName()) + i;

      if(!slotName.equals(input))
      {
        inputOrd = (BOrd)get(slotName);
        if(inputOrd.equals(checkOrd))
        {
          setFaultCause(input + " ord is configured the same as " + slotName);
          setInputFault(true);
          doExecute();
          return;
        }
      }

    }

    setFaultCause("");
    setInputFault(false);

    // call doExecute() to update status
    doExecute();
  }



  private String lastInputName;
  private BStatusNumeric averageOutput = new BStatusNumeric();
  private MySubscriber inputSub;
  private BRollingAvg[] comps;
  private BDynamicEnum[] inUse;
  private int fallback = -1;

  private static final BFacets PROPAGATE_FACETS =
          BFacets.make(BFacets.FIELD_EDITOR, BString.make("kitControl:PropagateFlagsFE"));

  private static final BFacets ACTION_FACETS =
          BFacets.make(BFacets.FIELD_EDITOR, BString.make("alarm:EnumAlarmRangeFE"),
                  BFacets.UX_FIELD_EDITOR, BString.make("alarm:EnumAlarmRangeEditor"));

  /////////////////////////////////////////////////////////////
  // inner classes
  /////////////////////////////////////////////////////////////

  public class MySubscriber extends Subscriber
  {
    public void event (BComponentEvent event)
    {
      if(event.getId()==BComponentEvent.PROPERTY_CHANGED && event.getSlotName().equals("out"))
      {
        calculate();
      }
    }
  }

}
