package com.vykon.vykonPro.hvac;

import javax.baja.status.BStatus;
import javax.baja.status.BStatusNumeric;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDouble;
import javax.baja.sys.BFacets;
import javax.baja.sys.Cursor;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.sys.Subscriber;
import javax.baja.sys.BComponentEvent;

import java.util.ArrayList;

public class BSatisfiedZoneBql
    extends BMinMaxAvgBql
{
  /*-
   class BSatisfiedZoneBql
   {
     properties
     {
       upperLimit: BStatusNumeric
         -- The upper limit used when evaluating a zone's compliance.
         default{[ new BStatusNumeric(80) ]}
         flags{ operator }
         
       lowerLimit: BStatusNumeric
         -- The lower limit used when evaluating a zone's compliance.
         default{[ new BStatusNumeric(60) ]}
         flags{ operator }
         
       satisfiedZones: int
         -- The number of zones processed whose value is within the upper and lower limits.
         default{[ 0 ]}
         flags{ readonly, transient }
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.hvac.BSatisfiedZoneBql(3352752520)1.0$ @*/
/* Generated Mon Mar 07 11:38:14 EST 2011 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "upperLimit"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>upperLimit</code> property.
   * The upper limit used when evaluating a zone's compliance.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#getUpperLimit
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#setUpperLimit
   */
  public static final Property upperLimit = newProperty(Flags.OPERATOR, new BStatusNumeric(80),null);
  
  /**
   * Get the <code>upperLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#upperLimit
   */
  public BStatusNumeric getUpperLimit() { return (BStatusNumeric)get(upperLimit); }
  
  /**
   * Set the <code>upperLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#upperLimit
   */
  public void setUpperLimit(BStatusNumeric v) { set(upperLimit,v,null); }

////////////////////////////////////////////////////////////////
// Property "lowerLimit"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lowerLimit</code> property.
   * The lower limit used when evaluating a zone's compliance.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#getLowerLimit
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#setLowerLimit
   */
  public static final Property lowerLimit = newProperty(Flags.OPERATOR, new BStatusNumeric(60),null);
  
  /**
   * Get the <code>lowerLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#lowerLimit
   */
  public BStatusNumeric getLowerLimit() { return (BStatusNumeric)get(lowerLimit); }
  
  /**
   * Set the <code>lowerLimit</code> property.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#lowerLimit
   */
  public void setLowerLimit(BStatusNumeric v) { set(lowerLimit,v,null); }

////////////////////////////////////////////////////////////////
// Property "satisfiedZones"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>satisfiedZones</code> property.
   * The number of zones processed whose value is within
   * the upper and lower limits.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#getSatisfiedZones
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#setSatisfiedZones
   */
  public static final Property satisfiedZones = newProperty(Flags.READONLY|Flags.TRANSIENT, 0,null);
  
  /**
   * Get the <code>satisfiedZones</code> property.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#satisfiedZones
   */
  public int getSatisfiedZones() { return getInt(satisfiedZones); }
  
  /**
   * Set the <code>satisfiedZones</code> property.
   * @see com.vykon.vykonPro.hvac.BSatisfiedZoneBql#satisfiedZones
   */
  public void setSatisfiedZones(int v) { setInt(satisfiedZones,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BSatisfiedZoneBql.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BFacets getSlotFacets(Slot slot)
  {
    if (slot.equals(upperLimit) || slot.equals(lowerLimit) )
      return getFacets();
    return super.getSlotFacets(slot);

  }
  
  public void doCalculate() throws Exception
  {
    if(!getEnabled()) return;
    if(!getStatus().isOk())
    {
      checkForService();
      if(!getStatus().isOk()) return;
    }
    
    if(getPointQuery().isNull())
    {
      initCalcTicket();
      return;
    }

    if(result==null)
    {
      //we haven't gotten the list back yet from the refreshQuery method
      //so just reset the timer and return
      initCalcTicket();
      return;
    }
    
    //initialize values for each execution
    int num=0;
    double avg=0;
    double min=Double.POSITIVE_INFINITY;
    double max=Double.NEGATIVE_INFINITY;
    String minZ="";
    String maxZ="";
    
    int satisfied=0;
    double upper = getUpperLimit().getValue();
    double lower = getLowerLimit().getValue();
    
    //call timer to setup next execution
    initCalcTicket();

    BComponent comp;
    BStatusNumeric n;
    double nValue;

    for(int i=0; i<myComps.size(); i++)
    {
      comp = (BComponent)myComps.get(i);
      if(comp.get("out")!=null && comp.get("out").getType().is(BStatusNumeric.TYPE))
      {
        // lease the component to subscribe it
        if(!comp.isSubscribed()) sub.subscribe(comp);

        n = (BStatusNumeric)comp.get("out");
        if(n.getStatus().isValid() && BDouble.make(n.getValue())!=BDouble.NaN)
        {
          nValue = n.getValue();

          if (nValue < min)
          {
            min = nValue;
            minZ = getZoneIdentifierFormat().format(comp);
          }

          if (nValue > max)
          {
            max = nValue;
            maxZ = getZoneIdentifierFormat().format(comp);
          }

          avg = avg + nValue;
          num++;

          //check if zone satisfied lowerLimit < nValue < upperLimit
          if(nValue>lower && nValue<upper) satisfied = satisfied + 1;
        }
      }
    }

    /*
    try(Cursor cursor = result.cursor())
    {
      BComponent comp;
      BStatusNumeric n;
      double nValue;

      while(cursor.next())
      {
        comp = (BComponent)cursor.get();
        if(comp.get("out")!=null && comp.get("out").getType().is(BStatusNumeric.TYPE))
        {
          // lease the component to subscribe it
          comp.lease(0, getUpdateValuesInterval().getMillis()+ 5000);

          n = (BStatusNumeric)comp.get("out");
          if(n.getStatus().isValid() && BDouble.make(n.getValue())!=BDouble.NaN)
          {
            nValue = n.getValue();

            if (nValue < min)
            {
              min = nValue;
              minZ = getZoneIdentifierFormat().format(comp);
            }

            if (nValue > max)
            {
              max = nValue;
              maxZ = getZoneIdentifierFormat().format(comp);
            }

            avg = avg + nValue;
            num++;

            //check if zone satisfied lowerLimit < nValue < upperLimit
            if(nValue>lower && nValue<upper) satisfied = satisfied + 1;
          }
        }
      }
    }
    catch(Exception e)
    {
      System.out.println(this.getSlotPath() + " - error calculating values");
      e.printStackTrace();
    }
    */

    getMinZoneIdentifier().setValue(minZ);
    getMaxZoneIdentifier().setValue(maxZ);  
    
    if(min == Double.POSITIVE_INFINITY) min = Double.NaN;
    if(max == Double.NEGATIVE_INFINITY) min = Double.NaN;
    
    if (num != 0)                 
    {
      getSum().setValue(avg);
      getAvg().setValue(avg/num);
      if(getAvg().getStatus().isNull()) getAvg().setStatus(BStatus.ok);
      if(getSum().getStatus().isNull()) getSum().setStatus(BStatus.ok);
    } 
    else                       
    {
      getSum().setStatus(BStatus.NULL);
      getAvg().setStatus(BStatus.NULL);
    }
    
    setCount(num);
    getMin().setValue(min);
    getMax().setValue(max);
    setSatisfiedZones(satisfied);
  }

}
