package com.vykon.vykonPro.logic;

import javax.baja.status.BStatusNumeric;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BEnumRange;
import javax.baja.sys.BIcon;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.tridium.kitControl.logic.BComparison;
import com.vykon.vykonPro.enums.BCompareModeEnum;

public class BDifferentialCompare
    extends BComparison
{
  /*-
   class BDifferentialCompare
   {
     properties
     {
       deadband: BStatusNumeric
         flags { summary }
         default {[ new BStatusNumeric() ]}
       
       logicMode: BEnum
         default {[ ( BDynamicEnum.make(0, BEnumRange.make(BCompareModeEnum.TYPE))) ]}
     
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.logic.BDifferentialCompare(2479716932)1.0$ @*/
/* Generated Tue Mar 16 15:59:03 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "deadband"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>deadband</code> property.
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#getDeadband
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#setDeadband
   */
  public static final Property deadband = newProperty(Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>deadband</code> property.
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#deadband
   */
  public BStatusNumeric getDeadband() { return (BStatusNumeric)get(deadband); }
  
  /**
   * Set the <code>deadband</code> property.
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#deadband
   */
  public void setDeadband(BStatusNumeric v) { set(deadband,v,null); }

////////////////////////////////////////////////////////////////
// Property "logicMode"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>logicMode</code> property.
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#getLogicMode
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#setLogicMode
   */
  public static final Property logicMode = newProperty(0, ( BDynamicEnum.make(0, BEnumRange.make(BCompareModeEnum.TYPE))),null);
  
  /**
   * Get the <code>logicMode</code> property.
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#logicMode
   */
  public BEnum getLogicMode() { return (BEnum)get(logicMode); }
  
  /**
   * Set the <code>logicMode</code> property.
   * @see com.vykon.vykonPro.logic.BDifferentialCompare#logicMode
   */
  public void setLogicMode(BEnum v) { set(logicMode,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BDifferentialCompare.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  // //////////////////////////////////////////////////////////////
  // Initialization
  // //////////////////////////////////////////////////////////////

  protected boolean calculate(double arg0, double arg1)
  {
    //get the logic mode and proccess case
    int logic = getLogicMode().getOrdinal();
    boolean o = this.getOut().getValue();
    double dband = getDeadband().getValue();
    
    switch(logic)
    {
      case BCompareModeEnum.GREATER_THAN:
        //check if out is currently true
        if(o == true)
        {
          //we are already true so check if arg0 <= (arg1 - dband)
          if(arg0 <= (arg1 - dband)) return false;
          else return true;
        }
        else
        {
          //we are false so we just need to check if arg0 > arg1
          if(arg0 > arg1) return true;
          else return false;
        }
        
      case BCompareModeEnum.GREATER_THAN_OR_EQUAL_TO:
        //check if out is currently true
        if(o == true)
        {
          //we are already true so check if arg0 < (arg1 - dand)
          if(arg0 < (arg1 - dband)) return false;
          else return true;
        }
        else
        {
          //we are false so we just need to check if arg0 >= arg1
          if(arg0 >= arg1) return true;
          else return false;
        }
        
      case BCompareModeEnum.EQUALS:
        //check if out is currently active
        if(o == true)
        {
          //we are already true so need to check if arg0 < (arg1 - dband) or if arg0 > (arg1 + dband)
          if( arg0 < (arg1 - dband) || arg0 > (arg1 + dband)) return false;
          else return true;
        }
        else
        {
          //we are false so we just need to check if arg0 == arg1
          if(arg0 == arg1) return true;
          else return false;
        }
        
      case BCompareModeEnum.LESS_THAN:
        //check if out is currently active
        if(o == true)
        {
          //we are already true so need to check if arg0 > (arg1 + dband)
          if(arg0 >= (arg1 + dband)) return false;
          else return true;
        }
        else
        {
          //we are false so just need to check if arg0 < arg1
          if(arg0 < arg1) return true;
          else return false;
        }
        
      case BCompareModeEnum.LESS_THAN_OR_EQUAL_TO:
        //check if out is currently active
        if(o == true)
        {
          //we are already true so need to check if arg0 >= (arg1 + dband)
          if(arg0 > (arg1 + dband)) return false;
          else return true;
        }
        else
        {
          //we are false so just need to check if arg0 <= arg1
          if(arg0 <= arg1) return true;
          else return false;
        }
      
    }
    
    return false;
  }

////////////////////////////////////////////////////////////////
//Presentation
//////////////////////////////////////////////////////////////// 

 /**
  * Get the icon.
  */
 public BIcon getIcon() { return icon; }
 private static final BIcon icon = BIcon.std("control/control.png");


  
  
  ///////////////////////////////////////////////
  // local variables
  //////////////////////////////////////////////
  
  
}
