package com.vykon.vykonPro.point;

import com.tridium.history.audit.BAuditHistoryService;
import com.tridium.history.audit.BAuditRecord;

import javax.baja.control.BControlPoint;
import javax.baja.control.BPointExtension;
import javax.baja.history.BHistoryRecord;
import javax.baja.nre.annotations.AgentOn;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusValue;
import javax.baja.sys.*;
import javax.baja.user.BUser;
import javax.baja.util.Lexicon;

/**
 * Created by james on 1/21/2019.
 */

@NiagaraProperty(
        name = "user",
        type = "String",
        defaultValue = "",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE
)

@NiagaraProperty(
        name = "timestamp",
        type = "BAbsTime",
        defaultValue = "BAbsTime.DEFAULT",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE
)

@NiagaraProperty(
        name = "adminUser",
        type = "String",
        defaultValue = "",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN
)

@NiagaraProperty(
        name = "adminTimestamp",
        type = "BAbsTime",
        defaultValue = "BAbsTime.DEFAULT",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN
)

@NiagaraProperty(
        name = "operatorUser",
        type = "String",
        defaultValue = "",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN
)

@NiagaraProperty(
        name = "operatorTimestamp",
        type = "BAbsTime",
        defaultValue = "BAbsTime.DEFAULT",
        flags = Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN
)

public class BAuditExt
    extends BPointExtension
{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.point.BAuditExt(1633666860)1.0$ @*/
/* Generated Mon May 06 13:28:57 EDT 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "user"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code user} property.
   * @see #getUser
   * @see #setUser
   */
  public static final Property user = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE, "", null);
  
  /**
   * Get the {@code user} property.
   * @see #user
   */
  public String getUser() { return getString(user); }
  
  /**
   * Set the {@code user} property.
   * @see #user
   */
  public void setUser(String v) { setString(user, v, null); }

////////////////////////////////////////////////////////////////
// Property "timestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code timestamp} property.
   * @see #getTimestamp
   * @see #setTimestamp
   */
  public static final Property timestamp = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE, BAbsTime.DEFAULT, null);
  
  /**
   * Get the {@code timestamp} property.
   * @see #timestamp
   */
  public BAbsTime getTimestamp() { return (BAbsTime)get(timestamp); }
  
  /**
   * Set the {@code timestamp} property.
   * @see #timestamp
   */
  public void setTimestamp(BAbsTime v) { set(timestamp, v, null); }

////////////////////////////////////////////////////////////////
// Property "adminUser"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code adminUser} property.
   * @see #getAdminUser
   * @see #setAdminUser
   */
  public static final Property adminUser = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN, "", null);
  
  /**
   * Get the {@code adminUser} property.
   * @see #adminUser
   */
  public String getAdminUser() { return getString(adminUser); }
  
  /**
   * Set the {@code adminUser} property.
   * @see #adminUser
   */
  public void setAdminUser(String v) { setString(adminUser, v, null); }

////////////////////////////////////////////////////////////////
// Property "adminTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code adminTimestamp} property.
   * @see #getAdminTimestamp
   * @see #setAdminTimestamp
   */
  public static final Property adminTimestamp = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN, BAbsTime.DEFAULT, null);
  
  /**
   * Get the {@code adminTimestamp} property.
   * @see #adminTimestamp
   */
  public BAbsTime getAdminTimestamp() { return (BAbsTime)get(adminTimestamp); }
  
  /**
   * Set the {@code adminTimestamp} property.
   * @see #adminTimestamp
   */
  public void setAdminTimestamp(BAbsTime v) { set(adminTimestamp, v, null); }

////////////////////////////////////////////////////////////////
// Property "operatorUser"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code operatorUser} property.
   * @see #getOperatorUser
   * @see #setOperatorUser
   */
  public static final Property operatorUser = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN, "", null);
  
  /**
   * Get the {@code operatorUser} property.
   * @see #operatorUser
   */
  public String getOperatorUser() { return getString(operatorUser); }
  
  /**
   * Set the {@code operatorUser} property.
   * @see #operatorUser
   */
  public void setOperatorUser(String v) { setString(operatorUser, v, null); }

////////////////////////////////////////////////////////////////
// Property "operatorTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code operatorTimestamp} property.
   * @see #getOperatorTimestamp
   * @see #setOperatorTimestamp
   */
  public static final Property operatorTimestamp = newProperty(Flags.READONLY | Flags.DEFAULT_ON_CLONE | Flags.HIDDEN, BAbsTime.DEFAULT, null);
  
  /**
   * Get the {@code operatorTimestamp} property.
   * @see #operatorTimestamp
   */
  public BAbsTime getOperatorTimestamp() { return (BAbsTime)get(operatorTimestamp); }
  
  /**
   * Set the {@code operatorTimestamp} property.
   * @see #operatorTimestamp
   */
  public void setOperatorTimestamp(BAbsTime v) { set(operatorTimestamp, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAuditExt.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

    public void started() throws Exception
    {
        //BControlPoint point = getParentPoint();
        //slotPath = point.getSlotPath().getBody();
        super.started();
    }

    @Override
    public void onExecute(BStatusValue out, Context context)
    {
        checkLevel(out.getStatus());
    }

    private void checkLevel(BStatus status)
    {
        if(status.isOverridden())
        {
            String level = status.getFacets().get(BStatus.ACTIVE_LEVEL).toString();
            if(level.length()>0)
            {
                if(level.equals("1"))
                {
                  setUser(getAdminUser());
                  setTimestamp(getAdminTimestamp());
                }
                else if(level.equals("8"))
                {
                  setUser(getOperatorUser());
                  setTimestamp(getOperatorTimestamp());
                }
                else
                {
                  setUser("");
                  setTimestamp(BAbsTime.DEFAULT);
                }
            }
        }
        else
        {
            setUser("");
            setTimestamp(BAbsTime.DEFAULT);
        }
    }

    public void checkRecord(BAuditRecord rec)
    {
        if(rec.getSlotName().equals("override") ||
                rec.getSlotName().equals("active") ||
                rec.getSlotName().equals("inactive"))
        {
          setOperatorUser(rec.getUserName());
          setOperatorTimestamp(rec.getTimestamp());
        }
        else if(rec.getSlotName().equals("emergencyOverride") ||
                rec.getSlotName().equals("emergencyActive") ||
                rec.getSlotName().equals("emergencyInactive"))
        {
          setAdminUser(rec.getUserName());
          setAdminTimestamp(rec.getTimestamp());
        }
        else if(rec.getSlotName().equals("auto"))
        {
          setOperatorUser("");
          setOperatorTimestamp(BAbsTime.DEFAULT);
        }
        else if(rec.getSlotName().equals("emergencyAuto"))
        {
          setAdminUser("");
          setAdminTimestamp(BAbsTime.DEFAULT);
        }

        checkLevel(getParentPoint().getStatus());
    }

    //@Override
    //public String getDisplayNameInParent(Context context) {
    //    return Lexicon.make(TYPE.getModule(), context).getText("auditMixin");
    //}

    //////////////////////////////////////
    // local
    //////////////////////////////////////


    //String slotPath;

}
