package com.vykon.vykonPro.point;

import javax.baja.control.BNumericPoint;
import javax.baja.control.BPointExtension;
import javax.baja.status.BStatusNumeric;
import javax.baja.status.BStatusValue;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Slot;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

/**
 * BNumericCovTotalizerExt is a standard point extension used to
 * for totalizing a numeric point value on chage of value.  
 *
 *
 * @author    
 * @creation  9 Nov 00
 * @version   $Revision: 29$ $Date: 3/28/2005 12:40:33 PM$
 * @since     Baja 1.0
 */

public class BNumericCovTotalizerExt
  extends BPointExtension
{ 

  /*-
  
  class BNumericCovTotalizerExt
  {
    properties
    {
      totalFacets: BFacets
        -- These facets are applied against the total property.
        default {[ BFacets.makeNumeric() ]}
      
      total: BStatusNumeric
        -- Total accumulated value since last reset
        flags { readonly }
        default {[ new BStatusNumeric(0) ]}
      
      timeOfTotalReset: BAbsTime
        -- Time of last reset 
        flags { readonly }
        default {[ BAbsTime.make() ]}
      
    }

    actions
    {
      resetTotal()
      -- Reset the total to zero
      
    }
  }

  -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.point.BNumericCovTotalizerExt(304433670)1.0$ @*/
/* Generated Tue Mar 16 16:00:31 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "totalFacets"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>totalFacets</code> property.
   * These facets are applied against the total property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#getTotalFacets
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#setTotalFacets
   */
  public static final Property totalFacets = newProperty(0, BFacets.makeNumeric(),null);
  
  /**
   * Get the <code>totalFacets</code> property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#totalFacets
   */
  public BFacets getTotalFacets() { return (BFacets)get(totalFacets); }
  
  /**
   * Set the <code>totalFacets</code> property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#totalFacets
   */
  public void setTotalFacets(BFacets v) { set(totalFacets,v,null); }

////////////////////////////////////////////////////////////////
// Property "total"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>total</code> property.
   * Total accumulated value since last reset
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#getTotal
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#setTotal
   */
  public static final Property total = newProperty(Flags.READONLY, new BStatusNumeric(0),null);
  
  /**
   * Get the <code>total</code> property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#total
   */
  public BStatusNumeric getTotal() { return (BStatusNumeric)get(total); }
  
  /**
   * Set the <code>total</code> property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#total
   */
  public void setTotal(BStatusNumeric v) { set(total,v,null); }

////////////////////////////////////////////////////////////////
// Property "timeOfTotalReset"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>timeOfTotalReset</code> property.
   * Time of last reset
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#getTimeOfTotalReset
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#setTimeOfTotalReset
   */
  public static final Property timeOfTotalReset = newProperty(Flags.READONLY, BAbsTime.make(),null);
  
  /**
   * Get the <code>timeOfTotalReset</code> property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#timeOfTotalReset
   */
  public BAbsTime getTimeOfTotalReset() { return (BAbsTime)get(timeOfTotalReset); }
  
  /**
   * Set the <code>timeOfTotalReset</code> property.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#timeOfTotalReset
   */
  public void setTimeOfTotalReset(BAbsTime v) { set(timeOfTotalReset,v,null); }

////////////////////////////////////////////////////////////////
// Action "resetTotal"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>resetTotal</code> action.
   * Reset the total to zero
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#resetTotal()
   */
  public static final Action resetTotal = newAction(0,null);
  
  /**
   * Invoke the <code>resetTotal</code> action.
   * @see com.vykon.vykonPro.point.BNumericCovTotalizerExt#resetTotal
   */
  public void resetTotal() { invoke(resetTotal,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BNumericCovTotalizerExt.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public BFacets getSlotFacets(Slot slot)
  {
    if(slot.equals(total))
      return getTotalFacets();
    return super.getSlotFacets(slot);

  }

////////////////////////////////////////////////////////////////
//  PointExtension
////////////////////////////////////////////////////////////////

  public boolean requiresPointSubscription()
  {
    return true;
  }

////////////////////////////////////////////////////////////////
//  Parent checking
////////////////////////////////////////////////////////////////  

  /**
   * Parent must be NumericPoint.
   */
  public boolean isParentLegal(BComponent parent)
  {                            
    if (!super.isParentLegal(parent)) return false;
    return parent instanceof BNumericPoint;
  }

////////////////////////////////////////////////////////////////
//  Initialization
////////////////////////////////////////////////////////////////

  /**
   * Callback for when the extension is started.
   */
  public void started()
    throws Exception
  {
    super.started();
    // Initialize state variables
    lastValue = 0;
  }

////////////////////////////////////////////////////////////////
// Update Methods
////////////////////////////////////////////////////////////////

  /** 
   * Called when either me or my parent control 
   * point is updated.
   */ 
  public void onExecute(BStatusValue o, Context cx)
  {
    BStatusNumeric out = (BStatusNumeric)o;
    if(out.getStatus().isValid())
    {
      double value = out.getValue();
      
      if(value != lastValue)
      {
        getTotal().setValue(getTotal().getValue() + value);
      }
    
      lastValue = value;
    }
  }

////////////////////////////////////////////////////////////////
// Actions
////////////////////////////////////////////////////////////////
  
  public void doResetTotal()
  {
    getTotal().setValue(0);
    setTimeOfTotalReset(Clock.time());
  }

////////////////////////////////////////////////////////////////
// Attributes
////////////////////////////////////////////////////////////////  

  
  /* last value read from parent object */
  private double lastValue;
}
