package com.vykon.vykonPro.report;


import java.io.ByteArrayOutputStream;
import java.io.PrintStream;

import javax.baja.alarm.AlarmDbConnection;
import javax.baja.alarm.BAlarmDatabase;
import javax.baja.alarm.BAlarmRecord;
import javax.baja.alarm.BAlarmService;
import javax.baja.collection.BITable;
import javax.baja.collection.Column;
import javax.baja.collection.TableCursor;
import javax.baja.naming.BOrd;
import javax.baja.naming.SlotPath;
import javax.baja.report.BReport;
import javax.baja.report.BReportSource;
import javax.baja.status.BStatus;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BFacets;
import javax.baja.sys.BInteger;
import javax.baja.sys.BNumber;
import javax.baja.sys.BObject;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BasicContext;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;

import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.timezone.BTimeZone;
import javax.baja.util.BFormat;
import javax.baja.util.BUuid;
import javax.baja.nre.util.TextUtil;

/**
 * 
 *  The AlarmQueryToCsv component is a report source component that allows the user to enter a bql query
 *  of the alarm database which is exported to csv when the report is generated.
 *
 * @author James Johnson
 * @creation Nov 8, 2010
 *
 */

public class BAlarmQueryToCsv
    extends BReportSource
{
  /*-
   class BAlarmQueryToCsv
   {
     properties
     {
       reportName:BFormat
         -- BFormat syntax used to resolve the reportName
         flags{ operator }
         default {[ BFormat.make("%componentSpace.rootComponent.stationName%_%parent.name%") ]}
         
       reportHeader:BFormat
         --The header included in the generated report
         flags{ operator }
         default{[ BFormat.make("Alarm report from %componentSpace.rootComponent.stationName%\n%time()%") ]}
         slotfacets {[ BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE) ]}
       
       alarmQuery:String
         -- the bql query used for the report
         flags{ operator }
         default{[ "select timestamp,alarmData.msgText where timestamp in bqltime.weektodate" ]}
         slotfacets {[ BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE, BFacets.FIELD_WIDTH, BInteger.make(120)) ]}
       
       lastExecutionTime:BAbsTime
         -- time of last report execution
         flags{ readonly }
         default{[ BAbsTime.NULL ]}
       
       faultCause: String
         flags{ readonly }
         default{[ "" ]}
         slotfacets{[ BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE, BFacets.FIELD_WIDTH, BInteger.make(120)) ]}
         
       status: BStatus
         flags{ readonly }
         default{[ BStatus.ok ]}
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.report.BAlarmQueryToCsv(1421056490)1.0$ @*/
/* Generated Thu Oct 28 16:42:45 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "reportName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>reportName</code> property.
   * BFormat syntax used to resolve the reportName
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#getReportName
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#setReportName
   */
  public static final Property reportName = newProperty(Flags.OPERATOR, BFormat.make("%componentSpace.rootComponent.stationName%_%parent.name%"),null);
  
  /**
   * Get the <code>reportName</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#reportName
   */
  public BFormat getReportName() { return (BFormat)get(reportName); }
  
  /**
   * Set the <code>reportName</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#reportName
   */
  public void setReportName(BFormat v) { set(reportName,v,null); }

////////////////////////////////////////////////////////////////
// Property "reportHeader"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>reportHeader</code> property.
   * The header included in the generated report
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#getReportHeader
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#setReportHeader
   */
  public static final Property reportHeader = newProperty(Flags.OPERATOR, BFormat.make("Alarm report from %componentSpace.rootComponent.stationName%\n%time()%"),BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE));
  
  /**
   * Get the <code>reportHeader</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#reportHeader
   */
  public BFormat getReportHeader() { return (BFormat)get(reportHeader); }
  
  /**
   * Set the <code>reportHeader</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#reportHeader
   */
  public void setReportHeader(BFormat v) { set(reportHeader,v,null); }

////////////////////////////////////////////////////////////////
// Property "alarmQuery"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>alarmQuery</code> property.
   * the bql query used for the report
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#getAlarmQuery
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#setAlarmQuery
   */
  public static final Property alarmQuery = newProperty(Flags.OPERATOR, "select timestamp,alarmData.msgText where timestamp in bqltime.weektodate",BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE, BFacets.FIELD_WIDTH, BInteger.make(120)));
  
  /**
   * Get the <code>alarmQuery</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#alarmQuery
   */
  public String getAlarmQuery() { return getString(alarmQuery); }
  
  /**
   * Set the <code>alarmQuery</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#alarmQuery
   */
  public void setAlarmQuery(String v) { setString(alarmQuery,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastExecutionTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastExecutionTime</code> property.
   * time of last report execution
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#getLastExecutionTime
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#setLastExecutionTime
   */
  public static final Property lastExecutionTime = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>lastExecutionTime</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#lastExecutionTime
   */
  public BAbsTime getLastExecutionTime() { return (BAbsTime)get(lastExecutionTime); }
  
  /**
   * Set the <code>lastExecutionTime</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#lastExecutionTime
   */
  public void setLastExecutionTime(BAbsTime v) { set(lastExecutionTime,v,null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#getFaultCause
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY, "",BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE, BFacets.FIELD_WIDTH, BInteger.make(120)));
  
  /**
   * Get the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the <code>faultCause</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#faultCause
   */
  public void setFaultCause(String v) { setString(faultCause,v,null); }

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>status</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#getStatus
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#setStatus
   */
  public static final Property status = newProperty(Flags.READONLY, BStatus.ok,null);
  
  /**
   * Get the <code>status</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the <code>status</code> property.
   * @see com.vykon.vykonPro.report.BAlarmQueryToCsv#status
   */
  public void setStatus(BStatus v) { set(status,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BAlarmQueryToCsv.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  
  public BReport handleGenerate() throws Exception
  {
    if(!this.isRunning()) return null;
    
    StringBuffer sb = new StringBuffer();
    setLastExecutionTime(Clock.time());

    BAlarmService alarmService = (BAlarmService)Sys.getService(BAlarmService.TYPE);

    try(AlarmDbConnection conn = alarmService.getAlarmDb().getDbConnection(null))
    {
      //start the csv file in memory and set the headers
      byteStream = new ByteArrayOutputStream();
      out = new PrintStream(byteStream);

      out.write(0xEF);
      out.write(0xBB);
      out.write(0xBF);
      out.print('\n');
      
      //check for multiple lines and break apart
      String[] headers = TextUtil.splitAndTrim(getReportHeader().toString(), '\n');
      //String[] headers = (getReportHeader().toString()).split("\\r?\\n");

      for (int i = 0; i < headers.length; i++)
      {
        BFormat p = BFormat.make(headers[i]);
        String s = SlotPath.unescape(SlotPath.escape(SlotPath.unescape(p.format(this))));
        out.println(s);
      }

      out.println("");
      
      //construct the bql query ord
      String select = getAlarmQuery();
      select = select.replace('\n', ' ');
      String selectTest = select.toLowerCase();
      
      //add UUID to start of select
      if(selectTest.startsWith("select *"))
      {
        //already getting the uuid so don't do anything
      }
      else if(selectTest.toLowerCase().startsWith("select"))
      {
        //statement starts with select
        if(!(selectTest.toLowerCase().indexOf("uuid") > -1))
        {
          //doesn't include uuid, so add it
          select = "select uuid," + select.substring(select.indexOf("select")+6);
          stripUuid = true;
        }
      }
      else
      {
        sb.append("enter a properly formatted select statement");
      }
      
      StringBuffer q = new StringBuffer();
      q.append("alarm:/|bql:");
      q.append(select.toString());
      
      BOrd aqOrd = BOrd.make(q.toString());
      
      //resolve the bql query ord to a table
      result = (BITable) aqOrd.resolve(this).get();

      //get the bql table columns
      bqlColCount = result.getColumns().size();
      bqlCols = new Column[bqlColCount];

      for(int j=0; j<bqlColCount; j++)
      {
        bqlCols[j] = result.getColumns().get(j);
      }

      // column facets
      colCx = new Context[bqlColCount];
      bqlColNames = new String[bqlColCount];
      bqlColLabels = new String[bqlColCount];
      quote = new boolean[bqlColCount];
      firstCol = true;

      for (int j = 0; j < bqlColCount; j++)
      {
        //get the column context
        colCx[j] = new BasicContext(Sys.getStation().getSysInfo(), bqlCols[j].getFacets());

        //get the column type
        Type type = bqlCols[j].getType();
        quote[j] =
          !type.is(BNumber.TYPE) && !type.is(BBoolean.TYPE) && !type.is(BRelTime.TYPE) &&
            !type.is(BAbsTime.TYPE);

        //get the column name and label
        bqlColNames[j] = bqlCols[j].getName();
        String dname = bqlCols[j].getDisplayName(null);
        bqlColLabels[j] = dname;

        if(dname.equalsIgnoreCase("uuid")) uuidCol = j;

        if(stripUuid == true && dname.equalsIgnoreCase("uuid"))
        {
          //skip adding uuid to the csv
        }
        else
        {
          dname = dname.replace(',', '_'); // no commas
          dname = dname.replace('"', '\''); // no quotes
          if (firstCol == true) firstCol = false;
          else out.print(",");
          out.print(dname);
        }
      }
      out.print('\n');

      // Get the alarm database
      //BAlarmService alarmService = (BAlarmService)Sys.getService(BAlarmService.TYPE);
      //BAlarmDatabase alarmDb = alarmService.getAlarmDb();

      c = result.cursor();

      /*
      * since N4 changed API for BITable, there is no size() method anymore
      * have to refactor code which needs to be tested
       */



      if (c.next())
      {

        do
        {
          boolean firstDataCol = true;
          
          //get the values from bql result for this row
          for (int j = 0; j < bqlColCount; j++)
          {
            if (stripUuid == true && j == uuidCol)
            {
              //skip outputting the uuid because user select didn't include it
            }
            else
            {
              // get cell, N4 changed from get to cell
              BObject cell = (BObject)c.cell(bqlCols[j]);
              // get the text of the cell
              String text;

              if (cell instanceof BAbsTime)
              {
                text =
                    ((BAbsTime) cell).toString(BFacets
                        .make(BFacets.TIME_ZONE, BTimeZone.getLocal()));
              }
              else
              {
                text =
                  cell.toString(new BasicContext(colCx[j], BFacets.make(BFacets.SHOW_UNITS,
                                                                        BBoolean.FALSE)));
                
                if (text.indexOf("%") > -1)
                {
                  //need to resolve BFacets relative to alarmRecord, N4 changed from get to cell and added toString call
                  BUuid alarmId =
                      (BUuid) BUuid.DEFAULT.decodeFromString(c.cell(bqlCols[uuidCol]).toString());
                  BAlarmRecord rec = conn.getRecord(alarmId);
                  text =
                      BFormat.make(SlotPath.unescape(cell.toString())).format(rec).replace('\n', ' ');
                }
              }
              
              //only write a comma on second and subsequent columns
              if(firstDataCol) firstDataCol = false;
              else out.print(',');
              
              // write the cell (make sure to escape double quotes)
              if (quote[j])
              {
                out.print('"');
                out.print(TextUtil.replace(text, "\"", "\"\""));
                out.print('"');
              }
              else
              {
                out.print(text);
              }
            }
          }
          out.print("\n");
        }
        while (c.next());
      }
      else
      {
        //didn't return any resutls from the alarm db query
        out.println("select statement did not return any results");
        sb.append("select statement did not return any results");
      }
    }
    catch(Exception e)
    {
      System.out.println(this.getSlotPath() + " , failed to generate report");
      e.printStackTrace();
      sb.append("failed to generate report");
    }
    finally
    {
      out.close();
      c.close();
    }
    
    String faults = sb.toString();
    if(faults.length()>0)
    {
      setFaultCause(faults);
      setStatus(BStatus.fault);
    }
    else
    {
      setFaultCause("");
      setStatus(BStatus.ok);
    }
    String fileName = resolveReportName();
    return new BReport(
                       fileName, 
                       fileName+".csv", 
                       "text/csv",
                       byteStream.toByteArray());
    
    
  }

  
  /*
   * resolve the reportName
   */
  private String resolveReportName()
  {
    BFormat pattern = getReportName();
    String s = (SlotPath.escape(SlotPath.unescape(pattern.format(this))));
    return s.trim();
  }
  
  ///////////////////////////////////////////
  // local variables
  ///////////////////////////////////////////
  
  private ByteArrayOutputStream byteStream;
  private PrintStream out;
  private boolean stripUuid = false;
  private boolean firstCol = true;
  
  //bql query variables
  private BITable result = null;
  private TableCursor c = null;
  
  Context[] colCx = null;
  boolean[] quote = null;
  
  int bqlColCount = -1;
  int uuidCol = -1;
  Column[] bqlCols = null;
  String[] bqlColNames = null;
  String[] bqlColLabels = null;
}
