/*
 * Copyright 2008 acme, Inc. All Rights Reserved.
 */

package com.vykon.vykonPro.report;
 
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.baja.file.BDirectory;
import javax.baja.file.BIFile;
import javax.baja.file.FilePath;
import javax.baja.naming.BOrd;
import javax.baja.report.BReport;
import javax.baja.report.BReportRecipient;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BObject;
import javax.baja.sys.BString;
import javax.baja.sys.BajaRuntimeException;
import javax.baja.sys.Context;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;



 /* this object extends the BFileRecipient and includes a date timestamp in the saved
 *  file name to ensure a unique file is created each time the exporter is called
 *
 * @author    
 * @creation  1 May 2008
 * @version   $Revision: $ $Date: $
 * @since     Baja 1.0
 */
 
public class BReportFileRecipient
  extends BReportRecipient
{ 
  /*-
  class BReportFileRecipient
  {
    properties
    {
      ord: BOrd
        -- The ord to the directory to save file in.
        default {[ BOrd.NULL ]}
        slotfacets {[ BFacets.make(BFacets.FIELD_EDITOR, BString.make("workbench:DirectoryOrdFE")) ]}
      
      includeTimestamp: boolean
      --boolean property to control file name.  Set to true if current timestamp is to be included in saved file name in format YYMMDD_hhmm.
      default{[ true ]}
      
      timestampFormat: String
        -- The format of the imported timestamp values, which
        -- is used to decode them.
        default {[ "yyyyMMdd_HHmm" ]}

    }
  }
  -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.report.BReportFileRecipient(996790615)1.0$ @*/
/* Generated Wed May 27 09:54:47 EDT 2015 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "ord"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code ord} property.
   * The ord to the directory to save file in.
   * @see #getOrd
   * @see #setOrd
   */
  public static final Property ord = newProperty(0, BOrd.NULL,BFacets.make(BFacets.FIELD_EDITOR, BString.make("workbench:DirectoryOrdFE")));
  
  /**
   * Get the {@code ord} property.
   * The ord to the directory to save file in.
   * @see #ord
   */
  public BOrd getOrd() { return (BOrd)get(ord); }
  
  /**
   * Set the {@code ord} property.
   * The ord to the directory to save file in.
   * @see #ord
   */
  public void setOrd(BOrd v) { set(ord,v,null); }

////////////////////////////////////////////////////////////////
// Property "includeTimestamp"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code includeTimestamp} property.
   * boolean property to control file name.  Set to true if current timestamp is to be included in saved file name in format YYMMDD_hhmm.
   * @see #getIncludeTimestamp
   * @see #setIncludeTimestamp
   */
  public static final Property includeTimestamp = newProperty(0, true,null);
  
  /**
   * Get the {@code includeTimestamp} property.
   * boolean property to control file name.  Set to true if current timestamp is to be included in saved file name in format YYMMDD_hhmm.
   * @see #includeTimestamp
   */
  public boolean getIncludeTimestamp() { return getBoolean(includeTimestamp); }
  
  /**
   * Set the {@code includeTimestamp} property.
   * boolean property to control file name.  Set to true if current timestamp is to be included in saved file name in format YYMMDD_hhmm.
   * @see #includeTimestamp
   */
  public void setIncludeTimestamp(boolean v) { setBoolean(includeTimestamp,v,null); }

////////////////////////////////////////////////////////////////
// Property "timestampFormat"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code timestampFormat} property.
   * The format of the imported timestamp values, which
   * is used to decode them.
   * @see #getTimestampFormat
   * @see #setTimestampFormat
   */
  public static final Property timestampFormat = newProperty(0, "yyyyMMdd_HHmm",null);
  
  /**
   * Get the {@code timestampFormat} property.
   * The format of the imported timestamp values, which
   * is used to decode them.
   * @see #timestampFormat
   */
  public String getTimestampFormat() { return getString(timestampFormat); }
  
  /**
   * Set the {@code timestampFormat} property.
   * The format of the imported timestamp values, which
   * is used to decode them.
   * @see #timestampFormat
   */
  public void setTimestampFormat(String v) { setString(timestampFormat,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BReportFileRecipient.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/
  
  

public void handleRoute(BReport breport)
        throws Exception
{
  String filename = breport.getFileName();
    
  if (getIncludeTimestamp())
  {
    int i = filename.lastIndexOf(".");
    filename = filename.substring(0, i) 
      + new SimpleDateFormat(getTimestampFormat().trim()).format(new Date())
      + filename.substring(i);
  }
       
  BIFile bifile = (BIFile)getOrd().resolve().get();
  BDirectory bdirectory = bifile.getFileSpace().makeDir(bifile.getFilePath(), null);
  FilePath filepath = bdirectory.getFilePath().merge(filename);
  BIFile bifile1 = bifile.getFileSpace().makeFile(filepath, null);
  OutputStream outputstream = bifile1.getOutputStream();
  byte abyte0[] = breport.getContent();
  outputstream.write(abyte0, 0, abyte0.length);
  outputstream.flush();
  outputstream.close();
}

public void changed(Property property, Context context)
{
  if(!isRunning()) return;
  
  //check if the property changed is the ord property
  if( property == ord)
  {
    //get the ord value and return if it's null.
    BOrd ord = (BOrd)get(property);
    if( ord.equals(BOrd.NULL) || ord.equals(BOrd.DEFAULT)) return;
    
    //resolve ord and determine if it is a BDirectory
    BObject object = ord.get();
    if( object instanceof BIFile)
    {
      BIFile file = (BIFile)object;
      if( !file.isDirectory())
      {
        // throw an exception indicating that the user needs to choose
        // a directory ord
        setOrd(BOrd.DEFAULT);
        throw new BajaRuntimeException("Invalid ORD: " + ord.encodeToString() + ". ORD must resolve to a File Directory.");
      }
    }
    // if ORD is not a BIFile, BOrd cannot be saved.
    else
    {
      setOrd(BOrd.DEFAULT);
      throw new BajaRuntimeException("Invalid ORD: " + ord.encodeToString() + ". ORD must resolve to a File Directory.");
    }
  }
  
  super.changed(property, context);
}

////////////////////////////////////////////////////////////////
//BObject
////////////////////////////////////////////////////////////////

public BIcon getIcon() { return icon; }
private static final BIcon icon = BIcon.std("file.png");

}