package com.vykon.vykonPro.report;

import java.io.ByteArrayOutputStream;

import javax.baja.agent.AgentFilter;
import javax.baja.agent.AgentList;
import javax.baja.file.BExporter;
import javax.baja.file.ExportOp;
import javax.baja.gx.BSize;
import javax.baja.naming.OrdTarget;
import javax.baja.report.BReport;
import javax.baja.report.BReportSource;
import javax.baja.sys.BFacets;
import javax.baja.sys.BObject;
import javax.baja.sys.BRelTime;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.tridium.report.BExportSourceInfo;

public class BVykonProReportSource
    extends BReportSource
{
  /*-
   class BVykonProReportSource
   {
     properties
     {
       source: BExportSourceInfo
        -- The object to export.
        default {[ BExportSourceInfo.NULL ]}
        
       pageSize: BSize
        -- The page size in inches.
        default {[ BSize.make(8.5, 11) ]}
        slotfacets {[ BFacets.make(BFacets.FIELD_EDITOR, "workbench:PageSizeFE") ]}
        
        
      reportName: String
        -- The name of the saved report
        default {[ "report" ]}
        
      reportDelay: BRelTime
        -- The delay time between resolving the px to be exported and generating the pdf
        default{[ BRelTime.makeSeconds(5) ]}
        
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.report.BVykonProReportSource(1754744722)1.0$ @*/
/* Generated Tue Mar 16 16:01:26 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "source"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>source</code> property.
   * The object to export.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#getSource
   * @see com.vykon.vykonPro.report.BVykonProReportSource#setSource
   */
  public static final Property source = newProperty(0, BExportSourceInfo.NULL,null);
  
  /**
   * Get the <code>source</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#source
   */
  public BExportSourceInfo getSource() { return (BExportSourceInfo)get(source); }
  
  /**
   * Set the <code>source</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#source
   */
  public void setSource(BExportSourceInfo v) { set(source,v,null); }

////////////////////////////////////////////////////////////////
// Property "pageSize"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>pageSize</code> property.
   * The page size in inches.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#getPageSize
   * @see com.vykon.vykonPro.report.BVykonProReportSource#setPageSize
   */
  public static final Property pageSize = newProperty(0, BSize.make(8.5, 11),BFacets.make(BFacets.FIELD_EDITOR, "workbench:PageSizeFE"));
  
  /**
   * Get the <code>pageSize</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#pageSize
   */
  public BSize getPageSize() { return (BSize)get(pageSize); }
  
  /**
   * Set the <code>pageSize</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#pageSize
   */
  public void setPageSize(BSize v) { set(pageSize,v,null); }

////////////////////////////////////////////////////////////////
// Property "reportName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>reportName</code> property.
   * The name of the saved report
   * @see com.vykon.vykonPro.report.BVykonProReportSource#getReportName
   * @see com.vykon.vykonPro.report.BVykonProReportSource#setReportName
   */
  public static final Property reportName = newProperty(0, "report",null);
  
  /**
   * Get the <code>reportName</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#reportName
   */
  public String getReportName() { return getString(reportName); }
  
  /**
   * Set the <code>reportName</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#reportName
   */
  public void setReportName(String v) { setString(reportName,v,null); }

////////////////////////////////////////////////////////////////
// Property "reportDelay"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>reportDelay</code> property.
   * The delay time between resolving the px to be exported
   * and generating the pdf
   * @see com.vykon.vykonPro.report.BVykonProReportSource#getReportDelay
   * @see com.vykon.vykonPro.report.BVykonProReportSource#setReportDelay
   */
  public static final Property reportDelay = newProperty(0, BRelTime.makeSeconds(5),null);
  
  /**
   * Get the <code>reportDelay</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#reportDelay
   */
  public BRelTime getReportDelay() { return (BRelTime)get(reportDelay); }
  
  /**
   * Set the <code>reportDelay</code> property.
   * @see com.vykon.vykonPro.report.BVykonProReportSource#reportDelay
   */
  public void setReportDelay(BRelTime v) { set(reportDelay,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BVykonProReportSource.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  
   
////////////////////////////////////////////////////////////////
//BReportGenerator
////////////////////////////////////////////////////////////////

 /**
  * Apply the configured exporter to the source object
  * to generate the report.
  */
 public BReport handleGenerate() throws Exception
 {
   // resovle
   OrdTarget source = getSource().getSource().resolve();

   // get obj and agent
   BObject obj = source.get();
   String agentId = getSource().getAgentId();
   BExporter exporter = null;

   // sleep for report delay to allow proper subscription
   Thread.sleep(getReportDelay().getMillis());

   // get exporter
   AgentList agents = obj.getAgents().filter(ExportFilter);
   for (int i=0; i<agents.size(); i++)
     if (agentId.equals(agents.get(i).getAgentId()))
     {
       exporter = (BExporter)agents.get(i).getInstance();
       break;
     }

   String rname = getReportName();

   String fname = rname + "." + exporter.getFileExtension();
   String mime  = exporter.getFileMimeType();

   ByteArrayOutputStream out = new ByteArrayOutputStream();

   if(mime.endsWith("pdf"))
   {
     //use the page size
     exporter.set("pageSize", getPageSize());
   }

   exporter.export(ExportOp.make(source, out));

   return new BReport(rname, fname, mime, out.toByteArray());
 }



////////////////////////////////////////////////////////////////
//Attributes
////////////////////////////////////////////////////////////////

 static AgentFilter ExportFilter = AgentFilter.is(BExporter.TYPE);
 
}