package com.vykon.vykonPro.tags;

import com.tridium.tagdictionary.condition.BIsTypeCondition;

import javax.baja.data.BIDataValue;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraSlots;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.*;
import javax.baja.tag.Entity;
import javax.baja.tag.Tag;
import javax.baja.tagdictionary.BTagInfo;
import javax.baja.tagdictionary.BTagRuleCondition;
import javax.baja.util.BFormat;


/**
 *	smart tag which uses BFormat resolved against the entity to return a String tag value
 */
 
@NiagaraType

@NiagaraProperty(name = "validity",
                     type="BTagRuleCondition",
                     defaultValue="new BIsTypeCondition(BComponent.TYPE)",
                     flags = Flags.READONLY | Flags.TRANSIENT)
                     
@NiagaraProperty(name = "format",
                      type = "BFormat",
                      defaultValue = "BFormat.make(\"%.%\")",
                      flags = Flags.OPERATOR)                 

					  
public class BFormatTag
  extends BTagInfo
{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.tags.BFormatTag(702660982)1.0$ @*/
/* Generated Wed Jul 11 09:28:12 EDT 2018 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "validity"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code validity} property.
   * @see #getValidity
   * @see #setValidity
   */
  public static final Property validity = newProperty(Flags.READONLY | Flags.TRANSIENT, new BIsTypeCondition(BComponent.TYPE), null);
  
  /**
   * Get the {@code validity} property.
   * @see #validity
   */
  public BTagRuleCondition getValidity() { return (BTagRuleCondition)get(validity); }
  
  /**
   * Set the {@code validity} property.
   * @see #validity
   */
  public void setValidity(BTagRuleCondition v) { set(validity, v, null); }

////////////////////////////////////////////////////////////////
// Property "format"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code format} property.
   * @see #getFormat
   * @see #setFormat
   */
  public static final Property format = newProperty(Flags.OPERATOR, BFormat.make("%.%"), null);
  
  /**
   * Get the {@code format} property.
   * @see #format
   */
  public BFormat getFormat() { return (BFormat)get(format); }
  
  /**
   * Set the {@code format} property.
   * @see #format
   */
  public void setFormat(BFormat v) { set(format, v, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BFormatTag.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public Tag getTag(Entity entity)
  {
    if (entity instanceof BComponent)
    {
      String value = getFormat().format((BComponent)entity);
      if (value == null) return null;
      else return new Tag(getTagId(), BString.make(value));
    }
    else return null;
  }
  
  public BIDataValue getDefaultValue()
  {
    return BString.make("");
  }
}

