package com.vykon.vykonPro.timer;

import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BValue;
import javax.baja.sys.Clock;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Topic;
import javax.baja.sys.Type;

import com.tridium.bql.util.BDynamicTimeRange;

public class BTimeRangeLatch
  extends BComponent
{
  /*-
   class BTimeRangeLatch
   {
     properties
     {
       timeRange: BDynamicTimeRange
         -- The time range start and end times are latched by invoking the two actions.
         default{[ BDynamicTimeRange.make(BAbsTime.NULL,BAbsTime.NULL) ]}
         flags{ summary, readonly }
         
        triggerDelay: BRelTime
         -- used to configure delay after latching the end time before firing the topic. 
         default{[ BRelTime.makeSeconds(5) ]}
         flags{ operator }
         
        lastTrigger: BAbsTime
         -- The time the topic slot was last fired
         default{[ BAbsTime.NULL ]}
         flags{ readonly, defaultOnClone }
     }
     actions
     {
       delayExpired()
         flags{ hidden }
         
       latchStart()
         flags{ summary }
         
       latchEnd()
         flags{ summary }
     }
     topics
     {
       trigger
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.timer.BTimeRangeLatch(3295006705)1.0$ @*/
/* Generated Mon Aug 11 13:09:42 EDT 2014 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "timeRange"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>timeRange</code> property.
   * The time range start and end times are latched by invoking the two actions.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#getTimeRange
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#setTimeRange
   */
  public static final Property timeRange = newProperty(Flags.SUMMARY|Flags.READONLY, BDynamicTimeRange.make(BAbsTime.NULL,BAbsTime.NULL),null);

  /**
   * Get the <code>timeRange</code> property.
   * The time range start and end times are latched by invoking the two actions.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#timeRange
   */
  public BDynamicTimeRange getTimeRange() { return (BDynamicTimeRange)get(timeRange); }

  /**
   * Set the <code>timeRange</code> property.
   * The time range start and end times are latched by invoking the two actions.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#timeRange
   */
  public void setTimeRange(BDynamicTimeRange v) { set(timeRange,v,null); }

////////////////////////////////////////////////////////////////
// Property "triggerDelay"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>triggerDelay</code> property.
   * used to configure delay after latching the end time
   * before firing the topic.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#getTriggerDelay
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#setTriggerDelay
   */
  public static final Property triggerDelay = newProperty(Flags.OPERATOR, BRelTime.makeSeconds(5),null);

  /**
   * Get the <code>triggerDelay</code> property.
   * used to configure delay after latching the end time
   * before firing the topic.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#triggerDelay
   */
  public BRelTime getTriggerDelay() { return (BRelTime)get(triggerDelay); }

  /**
   * Set the <code>triggerDelay</code> property.
   * used to configure delay after latching the end time
   * before firing the topic.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#triggerDelay
   */
  public void setTriggerDelay(BRelTime v) { set(triggerDelay,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastTrigger"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>lastTrigger</code> property.
   * The time the topic slot was last fired
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#getLastTrigger
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#setLastTrigger
   */
  public static final Property lastTrigger = newProperty(Flags.READONLY|Flags.DEFAULT_ON_CLONE, BAbsTime.NULL,null);

  /**
   * Get the <code>lastTrigger</code> property.
   * The time the topic slot was last fired
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#lastTrigger
   */
  public BAbsTime getLastTrigger() { return (BAbsTime)get(lastTrigger); }

  /**
   * Set the <code>lastTrigger</code> property.
   * The time the topic slot was last fired
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#lastTrigger
   */
  public void setLastTrigger(BAbsTime v) { set(lastTrigger,v,null); }

////////////////////////////////////////////////////////////////
// Action "delayExpired"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>delayExpired</code> action.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#delayExpired()
   */
  public static final Action delayExpired = newAction(Flags.HIDDEN,null);

  /**
   * Invoke the <code>delayExpired</code> action.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#delayExpired
   */
  public void delayExpired() { invoke(delayExpired,null,null); }

////////////////////////////////////////////////////////////////
// Action "latchStart"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>latchStart</code> action.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#latchStart()
   */
  public static final Action latchStart = newAction(Flags.SUMMARY,null);

  /**
   * Invoke the <code>latchStart</code> action.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#latchStart
   */
  public void latchStart() { invoke(latchStart,null,null); }

////////////////////////////////////////////////////////////////
// Action "latchEnd"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>latchEnd</code> action.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#latchEnd()
   */
  public static final Action latchEnd = newAction(Flags.SUMMARY,null);

  /**
   * Invoke the <code>latchEnd</code> action.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#latchEnd
   */
  public void latchEnd() { invoke(latchEnd,null,null); }

////////////////////////////////////////////////////////////////
// Topic "trigger"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>trigger</code> topic.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#fireTrigger
   */
  public static final Topic trigger = newTopic(0,null);

  /**
   * Fire an event for the <code>trigger</code> topic.
   * @see com.vykon.vykonPro.timer.BTimeRangeLatch#trigger
   */
  public void fireTrigger(BValue event) { fire(trigger, event, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BTimeRangeLatch.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public void stopped() throws Exception
  {
    if(ticket!=null) ticket.cancel();
    super.stopped();
  }

  public void doDelayExpired()
  {
    if(ticket!=null) ticket.cancel();
    fireTrigger(null);
    setLastTrigger(Clock.time());
  }

  public void doLatchStart() throws Exception
  {
    setTimeRange(BDynamicTimeRange.make(Clock.time(), BAbsTime.NULL));
  }

  public void doLatchEnd() throws Exception
  {
    BAbsTime current = Clock.time();
    BAbsTime start = getTimeRange().getStartTime(current);
    setTimeRange(BDynamicTimeRange.make(start, current));
    if(ticket!=null) ticket.cancel();
    ticket = Clock.schedule(this, getTriggerDelay(), delayExpired, null);
  }




  Clock.Ticket ticket = null;

}
