package com.vykon.vykonPro.timer;

import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BIcon;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BTime;
import javax.baja.sys.BValue;
import javax.baja.sys.BWeekday;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Topic;
import javax.baja.sys.Type;


public class BWeeklyTrigger
    extends BComponent
{
  /*-
   class BWeeklyTrigger
   {
     properties
     {
       triggerTime: BTime
         -- The time at which the trigger is configured to fire
         flags{ operator }
         default{[ BTime.DEFAULT ]}
         
       triggerDayOfWeek: BWeekday
         -- The day of the week which the trigger is configured to fire.
         flags{ operator }
         default{[ BWeekday.make(BWeekday.MONDAY) ]}
       
       triggerWeekInterval: int
         -- The number of weeks which must elapse from the lastTrigger before the nextTrigger
         -- is scheduled.
         flags{ operator }
         default{[ 1 ]}
         
       lastTrigger: BAbsTime
        -- The time of the last trigger or null is no trigger
        -- has ever occurred.
        flags { readonly }
        default {[ BAbsTime.NULL ]}

      nextTrigger: BAbsTime
        -- The next time that a trigger will be fired.
        flags { readonly }
        default {[ BAbsTime.END_OF_TIME ]}
        
     }
     actions
     {
       presetNextTrigger(date:BAbsTime)
         flags{ operator }
         default{[ BAbsTime.make() ]}
         
       ticketExpired()
         flags{ hidden }
     }
     topics
     {
       trigger
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.timer.BWeeklyTrigger(3909897118)1.0$ @*/
/* Generated Mon Apr 19 21:11:01 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "triggerTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>triggerTime</code> property.
   * The time at which the trigger is configured to fire
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#getTriggerTime
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#setTriggerTime
   */
  public static final Property triggerTime = newProperty(Flags.OPERATOR, BTime.DEFAULT,null);
  
  /**
   * Get the <code>triggerTime</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#triggerTime
   */
  public BTime getTriggerTime() { return (BTime)get(triggerTime); }
  
  /**
   * Set the <code>triggerTime</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#triggerTime
   */
  public void setTriggerTime(BTime v) { set(triggerTime,v,null); }

////////////////////////////////////////////////////////////////
// Property "triggerDayOfWeek"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>triggerDayOfWeek</code> property.
   * The day of the week which the trigger is configured
   * to fire.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#getTriggerDayOfWeek
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#setTriggerDayOfWeek
   */
  public static final Property triggerDayOfWeek = newProperty(Flags.OPERATOR, BWeekday.make(BWeekday.MONDAY),null);
  
  /**
   * Get the <code>triggerDayOfWeek</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#triggerDayOfWeek
   */
  public BWeekday getTriggerDayOfWeek() { return (BWeekday)get(triggerDayOfWeek); }
  
  /**
   * Set the <code>triggerDayOfWeek</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#triggerDayOfWeek
   */
  public void setTriggerDayOfWeek(BWeekday v) { set(triggerDayOfWeek,v,null); }

////////////////////////////////////////////////////////////////
// Property "triggerWeekInterval"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>triggerWeekInterval</code> property.
   * The number of weeks which must elapse from the lastTrigger
   * before the nextTrigger is scheduled.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#getTriggerWeekInterval
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#setTriggerWeekInterval
   */
  public static final Property triggerWeekInterval = newProperty(Flags.OPERATOR, 1,null);
  
  /**
   * Get the <code>triggerWeekInterval</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#triggerWeekInterval
   */
  public int getTriggerWeekInterval() { return getInt(triggerWeekInterval); }
  
  /**
   * Set the <code>triggerWeekInterval</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#triggerWeekInterval
   */
  public void setTriggerWeekInterval(int v) { setInt(triggerWeekInterval,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastTrigger"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>lastTrigger</code> property.
   * The time of the last trigger or null is no trigger
   * has ever occurred.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#getLastTrigger
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#setLastTrigger
   */
  public static final Property lastTrigger = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the <code>lastTrigger</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#lastTrigger
   */
  public BAbsTime getLastTrigger() { return (BAbsTime)get(lastTrigger); }
  
  /**
   * Set the <code>lastTrigger</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#lastTrigger
   */
  public void setLastTrigger(BAbsTime v) { set(lastTrigger,v,null); }

////////////////////////////////////////////////////////////////
// Property "nextTrigger"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>nextTrigger</code> property.
   * The next time that a trigger will be fired.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#getNextTrigger
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#setNextTrigger
   */
  public static final Property nextTrigger = newProperty(Flags.READONLY, BAbsTime.END_OF_TIME,null);
  
  /**
   * Get the <code>nextTrigger</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#nextTrigger
   */
  public BAbsTime getNextTrigger() { return (BAbsTime)get(nextTrigger); }
  
  /**
   * Set the <code>nextTrigger</code> property.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#nextTrigger
   */
  public void setNextTrigger(BAbsTime v) { set(nextTrigger,v,null); }

////////////////////////////////////////////////////////////////
// Action "presetNextTrigger"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>presetNextTrigger</code> action.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#presetNextTrigger()
   */
  public static final Action presetNextTrigger = newAction(Flags.OPERATOR,BAbsTime.make(),null);
  
  /**
   * Invoke the <code>presetNextTrigger</code> action.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#presetNextTrigger
   */
  public void presetNextTrigger(BAbsTime date) { invoke(presetNextTrigger,date,null); }

////////////////////////////////////////////////////////////////
// Action "ticketExpired"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>ticketExpired</code> action.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#ticketExpired()
   */
  public static final Action ticketExpired = newAction(Flags.HIDDEN,null);
  
  /**
   * Invoke the <code>ticketExpired</code> action.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#ticketExpired
   */
  public void ticketExpired() { invoke(ticketExpired,null,null); }

////////////////////////////////////////////////////////////////
// Topic "trigger"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>trigger</code> topic.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#fireTrigger
   */
  public static final Topic trigger = newTopic(0,null);
  
  /**
   * Fire an event for the <code>trigger</code> topic.
   * @see com.vykon.vykonPro.timer.BWeeklyTrigger#trigger
   */
  public void fireTrigger(BValue event) { fire(trigger, event, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BWeeklyTrigger.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  /*
   * init after steady state has been reached
   */
  public void atSteadyState()
  {
    if(isRunning()) init();
  }
  
  /*
   * init if started after steady state has been reached
   */
  public void started()
  {
    if(Sys.atSteadyState()) init();
  }
  
  /*
   * clean up on stop
   */
  public void stopped()
  {
    if(ticket !=null) ticket.cancel();
  }
  
  public void changed(Property p, Context cx)
  {
    if(!isRunning()) return;
    
    if(p.equals(triggerDayOfWeek) ||
        p.equals(triggerTime) ||
        p.equals(triggerWeekInterval))
    {
      setNextTrigger(BAbsTime.NULL);
      init();
    }
  }
  
  public void clockChanged(BRelTime shift)
  {
    init();
  }
  
  /*
   * init ticket
   */
  public void init()
  {
    if(ticket != null) ticket.cancel();
    BAbsTime current = Clock.time();
    int weekday = current.getWeekday().getOrdinal();
    int nextWeekday = getTriggerDayOfWeek().getOrdinal();

    if(getTriggerWeekInterval()<1 || nextWeekday<1) return;

    if(getNextTrigger() == BAbsTime.NULL || getNextTrigger() == BAbsTime.END_OF_TIME) 
    {
      //need to initialize the nextTriggerTime
      if(getLastTrigger() == BAbsTime.NULL)
      {
        //trigger has never fired so just find next date that matches
        if(weekday == nextWeekday && getTriggerTime().getTimeOfDayMillis() > current.getTimeOfDayMillis())
        {
          //trigger is still in the future for today
          setNextTrigger(BAbsTime.make(current, getTriggerTime()));
        }
        else
        {
          //trigger is past for today or at least a day out so walk to find next day
          BAbsTime nextDay = current;
          for(int i=0; i<7; i++)
          {
            nextDay = nextDay.nextDay();
            if(nextDay.getWeekday().getOrdinal()==nextWeekday) break;
          }
          setNextTrigger(BAbsTime.make(nextDay, getTriggerTime()));
        }
      }
      else
      {
        //trigger has fired in the past so need to use that as the start point
        BAbsTime last = getLastTrigger();
        
        if(last.getWeekday().getOrdinal()!=nextWeekday)
        {
          //trigger day has changed so walk the week to find the weekday
          for(int j=0; j<7; j++)
          {
            last = last.nextDay();
            if(last.getWeekday().getOrdinal()==nextWeekday) break;
          }
        }
        
        //find the nextTrigger using the triggerWeekInterval
        last = findNextWeek(last);
        
        //check current against last and find next week if not past
        while(last.isBefore(current))
        {
          last = findNextWeek(last);
        }
        
        setNextTrigger(BAbsTime.make(last, getTriggerTime()));
        
      }
      
    }
    else if(current.isAfter(getNextTrigger()))
    {
      ticketExpired();
    }
    else ticket = Clock.schedule(this, getNextTrigger(), ticketExpired, null);
  }
  
  private BAbsTime findNextWeek(BAbsTime last)
  {
    for (int k = 0; k < getTriggerWeekInterval(); k++)
    {
      last = last.next(getTriggerDayOfWeek());
    }
    
    return last;
  }
  
  ////////////////////////////////////////////////////////
  // actions
  ////////////////////////////////////////////////////////
  
  public void doTicketExpired()
  {
    if (!isRunning())
      return;

    BAbsTime current = Clock.time();
    BAbsTime next = getNextTrigger();
    
    if (current.isAfter(getNextTrigger()))
    {
      fireTrigger(null);
      
      for (int i = 0; i < getTriggerWeekInterval(); i++)
      {
        next = next.next(getTriggerDayOfWeek());
      }

      setLastTrigger(getNextTrigger());
      setNextTrigger(next);
    }
    
    if (ticket != null)
      ticket.cancel();
    ticket = Clock.schedule(this, next, ticketExpired, null);
  }
  
  public void doPresetNextTrigger(BAbsTime date)
  {
    setNextTrigger(date);
    init();
  }
  
  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("control/trigger.png");

  ///////////////////////////////////////////////////////////
  // local variables
  ///////////////////////////////////////////////////////////
  
  Clock.Ticket ticket = null;
}
