package com.vykon.vykonPro.util;

import com.tridium.history.audit.BAuditHistoryService;
import com.tridium.history.audit.BAuditRecord;
import com.vykon.vykonPro.point.BAuditExt;

import javax.baja.control.BControlPoint;
import javax.baja.history.BHistoryRecord;
import javax.baja.naming.BOrd;
import javax.baja.nre.annotations.NiagaraAction;
import javax.baja.nre.annotations.NiagaraProperty;
import javax.baja.nre.annotations.NiagaraType;
import javax.baja.sys.*;
import javax.baja.util.*;

/**
 * Created by james on 2/7/2019.
 */

@NiagaraType

@NiagaraAction(
        name = "checkRecord",
        flags = Flags.ASYNC,
        parameterType = "history:HistoryRecord",
        defaultValue = "new BAuditRecord()"
)

@NiagaraProperty(
        name = "worker",
        type = "BVykonProWorker",
        defaultValue = "new BVykonProWorker()"
)

public class BActionAuditService
    extends BAbstractService implements BIService
{
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BActionAuditService(296936188)1.0$ @*/
/* Generated Thu Feb 07 11:08:39 EST 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "worker"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code worker} property.
   * @see #getWorker
   * @see #setWorker
   */
  public static final Property worker = newProperty(0, new BVykonProWorker(), null);
  
  /**
   * Get the {@code worker} property.
   * @see #worker
   */
  public BVykonProWorker getWorker() { return (BVykonProWorker)get(worker); }
  
  /**
   * Set the {@code worker} property.
   * @see #worker
   */
  public void setWorker(BVykonProWorker v) { set(worker, v, null); }

////////////////////////////////////////////////////////////////
// Action "checkRecord"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code checkRecord} action.
   * @see #checkRecord(BHistoryRecord parameter)
   */
  public static final Action checkRecord = newAction(Flags.ASYNC, new BAuditRecord(), null);
  
  /**
   * Invoke the {@code checkRecord} action.
   * @see #checkRecord
   */
  public void checkRecord(BHistoryRecord parameter) { invoke(checkRecord, parameter, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BActionAuditService.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

    private static Type[] serviceTypes = new Type[] { TYPE };

    @Override
    public Type[] getServiceTypes() {
        return serviceTypes;
    }

    public boolean isParentLegal ( BComponent parent)
    {
        return(parent instanceof BServiceContainer);
    }

    public void serviceStarted() throws Exception
    {
      //getComponentSpace().enableMixIn(BAuditExt.TYPE);
      checkLink();
      super.serviceStarted();
    }

    public void serviceStopped() throws Exception
    {
      //getComponentSpace().disableMixIn(BAuditExt.TYPE);
      super.serviceStopped();
    }

  public void stationStarted()
  {
    checkLink();
  }

  private void checkLink()
  {
    BAuditHistoryService service = (BAuditHistoryService)Sys.getService(BAuditHistoryService.TYPE);
    if(service!=null && !isLinkTarget(checkRecord))
    {
      BLink link = new BLink(service.getHandleOrd(), "lastRecord", "checkRecord", true);
      if(get("auditLInk")==null) this.add("auditLink", link);
      else set("auditLink", link, null);
    }
  }

    public IFuture post(Action action, BValue argument, Context cx)
    {
        if(action == checkRecord)
            return getWorker().post(new Invocation(this, action, argument, cx));
        else
            return super.post(action, argument, cx);
    }

  public void doCheckRecord(BHistoryRecord record)
  {
    BAuditRecord rec = (BAuditRecord)record;
    if(rec.getOperation().equals("Invoked"))
    {
      BOrd targetOrd = BOrd.make("station:|slot:" + rec.getTarget());
      BComponent comp = (BComponent)targetOrd.resolve().get();
      if(comp!=null && comp instanceof BControlPoint)
      {
        BAuditExt[] extensions = ((BControlPoint)comp).getChildren(BAuditExt.class);
        for(int i=0; i<extensions.length; i++)
        {
          extensions[i].checkRecord(rec);
        }
      }
    }
  }

    /**
     * Get the icon.
     */
    public BIcon getIcon()
    {
        return icon;
    }

    private static final BIcon icon = BIcon.std("navOnly/histories.png");

}
