package com.vykon.vykonPro.util;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.Socket;
import javax.baja.status.BStatus;
import javax.baja.status.BStatusBoolean;
import javax.baja.status.BStatusString;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BComponent;
import javax.baja.sys.BFacets;
import javax.baja.sys.BIcon;
import javax.baja.sys.BInteger;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BValue;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.units.BUnit;
import javax.baja.util.IFuture;
import javax.baja.util.Invocation;

public class BConnectionFailover
    extends BComponent
{
  /*-
   class BConnectionFailover
   {
     properties
     {
       status: BStatus
           -- The status of the component
           flags { readonly, transient }
           default {[ BStatus.ok ]}
           
      faultCause: String
           -- The fault cause.
           flags { readonly, transient }
           default {[ "" ]}
       
       enabled: boolean
         -- Property which controls whether the component is enabled or disabled.
         default {[ true ] }
         slotfacets {[BFacets.makeBoolean("enabled", "disabled") ]}
       
       restoreMode: boolean
         -- Property which controls whether the component automatically clear the failure or if it requires a manual action by an operator.
         default {[ false ]}
         slotfacets {[ BFacets.makeBoolean("automatic", "manual") ]}
          
       pingFrequency:BRelTime
         -- frequency at which the host is pinged.
         flags{ }
         default{[ BRelTime.makeMinutes(5) ]}
       
       pingHost:String
         -- host address to ping for testing primary connectivity
         flags{ summary, operator }
         default{[ "enter host address here" ]}

       pingPort:int
         -- port used when pinging the host
         default{[ 80 ]}
         flags{ operator }
         
       pingTimeout:int
         -- timeout used when evaluating a ping failure
         default{[ 5 ]}
         slotfacets{[ BFacets.make(BFacets.UNITS, BUnit.getUnit("second"), BFacets.MIN, BInteger.make(0)) ]}
       
       pingFailureLimit:int
         -- number of consecutive ping failures required to cause the pingFail slot to indicate a failure.
         default{[ 3 ]}
         slotfacets{[ BFacets.make(BFacets.MIN, BInteger.make(1)) ]}
       
       numberOfPingFails:int
         -- slot which stores the number of consecutive ping failures.  Automatically reset to zero on a successful ping.
         flags{ readonly }
         default{[ 0 ]}
         
       pingStatus:BStatusString
         -- status message result of ping attempt.
         flags{ summary, readonly }
         default{[ new BStatusString() ]}
         
       pingFail:BStatusBoolean
         -- StatusBoolean output which reflects the status of the ping attempt
         flags{ summary, readonly }
         default{[ new BStatusBoolean() ]}
       
       lastPingTime:BAbsTime
         -- time of last ping attempt.
         flags{ readonly }
         default{[ BAbsTime.NULL ]}
         
         
     }
     actions
     {
       ping()
         flags{async}
       resetFail()
     }
     topics
     {
     
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BConnectionFailover(1366382904)1.0$ @*/
/* Generated Wed May 27 09:54:47 EDT 2015 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code status} property.
   * The status of the component
   * @see #getStatus
   * @see #setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.TRANSIENT, BStatus.ok,null);
  
  /**
   * Get the {@code status} property.
   * The status of the component
   * @see #status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the {@code status} property.
   * The status of the component
   * @see #status
   */
  public void setStatus(BStatus v) { set(status,v,null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code faultCause} property.
   * The fault cause.
   * @see #getFaultCause
   * @see #setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.TRANSIENT, "",null);
  
  /**
   * Get the {@code faultCause} property.
   * The fault cause.
   * @see #faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the {@code faultCause} property.
   * The fault cause.
   * @see #faultCause
   */
  public void setFaultCause(String v) { setString(faultCause,v,null); }

////////////////////////////////////////////////////////////////
// Property "enabled"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code enabled} property.
   * Property which controls whether the component is enabled or disabled.
   * @see #getEnabled
   * @see #setEnabled
   */
  public static final Property enabled = newProperty(0, true,BFacets.makeBoolean("enabled", "disabled"));
  
  /**
   * Get the {@code enabled} property.
   * Property which controls whether the component is enabled or disabled.
   * @see #enabled
   */
  public boolean getEnabled() { return getBoolean(enabled); }
  
  /**
   * Set the {@code enabled} property.
   * Property which controls whether the component is enabled or disabled.
   * @see #enabled
   */
  public void setEnabled(boolean v) { setBoolean(enabled,v,null); }

////////////////////////////////////////////////////////////////
// Property "restoreMode"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code restoreMode} property.
   * Property which controls whether the component automatically clear the failure or if it requires a manual action by an operator.
   * @see #getRestoreMode
   * @see #setRestoreMode
   */
  public static final Property restoreMode = newProperty(0, false,BFacets.makeBoolean("automatic", "manual"));
  
  /**
   * Get the {@code restoreMode} property.
   * Property which controls whether the component automatically clear the failure or if it requires a manual action by an operator.
   * @see #restoreMode
   */
  public boolean getRestoreMode() { return getBoolean(restoreMode); }
  
  /**
   * Set the {@code restoreMode} property.
   * Property which controls whether the component automatically clear the failure or if it requires a manual action by an operator.
   * @see #restoreMode
   */
  public void setRestoreMode(boolean v) { setBoolean(restoreMode,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingFrequency"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingFrequency} property.
   * frequency at which the host is pinged.
   * @see #getPingFrequency
   * @see #setPingFrequency
   */
  public static final Property pingFrequency = newProperty(0, BRelTime.makeMinutes(5),null);
  
  /**
   * Get the {@code pingFrequency} property.
   * frequency at which the host is pinged.
   * @see #pingFrequency
   */
  public BRelTime getPingFrequency() { return (BRelTime)get(pingFrequency); }
  
  /**
   * Set the {@code pingFrequency} property.
   * frequency at which the host is pinged.
   * @see #pingFrequency
   */
  public void setPingFrequency(BRelTime v) { set(pingFrequency,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingHost"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingHost} property.
   * host address to ping for testing primary connectivity
   * @see #getPingHost
   * @see #setPingHost
   */
  public static final Property pingHost = newProperty(Flags.SUMMARY|Flags.OPERATOR, "enter host address here",null);
  
  /**
   * Get the {@code pingHost} property.
   * host address to ping for testing primary connectivity
   * @see #pingHost
   */
  public String getPingHost() { return getString(pingHost); }
  
  /**
   * Set the {@code pingHost} property.
   * host address to ping for testing primary connectivity
   * @see #pingHost
   */
  public void setPingHost(String v) { setString(pingHost,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingPort"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingPort} property.
   * port used when pinging the host
   * @see #getPingPort
   * @see #setPingPort
   */
  public static final Property pingPort = newProperty(Flags.OPERATOR, 80,null);
  
  /**
   * Get the {@code pingPort} property.
   * port used when pinging the host
   * @see #pingPort
   */
  public int getPingPort() { return getInt(pingPort); }
  
  /**
   * Set the {@code pingPort} property.
   * port used when pinging the host
   * @see #pingPort
   */
  public void setPingPort(int v) { setInt(pingPort,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingTimeout"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingTimeout} property.
   * timeout used when evaluating a ping failure
   * @see #getPingTimeout
   * @see #setPingTimeout
   */
  public static final Property pingTimeout = newProperty(0, 5,BFacets.make(BFacets.UNITS, BUnit.getUnit("second"), BFacets.MIN, BInteger.make(0)));
  
  /**
   * Get the {@code pingTimeout} property.
   * timeout used when evaluating a ping failure
   * @see #pingTimeout
   */
  public int getPingTimeout() { return getInt(pingTimeout); }
  
  /**
   * Set the {@code pingTimeout} property.
   * timeout used when evaluating a ping failure
   * @see #pingTimeout
   */
  public void setPingTimeout(int v) { setInt(pingTimeout,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingFailureLimit"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingFailureLimit} property.
   * number of consecutive ping failures required to cause the pingFail slot to indicate a failure.
   * @see #getPingFailureLimit
   * @see #setPingFailureLimit
   */
  public static final Property pingFailureLimit = newProperty(0, 3,BFacets.make(BFacets.MIN, BInteger.make(1)));
  
  /**
   * Get the {@code pingFailureLimit} property.
   * number of consecutive ping failures required to cause the pingFail slot to indicate a failure.
   * @see #pingFailureLimit
   */
  public int getPingFailureLimit() { return getInt(pingFailureLimit); }
  
  /**
   * Set the {@code pingFailureLimit} property.
   * number of consecutive ping failures required to cause the pingFail slot to indicate a failure.
   * @see #pingFailureLimit
   */
  public void setPingFailureLimit(int v) { setInt(pingFailureLimit,v,null); }

////////////////////////////////////////////////////////////////
// Property "numberOfPingFails"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code numberOfPingFails} property.
   * slot which stores the number of consecutive ping failures.  Automatically reset to zero on a successful ping.
   * @see #getNumberOfPingFails
   * @see #setNumberOfPingFails
   */
  public static final Property numberOfPingFails = newProperty(Flags.READONLY, 0,null);
  
  /**
   * Get the {@code numberOfPingFails} property.
   * slot which stores the number of consecutive ping failures.  Automatically reset to zero on a successful ping.
   * @see #numberOfPingFails
   */
  public int getNumberOfPingFails() { return getInt(numberOfPingFails); }
  
  /**
   * Set the {@code numberOfPingFails} property.
   * slot which stores the number of consecutive ping failures.  Automatically reset to zero on a successful ping.
   * @see #numberOfPingFails
   */
  public void setNumberOfPingFails(int v) { setInt(numberOfPingFails,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingStatus"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingStatus} property.
   * status message result of ping attempt.
   * @see #getPingStatus
   * @see #setPingStatus
   */
  public static final Property pingStatus = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusString(),null);
  
  /**
   * Get the {@code pingStatus} property.
   * status message result of ping attempt.
   * @see #pingStatus
   */
  public BStatusString getPingStatus() { return (BStatusString)get(pingStatus); }
  
  /**
   * Set the {@code pingStatus} property.
   * status message result of ping attempt.
   * @see #pingStatus
   */
  public void setPingStatus(BStatusString v) { set(pingStatus,v,null); }

////////////////////////////////////////////////////////////////
// Property "pingFail"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code pingFail} property.
   * StatusBoolean output which reflects the status of the ping attempt
   * @see #getPingFail
   * @see #setPingFail
   */
  public static final Property pingFail = newProperty(Flags.SUMMARY|Flags.READONLY, new BStatusBoolean(),null);
  
  /**
   * Get the {@code pingFail} property.
   * StatusBoolean output which reflects the status of the ping attempt
   * @see #pingFail
   */
  public BStatusBoolean getPingFail() { return (BStatusBoolean)get(pingFail); }
  
  /**
   * Set the {@code pingFail} property.
   * StatusBoolean output which reflects the status of the ping attempt
   * @see #pingFail
   */
  public void setPingFail(BStatusBoolean v) { set(pingFail,v,null); }

////////////////////////////////////////////////////////////////
// Property "lastPingTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code lastPingTime} property.
   * time of last ping attempt.
   * @see #getLastPingTime
   * @see #setLastPingTime
   */
  public static final Property lastPingTime = newProperty(Flags.READONLY, BAbsTime.NULL,null);
  
  /**
   * Get the {@code lastPingTime} property.
   * time of last ping attempt.
   * @see #lastPingTime
   */
  public BAbsTime getLastPingTime() { return (BAbsTime)get(lastPingTime); }
  
  /**
   * Set the {@code lastPingTime} property.
   * time of last ping attempt.
   * @see #lastPingTime
   */
  public void setLastPingTime(BAbsTime v) { set(lastPingTime,v,null); }

////////////////////////////////////////////////////////////////
// Action "ping"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code ping} action.
   * @see #ping()
   */
  public static final Action ping = newAction(Flags.ASYNC,null);
  
  /**
   * Invoke the {@code ping} action.
   * @see #ping
   */
  public void ping() { invoke(ping,null,null); }

////////////////////////////////////////////////////////////////
// Action "resetFail"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code resetFail} action.
   * @see #resetFail()
   */
  public static final Action resetFail = newAction(0,null);
  
  /**
   * Invoke the {@code resetFail} action.
   * @see #resetFail
   */
  public void resetFail() { invoke(resetFail,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BConnectionFailover.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started()
  {
    checkForService();
    if(getEnabled()) initClockTicket();
  }

  public void stopped()
  {
    if (ticket != null) ticket.cancel();
  }
  
  private final void checkForService()
  {
    if(BVykonProService.getInstance()==null)
    {
      setStatus(BStatus.fault);
      setFaultCause("This component requires the VykonPro service in the station");
    }
    else if(BVykonProService.getInstance().isDisabled())
    {
      setStatus(BStatus.fault);
      setFaultCause("The vykonPro service is disabled");
    }
    else
    {
      setStatus(BStatus.ok);
      setFaultCause("");
    }
  }
  
  public void clockChanged(BRelTime value)
  {
    if (getEnabled())
    {
      initClockTicket();
    }
  }
  
  public void changed(Property property, Context context) 
  {
    super.changed(property, context);
    if( !Sys.atSteadyState() || !isRunning() )
     return;
     
    if(property.equals(pingFrequency) && getEnabled()) initClockTicket();
    
    if(property.equals(enabled) && getEnabled()) initClockTicket();
  }
  
  void initClockTicket()
  {            
    if (ticket != null) ticket.cancel();
    ticket = Clock.schedule(this, getPingFrequency(), ping, null);
  }
  
  public IFuture post(Action action, BValue argument, Context cx)
  {
    if(action == ping)
      return BVykonProService.getInstance().getWorker().post(new Invocation(this, action, argument, cx));
    else
      return super.post(action, argument, cx);
  }
  
  public void doPing() throws Exception
  {
    initClockTicket();

    if(getStatus().isFault())
    {
      checkForService();
      if(getStatus().isFault()) return;
    }

    
    if(getPingHost().length()==0 )
    {
      getPingStatus().setValue("ping host not set");
      return;
    }

    Socket socket = new Socket();

    try
    {
      InetSocketAddress isa = new InetSocketAddress(InetAddress.getByName(getPingHost()), getPingPort());
      socket.connect(isa, getPingTimeout()*1000);

      getPingStatus().setValue("ping successfull " + getPingHost());
      
      //check if currently in pingFail
      if(getPingFail().getValue())
      {
        //currently in pingFail, check restoreMode to see if we should automatically clear it
        if(getRestoreMode())
        {
          getPingFail().setValue(false);
        }
      }
      setNumberOfPingFails(0);
      
    }
    catch (Exception e)
    {
      getPingStatus().setValue("ping failed " + getPingHost());
      
      //increment the current numberOfPingFails value
      setNumberOfPingFails(getNumberOfPingFails() + 1);
      
      //check if numberOfPingFails is above the limit and set to true
      if(getNumberOfPingFails() > getPingFailureLimit())
      {
        getPingFail().setValue(true);
      }
	  
	  e.printStackTrace();
    }
    finally
    {
      if (socket != null) socket.close();
    }
    setLastPingTime(Clock.time());
  }

  public void doResetFail()
  {
    getPingFail().setValue(false);
    setNumberOfPingFails(0);
    getPingStatus().setValue("cleared ping fail state at time - " + Clock.time());
  }
  
  /**
   * Get the icon.
   */
  public BIcon getIcon()
  {
    return icon;
  }

  private static final BIcon icon = BIcon.std("gears.png");

  
//////////////////////////////////////////////////////////////////////////////
// local variables
//////////////////////////////////////////////////////////////////////////////
  
  Clock.Ticket ticket;
}
