package com.vykon.vykonPro.util;

import javax.baja.naming.SlotPath;
import javax.baja.sys.Action;
import javax.baja.sys.BComponent;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.BFormat;

public class BFormatToStringResolver
    extends BComponent
{
  /*-
   class BFormatToStringResolver
   {
     properties
     {
     format: BFormat
        --String which when resolved is stored in the out field
        flags{ }
        default {[ BFormat.make("%.%") ]}

      allowEscape: boolean
        --Configures whether the BFormat syntax may use the escape() syntax.
         default{[ false ]}

      out: String
        --Resolved String based on format text.
        flags{ readonly }
        default{[ "" ]}
     }
     actions
     {
       updateOut()
     }
     topics
     {
     }
   }
   -*/

/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BFormatToStringResolver(733013897)1.0$ @*/
/* Generated Wed Apr 10 13:20:48 EDT 2019 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "format"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code format} property.
   * String which when resolved is stored in the out field
   * @see #getFormat
   * @see #setFormat
   */
  public static final Property format = newProperty(0, BFormat.make("%.%"), null);
  
  /**
   * Get the {@code format} property.
   * String which when resolved is stored in the out field
   * @see #format
   */
  public BFormat getFormat() { return (BFormat)get(format); }
  
  /**
   * Set the {@code format} property.
   * String which when resolved is stored in the out field
   * @see #format
   */
  public void setFormat(BFormat v) { set(format, v, null); }

////////////////////////////////////////////////////////////////
// Property "allowEscape"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code allowEscape} property.
   * Configures whether the BFormat syntax may use the escape() syntax.
   * @see #getAllowEscape
   * @see #setAllowEscape
   */
  public static final Property allowEscape = newProperty(0, false, null);
  
  /**
   * Get the {@code allowEscape} property.
   * Configures whether the BFormat syntax may use the escape() syntax.
   * @see #allowEscape
   */
  public boolean getAllowEscape() { return getBoolean(allowEscape); }
  
  /**
   * Set the {@code allowEscape} property.
   * Configures whether the BFormat syntax may use the escape() syntax.
   * @see #allowEscape
   */
  public void setAllowEscape(boolean v) { setBoolean(allowEscape, v, null); }

////////////////////////////////////////////////////////////////
// Property "out"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code out} property.
   * Resolved String based on format text.
   * @see #getOut
   * @see #setOut
   */
  public static final Property out = newProperty(Flags.READONLY, "", null);
  
  /**
   * Get the {@code out} property.
   * Resolved String based on format text.
   * @see #out
   */
  public String getOut() { return getString(out); }
  
  /**
   * Set the {@code out} property.
   * Resolved String based on format text.
   * @see #out
   */
  public void setOut(String v) { setString(out, v, null); }

////////////////////////////////////////////////////////////////
// Action "updateOut"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code updateOut} action.
   * @see #updateOut()
   */
  public static final Action updateOut = newAction(0, null);
  
  /**
   * Invoke the {@code updateOut} action.
   * @see #updateOut
   */
  public void updateOut() { invoke(updateOut, null, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BFormatToStringResolver.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started() throws Exception
  {
    updateOut();
  }

  public void changed(Property property, Context context) 
  {
   super.changed(property, context);
    if( !Sys.atSteadyState() || !isRunning() )
     return;
   
   if(property.equals(format) || property.equals(allowEscape)) updateOut();
    
  }
  
  private String resolveFormat()
  {
    BFormat pattern = getFormat();
    
    // This is a tricky issue.  It looks funny but it's correct.
    // The resolved pattern must be unescaped because it may include
    // slot names of ancestors (ex. "%parent.name%") which are already
    // escaped.  Sometimes the result needs to be escaped because
    // it may just be static test (ex. "My History").  By unescaping
    // the result first, the escape will always return the right result.
    //
    // added allowEscape so escape() syntax can be used to format for BQL
    // where need something like $242d instead of $2d
    if(getAllowEscape()) return (pattern.format(this));

    return SlotPath.unescape(SlotPath.escape(SlotPath.unescape(pattern.format(this))));
  }
  
  public void doUpdateOut()
  {
    String newout = resolveFormat();
    setOut(newout);
  }

}
