package com.vykon.vykonPro.util;

import javax.baja.naming.BOrd;
import javax.baja.naming.OrdQuery;
import javax.baja.sys.*;

public class BHyperlinkList
    extends BComponent
{
  /*-
   class BHyperlinkList
   {
     properties
     {
       numberOfHyperlinks:int
         -- The number of hyperlink ords to be configured on this component
         default{[ 0 ]}
         slotfacets {[ BFacets.makeInt(null, 0, Integer.MAX_VALUE) ]}
     }
     actions
     {
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BHyperlinkList(2004117763)1.0$ @*/
/* Generated Wed Mar 17 13:16:52 EDT 2010 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "numberOfHyperlinks"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>numberOfHyperlinks</code> property.
   * The number of hyperlink ords to be configured on this
   * component
   * @see com.vykon.vykonPro.util.BHyperlinkList#getNumberOfHyperlinks
   * @see com.vykon.vykonPro.util.BHyperlinkList#setNumberOfHyperlinks
   */
  public static final Property numberOfHyperlinks = newProperty(0, 0,BFacets.makeInt(null, 0, Integer.MAX_VALUE));
  
  /**
   * Get the <code>numberOfHyperlinks</code> property.
   * @see com.vykon.vykonPro.util.BHyperlinkList#numberOfHyperlinks
   */
  public int getNumberOfHyperlinks() { return getInt(numberOfHyperlinks); }
  
  /**
   * Set the <code>numberOfHyperlinks</code> property.
   * @see com.vykon.vykonPro.util.BHyperlinkList#numberOfHyperlinks
   */
  public void setNumberOfHyperlinks(int v) { setInt(numberOfHyperlinks,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHyperlinkList.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started() throws Exception
  {
    super.started();
    checkOrds();
  }

  public void changed(Property prop, Context cx)
  {
    if(!isRunning()) return;
    
    if(prop.equals(numberOfHyperlinks))
    {
      initHyperlinks();
    }
    else if(prop.getName().startsWith("hyperlinkOrd"))
    {
      checkOrds();
    }
  }

  public void initHyperlinks()
  {
    //check the required number of links
    int numLinks = getNumberOfHyperlinks();
    
    //check the number of existing slots
    int numSlots = this.getChildren(BOrd.class).length;
    
    //need to decide if adding or removing links
    if(numLinks > numSlots)
    {
      //we are adding more links
      for(int i=1; i<=numLinks; i++) //int i=0; i<numLinks; i++
      {
        if(i>numSlots)
        {
          //gotten to the ones that we need to add
          this.add("hyperlinkOrd"+ i, makeDefaultOrd());
          this.add("hyperlinkDisplay" + i, makeDefaultString());
          this.add("external"+i, makeDefaultBoolean(),Flags.READONLY + Flags.HIDDEN);
        }
      }
    }
    else if(numLinks < numSlots)
    {
      //we are removing links
      for(int i=1; i<=numSlots; i++) //int i=0; i<lastNumLinks; i++
      {
        //if(i>numLinks-1)
        if(i>numLinks)
        {
          //gotten to the ones that we need to remove
          this.remove("hyperlinkOrd"+i);
          this.remove("hyperlinkDisplay"+i);
          this.remove("external"+i);
        }
      }
    }
  }
  
  private void checkOrds()
  {
    int numLinks = getNumberOfHyperlinks();
    BOrd[] ords = this.getChildren(BOrd.class);
    for(int i=1; i<=numLinks; i++)
    {
      if(get("external"+i)==null)
      {
        this.add("external"+i, makeDefaultBoolean(),Flags.READONLY + Flags.HIDDEN);
      }

      if(ords[i-1].equals(BOrd.DEFAULT)) continue;

      OrdQuery[] queries = ords[i-1].parse();
      if(queries.length>0)
      {
        String scheme = queries[0].getScheme().toLowerCase();
        if(scheme.equals("ip") || scheme.equals("http") || scheme.equals("https"))
          this.set("external"+i,BBoolean.make(true));
        else this.set("external"+i,BBoolean.make(false));
      }
    }
  }

  private static BOrd makeDefaultOrd()
  {
    BOrd o = BOrd.NULL;
    return o;
  }
  
  private static BValue makeDefaultString()
  {
    BString s = BString.make("");
    return s;
  }

  private static BValue makeDefaultBoolean()
  {
    BBoolean b = BBoolean.make(false);
    return b;
  }
  
  public BIcon getIcon() { return icon; }
  private static final BIcon icon = BIcon.std("hyperlink.png");

}
