package com.vykon.vykonPro.util;

import javax.baja.status.BStatus;
import javax.baja.status.BStatusNumeric;
import javax.baja.sys.BDouble;
import javax.baja.sys.BIcon;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;

import com.tridium.kitControl.util.BDecaInputNumeric;

public class BMinMaxAvg
    extends BDecaInputNumeric
{
  /*-
   class BMinMaxAvg
   {
     properties
     {
       min: BStatusNumeric
        -- The output of a BNumericPoint is a BStatusNumeric
        flags { operator, readonly, transient, summary }
        default {[ new BStatusNumeric() ]}
        
      max: BStatusNumeric
        -- The output of a BNumericPoint is a BStatusNumeric
        flags { operator, readonly, transient, summary }
        default {[ new BStatusNumeric() ]}
        
      avg: BStatusNumeric
        -- The output of a BNumericPoint is a BStatusNumeric
        flags { operator, readonly, transient, summary }
        default {[ new BStatusNumeric() ]}
     }
     actions
     {
     
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonPro.util.BMinMaxAvg(1757543417)1.0$ @*/
/* Generated Wed Mar 11 14:26:10 ACT 2009 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Property "min"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>min</code> property.
   * The output of a BNumericPoint is a BStatusNumeric
   * @see com.vykon.vykonPro.util.BMinMaxAvg#getMin
   * @see com.vykon.vykonPro.util.BMinMaxAvg#setMin
   */
  public static final Property min = newProperty(Flags.OPERATOR|Flags.READONLY|Flags.TRANSIENT|Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>min</code> property.
   * @see com.vykon.vykonPro.util.BMinMaxAvg#min
   */
  public BStatusNumeric getMin() { return (BStatusNumeric)get(min); }
  
  /**
   * Set the <code>min</code> property.
   * @see com.vykon.vykonPro.util.BMinMaxAvg#min
   */
  public void setMin(BStatusNumeric v) { set(min,v,null); }

////////////////////////////////////////////////////////////////
// Property "max"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>max</code> property.
   * The output of a BNumericPoint is a BStatusNumeric
   * @see com.vykon.vykonPro.util.BMinMaxAvg#getMax
   * @see com.vykon.vykonPro.util.BMinMaxAvg#setMax
   */
  public static final Property max = newProperty(Flags.OPERATOR|Flags.READONLY|Flags.TRANSIENT|Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>max</code> property.
   * @see com.vykon.vykonPro.util.BMinMaxAvg#max
   */
  public BStatusNumeric getMax() { return (BStatusNumeric)get(max); }
  
  /**
   * Set the <code>max</code> property.
   * @see com.vykon.vykonPro.util.BMinMaxAvg#max
   */
  public void setMax(BStatusNumeric v) { set(max,v,null); }

////////////////////////////////////////////////////////////////
// Property "avg"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the <code>avg</code> property.
   * The output of a BNumericPoint is a BStatusNumeric
   * @see com.vykon.vykonPro.util.BMinMaxAvg#getAvg
   * @see com.vykon.vykonPro.util.BMinMaxAvg#setAvg
   */
  public static final Property avg = newProperty(Flags.OPERATOR|Flags.READONLY|Flags.TRANSIENT|Flags.SUMMARY, new BStatusNumeric(),null);
  
  /**
   * Get the <code>avg</code> property.
   * @see com.vykon.vykonPro.util.BMinMaxAvg#avg
   */
  public BStatusNumeric getAvg() { return (BStatusNumeric)get(avg); }
  
  /**
   * Set the <code>avg</code> property.
   * @see com.vykon.vykonPro.util.BMinMaxAvg#avg
   */
  public void setAvg(BStatusNumeric v) { set(avg,v,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BMinMaxAvg.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


////////////////////////////////////////////////////////////////
//Interfaces
////////////////////////////////////////////////////////////////

 public void doCalculate()
 {
   double min = Double.POSITIVE_INFINITY;
   double max = Double.NEGATIVE_INFINITY;
   double avg = 0.0;
   double avgCount = 0;
   for(int i = 0; i < getNumberValues(); i++)
   {
     BStatusNumeric value = getInStatusValue(i);
     // 2/26/09 James J added check for NaN
     if(value.getStatus().isValid() && BDouble.make(value.getValue())!=BDouble.NaN)
     {
       if(value.getValue() < min) min = value.getValue();
       if(value.getValue() > max) max = value.getValue();
       avg = avg + value.getValue();
       avgCount++;
     }
   }
   if(min == Double.POSITIVE_INFINITY) min = Double.NaN;
   if(max == Double.NEGATIVE_INFINITY) min = Double.NaN;
   
   // 2/26/09 James J added check to prevent divide by zero condition
   // and to set status null if no valid inputs.
   if(avgCount!=0)
   {
     avg = avg / avgCount;
     getAvg().setValue(avg);
     if(getAvg().getStatus().isNull()) getAvg().setStatus(BStatus.ok);
   }
   else //no valid inputs so set avg status to null
   {
     getAvg().setStatus(BStatus.NULL);
   }
   getMin().setValue(min);
   getMax().setValue(max);
   getAvg().setValue(avg);
 }

 public final BStatusNumeric getInStatusValue(int select)
 {
   switch(select)
   {
   case 0: return getInA();
   case 1: return getInB();
   case 2: return getInC();
   case 3: return getInD();
   case 4: return getInE();
   case 5: return getInF();
   case 6: return getInG();
   case 7: return getInH();
   case 8: return getInI();
   case 9: return getInJ();
   }
   return new BStatusNumeric();
 }
 
 /**
  * Get the icon.
  */
 public BIcon getIcon() { return icon; }
 private static final BIcon icon = BIcon.std("control/util/switch.png");


}
