package com.vykon.vykonProTransform;

import javax.baja.collection.BITable;
import javax.baja.collection.Column;
import javax.baja.collection.TableCursor;
import javax.baja.history.BBooleanTrendRecord;
import javax.baja.history.BCollectionInterval;
import javax.baja.history.BEnumTrendRecord;
import javax.baja.history.BHistoryConfig;
import javax.baja.history.BHistoryId;
import javax.baja.history.BHistoryService;
import javax.baja.history.BIHistory;
import javax.baja.history.BNumericTrendRecord;
import javax.baja.history.BStringTrendRecord;
import javax.baja.history.BTrendFlags;
import javax.baja.history.db.BHistoryDatabase;
import javax.baja.history.db.HistoryDatabaseConnection;
import javax.baja.naming.BOrd;
import javax.baja.naming.BOrdList;
import javax.baja.naming.SlotPath;
import javax.baja.space.BComponentSpace;
import javax.baja.status.BStatus;
import javax.baja.sys.Action;
import javax.baja.sys.BAbsTime;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BComponent;
import javax.baja.sys.BDouble;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BEnum;
import javax.baja.sys.BFacets;
import javax.baja.sys.BInteger;
import javax.baja.sys.BNumber;
import javax.baja.sys.BObject;
import javax.baja.sys.BRelTime;
import javax.baja.sys.BString;
import javax.baja.sys.BValue;
import javax.baja.sys.Clock;
import javax.baja.sys.Context;
import javax.baja.sys.Flags;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.timezone.BTimeZone;
import javax.baja.util.BFormat;
import javax.baja.util.BTypeSpec;
import javax.baja.util.IFuture;
import javax.baja.util.Invocation;

import com.vykon.vykonPro.util.BVykonProService;



/**
 * This component attempts to resolve the configured ord property to a BITable and then processes the table
 * storing the rows as one or more histories in the station's history database.  The results of the query 
 * must be in temporal order with the oldest timestamp in the first row. The timestamp column must be
 * the first column in the table.
 *
 * @author    James Johnson
 * @creation  02 Sep 2014
 * @version   $Revision$ $Date$
 * @since     Niagara 3.7
 */

public class BTableToHistory
    extends BComponent
{
  /*-
   class BTableToHistory
   {
     properties
     {
       ord:BOrd
         -- the ord to be resolved to generate the BITable
         flags{ operator }
         default{[ BOrd.NULL ]}
         
       lastExecutionTime:BAbsTime
         -- time of last report execution
         flags{ readonly }
         default{[ BAbsTime.NULL ]}
       
       faultCause: String
         flags{ readonly, transient }
         default{[ "" ]}
         slotfacets{[ BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE, BFacets.FIELD_WIDTH, BInteger.make(120)) ]}
         
       status: BStatus
         flags{ readonly, transient }
         default{[ BStatus.ok ]}
         
       historyConfig: BHistoryConfig
         default{[ new BHistoryConfig() ]}
         
       interval: BRelTime
         default{[ BRelTime.makeMinutes(15) ]}
         flags{ operator }
         slotfacets{[ BFacets.make(BFacets.MIN, BRelTime.makeSeconds(1)) ]}
         
       deleteRecordsOnSplit: boolean
         -- If property is true and a change to the history config causes a split in an existing history
         -- the original history records are deleted instead of causing a hisotry split.
         default{[ false ]}
         flags{ operator }
         
       deleteRecordsOnExecute: boolean
         -- If property is true any existing records are deleted from the history prior to
         -- appending new records.
         default{[ false ]}
         flags{ operator }
         
       historyDeviceName: BFormat
         -- BFormat property resolved against this component to specify the history device name portion of the 
         -- resulting history ID.
         default{[ BFormat.make("%componentSpace.rootComponent.stationName%") ]}
         flags{ operator }
		 
	   useComponentOrd: boolean
	     -- If property is true the TableToHistory component ord is used to set the source property of the history config.
		 -- If property is false the ord property of the TableToHistory is used to set the source property of the history config.
		 default{[ false ]}
		 flags{ operator }
         
     }
     actions
     {
       execute()
         flags{ async }
     }
     topics
     {
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonProTransform.BTableToHistory(2569994100)1.0$ @*/
/* Generated Mon Dec 12 09:37:07 EST 2016 by Slot-o-Matic (c) Tridium, Inc. 2012 */

////////////////////////////////////////////////////////////////
// Property "ord"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code ord} property.
   * the ord to be resolved to generate the BITable
   * @see #getOrd
   * @see #setOrd
   */
  public static final Property ord = newProperty(Flags.OPERATOR, BOrd.NULL, null);
  
  /**
   * Get the {@code ord} property.
   * the ord to be resolved to generate the BITable
   * @see #ord
   */
  public BOrd getOrd() { return (BOrd)get(ord); }
  
  /**
   * Set the {@code ord} property.
   * the ord to be resolved to generate the BITable
   * @see #ord
   */
  public void setOrd(BOrd v) { set(ord, v, null); }

////////////////////////////////////////////////////////////////
// Property "lastExecutionTime"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code lastExecutionTime} property.
   * time of last report execution
   * @see #getLastExecutionTime
   * @see #setLastExecutionTime
   */
  public static final Property lastExecutionTime = newProperty(Flags.READONLY, BAbsTime.NULL, null);
  
  /**
   * Get the {@code lastExecutionTime} property.
   * time of last report execution
   * @see #lastExecutionTime
   */
  public BAbsTime getLastExecutionTime() { return (BAbsTime)get(lastExecutionTime); }
  
  /**
   * Set the {@code lastExecutionTime} property.
   * time of last report execution
   * @see #lastExecutionTime
   */
  public void setLastExecutionTime(BAbsTime v) { set(lastExecutionTime, v, null); }

////////////////////////////////////////////////////////////////
// Property "faultCause"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code faultCause} property.
   * @see #getFaultCause
   * @see #setFaultCause
   */
  public static final Property faultCause = newProperty(Flags.READONLY|Flags.TRANSIENT, "", BFacets.make(BFacets.MULTI_LINE, BBoolean.TRUE, BFacets.FIELD_WIDTH, BInteger.make(120)));
  
  /**
   * Get the {@code faultCause} property.
   * @see #faultCause
   */
  public String getFaultCause() { return getString(faultCause); }
  
  /**
   * Set the {@code faultCause} property.
   * @see #faultCause
   */
  public void setFaultCause(String v) { setString(faultCause, v, null); }

////////////////////////////////////////////////////////////////
// Property "status"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code status} property.
   * @see #getStatus
   * @see #setStatus
   */
  public static final Property status = newProperty(Flags.READONLY|Flags.TRANSIENT, BStatus.ok, null);
  
  /**
   * Get the {@code status} property.
   * @see #status
   */
  public BStatus getStatus() { return (BStatus)get(status); }
  
  /**
   * Set the {@code status} property.
   * @see #status
   */
  public void setStatus(BStatus v) { set(status, v, null); }

////////////////////////////////////////////////////////////////
// Property "historyConfig"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code historyConfig} property.
   * @see #getHistoryConfig
   * @see #setHistoryConfig
   */
  public static final Property historyConfig = newProperty(0, new BHistoryConfig(), null);
  
  /**
   * Get the {@code historyConfig} property.
   * @see #historyConfig
   */
  public BHistoryConfig getHistoryConfig() { return (BHistoryConfig)get(historyConfig); }
  
  /**
   * Set the {@code historyConfig} property.
   * @see #historyConfig
   */
  public void setHistoryConfig(BHistoryConfig v) { set(historyConfig, v, null); }

////////////////////////////////////////////////////////////////
// Property "interval"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code interval} property.
   * @see #getInterval
   * @see #setInterval
   */
  public static final Property interval = newProperty(Flags.OPERATOR, BRelTime.makeMinutes(15), BFacets.make(BFacets.MIN, BRelTime.makeSeconds(1)));
  
  /**
   * Get the {@code interval} property.
   * @see #interval
   */
  public BRelTime getInterval() { return (BRelTime)get(interval); }
  
  /**
   * Set the {@code interval} property.
   * @see #interval
   */
  public void setInterval(BRelTime v) { set(interval, v, null); }

////////////////////////////////////////////////////////////////
// Property "deleteRecordsOnSplit"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code deleteRecordsOnSplit} property.
   * If property is true and a change to the history config causes a split in an existing history
   * the original history records are deleted instead of causing a hisotry split.
   * @see #getDeleteRecordsOnSplit
   * @see #setDeleteRecordsOnSplit
   */
  public static final Property deleteRecordsOnSplit = newProperty(Flags.OPERATOR, false, null);
  
  /**
   * Get the {@code deleteRecordsOnSplit} property.
   * If property is true and a change to the history config causes a split in an existing history
   * the original history records are deleted instead of causing a hisotry split.
   * @see #deleteRecordsOnSplit
   */
  public boolean getDeleteRecordsOnSplit() { return getBoolean(deleteRecordsOnSplit); }
  
  /**
   * Set the {@code deleteRecordsOnSplit} property.
   * If property is true and a change to the history config causes a split in an existing history
   * the original history records are deleted instead of causing a hisotry split.
   * @see #deleteRecordsOnSplit
   */
  public void setDeleteRecordsOnSplit(boolean v) { setBoolean(deleteRecordsOnSplit, v, null); }

////////////////////////////////////////////////////////////////
// Property "deleteRecordsOnExecute"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code deleteRecordsOnExecute} property.
   * If property is true any existing records are deleted from the history prior to
   * appending new records.
   * @see #getDeleteRecordsOnExecute
   * @see #setDeleteRecordsOnExecute
   */
  public static final Property deleteRecordsOnExecute = newProperty(Flags.OPERATOR, false, null);
  
  /**
   * Get the {@code deleteRecordsOnExecute} property.
   * If property is true any existing records are deleted from the history prior to
   * appending new records.
   * @see #deleteRecordsOnExecute
   */
  public boolean getDeleteRecordsOnExecute() { return getBoolean(deleteRecordsOnExecute); }
  
  /**
   * Set the {@code deleteRecordsOnExecute} property.
   * If property is true any existing records are deleted from the history prior to
   * appending new records.
   * @see #deleteRecordsOnExecute
   */
  public void setDeleteRecordsOnExecute(boolean v) { setBoolean(deleteRecordsOnExecute, v, null); }

////////////////////////////////////////////////////////////////
// Property "historyDeviceName"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code historyDeviceName} property.
   * BFormat property resolved against this component to specify the history device name portion of the
   * resulting history ID.
   * @see #getHistoryDeviceName
   * @see #setHistoryDeviceName
   */
  public static final Property historyDeviceName = newProperty(Flags.OPERATOR, BFormat.make("%componentSpace.rootComponent.stationName%"), null);
  
  /**
   * Get the {@code historyDeviceName} property.
   * BFormat property resolved against this component to specify the history device name portion of the
   * resulting history ID.
   * @see #historyDeviceName
   */
  public BFormat getHistoryDeviceName() { return (BFormat)get(historyDeviceName); }
  
  /**
   * Set the {@code historyDeviceName} property.
   * BFormat property resolved against this component to specify the history device name portion of the
   * resulting history ID.
   * @see #historyDeviceName
   */
  public void setHistoryDeviceName(BFormat v) { set(historyDeviceName, v, null); }

////////////////////////////////////////////////////////////////
// Property "useComponentOrd"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code useComponentOrd} property.
   * If property is true the TableToHistory component ord is used to set the source property of the history config.
   * If property is false the ord property of the TableToHistory is used to set the source property of the history config.
   * @see #getUseComponentOrd
   * @see #setUseComponentOrd
   */
  public static final Property useComponentOrd = newProperty(Flags.OPERATOR, false, null);
  
  /**
   * Get the {@code useComponentOrd} property.
   * If property is true the TableToHistory component ord is used to set the source property of the history config.
   * If property is false the ord property of the TableToHistory is used to set the source property of the history config.
   * @see #useComponentOrd
   */
  public boolean getUseComponentOrd() { return getBoolean(useComponentOrd); }
  
  /**
   * Set the {@code useComponentOrd} property.
   * If property is true the TableToHistory component ord is used to set the source property of the history config.
   * If property is false the ord property of the TableToHistory is used to set the source property of the history config.
   * @see #useComponentOrd
   */
  public void setUseComponentOrd(boolean v) { setBoolean(useComponentOrd, v, null); }

////////////////////////////////////////////////////////////////
// Action "execute"
////////////////////////////////////////////////////////////////
  
  /**
   * Slot for the {@code execute} action.
   * @see #execute()
   */
  public static final Action execute = newAction(Flags.ASYNC, null);
  
  /**
   * Invoke the {@code execute} action.
   * @see #execute
   */
  public void execute() { invoke(execute, null, null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  @Override
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BTableToHistory.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

  public void started() throws Exception
  {
    super.started();
    checkForService();
  }

  public void changed(Property property, Context context) 
  {
    super.changed(property, context);
    if(property.equals(interval)) getHistoryConfig().setInterval(BCollectionInterval.make(getInterval()));
  }
  
  
  public IFuture post(Action action, BValue argument, Context cx)
  {
    if(action == execute)
      return BVykonProService.getInstance().getWorker().post(new Invocation(this, action, argument, cx));
    else
      return super.post(action, argument, cx);
  }
  
  
  private final void checkForService()
  {
    if(BVykonProService.getInstance()==null)
    {
      updateFault("This component requires the VykonPro service in the station");
    }
    else if(BVykonProService.getInstance().isDisabled())
    {
      updateFault("The vykonPro service is disabled");
    }
    else
    {
      updateFault("");
    }
  }
  
  
  
  public void doExecute() throws Exception
  {
    if(!isRunning()) return;
    if(getStatus().isFault())
    {
      checkForService();
      if(getStatus().isFault()) return;
    }
    
    updateFault("");
    setLastExecutionTime(Clock.time());
    
    try
    {
      //resolve the ord to a table
      result = (BITable) getOrd().resolve(this).get();
      //if (result.size() > 0)
      if(result!=null)
      {
        //get the table columns
        cols = result.getColumns().list();
        colFacets = new BFacets[cols.length];
        
        //get the history database
        BHistoryDatabase localDb = ((BHistoryService) Sys.getService(BHistoryService.TYPE)).getDatabase();
        try(HistoryDatabaseConnection conn = localDb.getDbConnection(null))
        {
          BIHistory history = null;
          BTimeZone tzone = null;

          //String station = Sys.getStation().getStationName();
          String station = SlotPath.escape(SlotPath.unescape(getHistoryDeviceName().format(this)));

          if (localDb == null)
          {
            updateFault("Local history database not available.");
            return;
          }

          // verify the first column contains timestamps
          if(!cols[0].getType().is(BAbsTime.TYPE))
          {
            updateFault("The first column in the result set must be a timestamp");
            return;
          }
          else
          {
            tzone = (BTimeZone) cols[0].getFacets().get("TimeZone");
          }

          // start loop on column 1 because column 0 is the timestamp
          for (int j = 1; j < cols.length; j++)
          {
            // initialize the column indexes for each loop
			int statusCol = -1;
            int flagsCol = -1;
            int recordType = -1;
			
			// get the name of the column and the facets
            colFacets[j] = cols[j].getFacets();
            BObject sName = colFacets[j].get("SERIES_NAME");
            String name = cols[j].getDisplayName(null);
            if(sName != null) name = sName.toString(null);

            // setup the historyConfig
            BHistoryConfig config = getHistoryConfig();

            BOrdList source = null;
			if(getUseComponentOrd())source = BOrdList.make(getSourceOrd());
			else source = BOrdList.make(this.getOrd());
            config.setSource(source);

            if(tzone!=null) config.setTimeZone(tzone);

            BHistoryId id = BHistoryId.make(station, name);
            config.setId(id);

            if(config.get("valueFacets")==null) config.add("valueFacets", colFacets[j]);
            else config.set("valueFacets", colFacets[j]);

            // set the record type based on the column type
            if(cols[j].getType().is(BBoolean.TYPE))
            {
              config.setRecordType(BTypeSpec.make("history", "BooleanTrendRecord"));
              recordType=1;
            }
            else if(cols[j].getType().is(BNumber.TYPE))
            {
              config.setRecordType(BTypeSpec.make("history", "NumericTrendRecord"));
              recordType=2;
            }
            else if(cols[j].getType().is(BEnum.TYPE))
            {
              config.setRecordType(BTypeSpec.make("history", "EnumTrendRecord"));
              recordType=3;
            }
            else if(cols[j].getType().is(BString.TYPE))
            {
              config.setRecordType(BTypeSpec.make("history", "StringTrendRecord"));
              recordType=4;
            }
            else if(cols[j].getType().is(BStatus.TYPE)) statusCol = j;
            else if(cols[j].getType().is(BTrendFlags.TYPE)) flagsCol = j;

            config.setInterval(BCollectionInterval.make(getInterval()));

            // check if the history exists in the database
            if(!conn.exists(id))
            {
              conn.createHistory(config);
              history = conn.getHistory(id);
            }
            else
            {
              history = conn.getHistory(id);

              if(getDeleteRecordsOnExecute())
              {
                conn.clearAllRecords(id);
              }
              else
              {
                // check historyConfig to see if they match
                if(!history.getConfig().equivalent(config))
                {
                  if(getDeleteRecordsOnSplit())
                  {
                    conn.clearAllRecords(id);
                    conn.reconfigureHistory(config);
                  }
                  else conn.recreateHistory(config, true);
                }
              }
            }

			BAbsTime lastTimestamp = conn.getLastTimestamp(history);
			
            try(TableCursor c = result.cursor())
            {

          /*
           * TODO - should consider checking if the timestamp is after the last record in the history or not.
           * Currently if it is not, the append operation should fail throwing an error in the application
           * director.
           *
           * It might make sense to have a configuration property to allow a user to decide if they want to force
           * a history split when this condition exits. Might be useful for ad hoc generation where they generated
           * for lastWeek and now want to generate for lastMonth.
           */
              if(recordType==1)
              {
                // boolean records
                while(c.next())
                {
                  BAbsTime timestamp = (BAbsTime) c.cell(cols[0]);
				  if(lastTimestamp!=null && timestamp.isAfter(lastTimestamp))
				  {
					BBooleanTrendRecord rec = new BBooleanTrendRecord();
                    rec.setValue(((BBoolean)c.cell(cols[j])).getBoolean());
                    rec.setTimestamp(timestamp);
                    //if(flagsCol>-1) rec.setTrendFlags((BTrendFlags)c.cell(cols[flagsCol]));
                    //if(statusCol>-1) rec.setStatus((BStatus)c.cell(cols[statusCol]));
                    conn.append(history, rec);  
				  }
                }
              }
              else if(recordType==2)
              {
                // numeric records
                while(c.next())
                {
                  BAbsTime timestamp = (BAbsTime) c.cell(cols[0]);
                  if(lastTimestamp!=null && timestamp.isAfter(lastTimestamp))
				  {
				    BNumericTrendRecord rec = new BNumericTrendRecord();
                    //rec.setValue(c.getDouble(cols[j]));
                    rec.setValue(((BDouble)c.cell(cols[j])).getDouble());
                    rec.setTimestamp(timestamp);
                    //if(flagsCol>-1) rec.setTrendFlags((BTrendFlags)c.cell(cols[flagsCol]));
                    //if(statusCol>-1) rec.setStatus((BStatus)c.cell(cols[statusCol]));
                    conn.append(history, rec);
				  }	
                }
              }
              else if(recordType==3)
              {
                // enum records
                while(c.next())
                {
                  BAbsTime timestamp = (BAbsTime) c.cell(cols[0]);
                  if(lastTimestamp!=null && timestamp.isAfter(lastTimestamp))
				  {
				    BEnumTrendRecord rec = new BEnumTrendRecord();
                    //rec.setValue(BDynamicEnum.make(c.getInt(cols[j])));
                    rec.setValue(BDynamicEnum.make(((BInteger)c.cell(cols[j])).getInt()));
                    rec.setTimestamp(timestamp);
                    //if(flagsCol>-1) rec.setTrendFlags((BTrendFlags)c.cell(cols[flagsCol]));
                    //if(statusCol>-1) rec.setStatus((BStatus)c.cell(cols[statusCol]));
                    conn.append(history, rec);
				  }	
                }
              }
              else if(recordType==4)
              {
                // string records
                while(c.next())
                {
                  BAbsTime timestamp = (BAbsTime) c.cell(cols[0]);
				  if(lastTimestamp!=null && timestamp.isAfter(lastTimestamp))
				  {
                    BStringTrendRecord rec = new BStringTrendRecord();
                    rec.setValue(c.cell(cols[j]).toString(null));
                    rec.setTimestamp(timestamp);
                    //if(flagsCol>-1) rec.setTrendFlags((BTrendFlags)c.cell(cols[flagsCol]));
                    //if(statusCol>-1) rec.setStatus((BStatus)c.cell(cols[statusCol]));
                    conn.append(history, rec);
				  }	
                }
              }
            }
          } // end for j loop
        }
         // end for loop to iterate through columns
      } // end if there were rows in the result
      else
      {
        //didn't return any results from resolving the ord
        updateFault("Result set does not contain any records.");
      }
    }
    catch(Exception e)
    {
      updateFault("Failed to generate report.");
      System.out.println(this.getSlotPath() + " , failed to generate report");
      e.printStackTrace();
    }
  }
  
  private void updateFault(String faults)
  {
    if(faults.length()>0)
    {
      setFaultCause(faults);
      setStatus(BStatus.fault);
    }
    else
    {
      setFaultCause("");
      setStatus(BStatus.ok);
    }
  }
  
  
  /**
   * Get the ord to use as the source for the history.
   */
  public BOrd getSourceOrd()
  {
    BComponentSpace cs = getComponentSpace();
    if (cs == null) return null;
    BOrd base = cs.getOrdInSession();
    if (base == null) return null;
    return BOrd.make(base, getSlotPathOrd());
  }
  
///////////////////////////////////////////
// local variables
///////////////////////////////////////////

private BITable result = null;
private TableCursor c = null;
int colCount = -1;
Column[] cols = null;
BFacets[] colFacets = null;
int statusCol = -1;
int flagsCol = -1;
int recordType = -1; // 1 = boolean, 2 = numeric, 3 = enum, 4 = string
}



