package com.vykon.vykonProTransform.functions;

import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.baja.seriestransform.exceptions.TransformException;
import javax.baja.seriestransform.graph.BTransformFunction;
import javax.baja.sys.BComplex;
import javax.baja.sys.BDynamicEnum;
import javax.baja.sys.BValue;
import javax.baja.sys.Property;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.util.Lexicon;

public class BEnumFunction
    extends BTransformFunction
{
  /*-
   class BEnumFunction
   {
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonProTransform.functions.BEnumFunction(4032854422)1.0$ @*/
/* Generated Thu Dec 04 10:05:43 EST 2014 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////
  
  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BEnumFunction.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/


  public void applyFunction(Map series, String[] srcProps, Property destProp, BComplex resultRecord)   
      throws TransformException  
      {  
        BDynamicEnum result = null;
        
        // iterate through each argument property name. For each argument,   
        // get the series that contains the list of records that the property  
        // is associated with and the name of the property.  
        for( int i = 0; i < srcProps.length; i++)  
        {  
          String name = srcProps[i];  
          int count = 0;
          
          // Use the getSeriesRecord method to retrieve the list of records  
          // associated with this input argument. The static getSeriesName  
          // method parses the series name from the argument name.  
          List records = getSeriesRecords(series, getSeriesName(name));  
            
            
          // iterate over our list of records and count true values for the  
          // given field value  
          if( null == records)continue; 
          for( Iterator it = records.iterator(); it.hasNext();)  
          {  
            BComplex record = (BComplex)it.next();  
            Property field = record.getProperty(getFieldName(name));  
            BValue value = record.get(field);
            
            try
            {
              BDynamicEnum de = (BDynamicEnum)value;
              if(count==0) result = de;
              count = count+1;
            }
            catch(Exception e)
            {
              System.out.println("Failed to determine value for field " + field);
              e.printStackTrace();
            }
          }  
        }  
          
        // Use the setRecordValue method to handle setting facet information  
        // and creating a new dynamic property in the BComponent if necessary.  
        setRecordValue(resultRecord, destProp, result);  
          
      }

  public Type[] getArgumentTypes()
  {
    Type[] types = { BDynamicEnum.TYPE };
    return types;
  }

  public String getFunctionDesc()
  {
    return FUNCTION_DESC;
  }

  public String getFunctionName()
  {
    return FUNCTION_NAME;
  }

  public Type getReturnType()
  {
    return BDynamicEnum.TYPE;
  }
  
  private static final Lexicon lex = Lexicon.make(BEnumFunction.class);
  private static final String FUNCTION_NAME = lex.getText("functions.name.enum"); 
  private static final String FUNCTION_DESC = lex.getText("functions.desc.enum");


}
