package com.vykon.vykonProTransform.ui;

import javax.baja.naming.BOrd;
import javax.baja.seriestransform.graph.BSeriesSchema;
import javax.baja.sys.Action;
import javax.baja.sys.BBoolean;
import javax.baja.sys.BObject;
import javax.baja.sys.Context;
import javax.baja.sys.Sys;
import javax.baja.sys.Type;
import javax.baja.ui.BLabel;
import javax.baja.ui.enums.BHalign;
import javax.baja.ui.enums.BValign;
import javax.baja.ui.pane.BBorderPane;
import javax.baja.ui.pane.BConstrainedPane;
import javax.baja.ui.pane.BGridPane;
import javax.baja.ui.pane.BPane;
import javax.baja.util.BFormat;
import javax.baja.util.Lexicon;
import javax.baja.workbench.BWbEditor;
import javax.baja.workbench.CannotSaveException;
import javax.baja.workbench.fieldeditor.BWbFieldEditor;
import javax.baja.workbench.popup.BIPopupEditor;

import com.tridium.bql.util.BDynamicTimeRange;
import com.tridium.seriestransform.graph.ui.BConfigEditor;
import com.tridium.seriestransform.graph.ui.BFormatOrdFE;
import com.tridium.seriestransform.interval.BSeriesInterval;
import com.tridium.seriestransform.interval.ui.BSeriesIntervalFE;
import com.tridium.seriestransform.schema.ui.BNodeSchemaFE;
import com.tridium.seriestransform.source.ui.BHistoryDateRangeFE;
import com.vykon.vykonProTransform.source.BHistorySourceNodeDelta;

public class BHistoryDeltaPE
    extends BWbEditor
    implements BIPopupEditor
{
  /*-
   class BHistoryDeltaPE
   {
     actions
     {
       sourceChanged()
         -- Action called when the data source ORD is modified
     }
   }
   -*/
/*+ ------------ BEGIN BAJA AUTO GENERATED CODE ------------ +*/
/*@ $com.vykon.vykonProTransform.ui.BHistoryDeltaPE(615430918)1.0$ @*/
/* Generated Thu Dec 04 12:07:13 EST 2014 by Slot-o-Matic 2000 (c) Tridium, Inc. 2000 */

////////////////////////////////////////////////////////////////
// Action "sourceChanged"
////////////////////////////////////////////////////////////////

  /**
   * Slot for the <code>sourceChanged</code> action.
   * Action called when the data source ORD is modified
   * @see com.vykon.vykonProTransform.ui.BHistoryDeltaPE#sourceChanged()
   */
  public static final Action sourceChanged = newAction(0,null);

  /**
   * Invoke the <code>sourceChanged</code> action.
   * Action called when the data source ORD is modified
   * @see com.vykon.vykonProTransform.ui.BHistoryDeltaPE#sourceChanged
   */
  public void sourceChanged() { invoke(sourceChanged,null,null); }

////////////////////////////////////////////////////////////////
// Type
////////////////////////////////////////////////////////////////

  public Type getType() { return TYPE; }
  public static final Type TYPE = Sys.loadType(BHistoryDeltaPE.class);

/*+ ------------ END BAJA AUTO GENERATED CODE -------------- +*/

////////////////////////////////////////////////////////////////
//Popup
////////////////////////////////////////////////////////////////

  public BWbEditor getEditor()
  {
    return this;
  }

  // //////////////////////////////////////////////////////////////
  // Editor API
  // //////////////////////////////////////////////////////////////

  protected void doLoadValue(BObject value, Context context) throws Exception
  {
    src = (BHistorySourceNodeDelta) value;
    src.lease(3);
    BSeriesSchema srcSchema = src.getSrcSchema();
    schemaFE.loadValue(srcSchema, context);

    BFormat dataSource = src.getDataSource();
    dataSrcFE.loadValue(dataSource, context);

    BDynamicTimeRange dateRange = src.getDateRange();
    timeRangeEd.loadValue(dateRange, context);

    deltaFE = BWbFieldEditor.makeFor(BBoolean.DEFAULT);
    deltaFE.loadValue(BBoolean.make(src.getDeltaValues()));

    // set out modified flag if data source FE is changed
    linkTo(dataSrcFE, BFormatOrdFE.setModified, setModified);
    linkTo(dataSrcFE, BFormatOrdFE.setModified, sourceChanged);
    linkTo(intervalFE, BSeriesIntervalFE.setModified, setModified);
    linkTo(timeRangeEd, BHistoryDateRangeFE.setModified, setModified);
    linkTo(deltaFE, BWbFieldEditor.setModified, setModified);

    // get the quantization interval
    BSeriesInterval quantInterval = src.getQuantInterval();
    intervalFE.loadValue(quantInterval);

    // create a subtitle for the configuration section
    BPane configTitle = BConfigEditor.makeSubTitle(TITLE_CONFIG, null);
    BPane schemaTitle = BConfigEditor.makeSubTitle(TITLE_SCHEMA, null);

    // create a grid display
    BLabel dateRangeLbl = new BLabel(LBL_RANGE);
    dateRangeLbl.setValign(BValign.top);

    BLabel deltaLabel = new BLabel(LBL_DELTA);
    deltaLabel.setValign(BValign.top);

    BGridPane configPane = new BGridPane(2);
    configPane.add(null, new BLabel(LBL_SRC));
    configPane.add(null, dataSrcFE);
    configPane.add(null, new BLabel(LBL_INTERVAL));
    configPane.add(null, intervalFE);
    configPane.add(null, dateRangeLbl);
    configPane.add(null, timeRangeEd);
    configPane.add(null, deltaLabel);
    configPane.add(null, deltaFE);
    configPane.setRowGap(5);
    configPane.setColumnGap(10);

    BGridPane displayPane = new BGridPane(1);
    displayPane.add(null, configTitle);
    displayPane.add(null, configPane);
    displayPane.add(null, schemaTitle);
    displayPane.add(null, new BBorderPane(schemaFE, 10, 20, 0, 70));
    displayPane.setStretchColumn(0);
    displayPane.setColumnAlign(BHalign.fill);

    BConstrainedPane cp = new BConstrainedPane(displayPane);
    cp.setMaxWidth(350);
    setContent(cp);
  }

  /*
   * (non-Javadoc)
   *
   * @see javax.baja.workbench.BWbEditor#doSaveValue(javax.baja.sys.BObject, javax.baja.sys.Context)
   */
  protected BObject doSaveValue(BObject value, Context cx) throws CannotSaveException, Exception
  {
    src.lease(3);
    BSeriesSchema newSrcSchema = (BSeriesSchema) schemaFE.saveValue(cx);
    BSeriesInterval quantInterval = src.getQuantInterval();
    BFormat format = (BFormat) dataSrcFE.saveValue();
    intervalFE.saveValue(quantInterval, cx);
    BDynamicTimeRange range = (BDynamicTimeRange) timeRangeEd.saveValue();

    // check if our quantization interval has actually changed
    BSeriesInterval oldInterval = src.getQuantInterval();
    if (!oldInterval.equivalent(quantInterval))
      src.setQuantInterval((BSeriesInterval) quantInterval.newCopy(true));

    // check if our schema has actually changed
    BSeriesSchema oldSrcSchema = src.getSchema();
    if (!oldSrcSchema.equivalent(newSrcSchema))
      src.setSrcSchema((BSeriesSchema) newSrcSchema.newCopy(true));

    BFormat oldSrcFormat = src.getDataSource();
    if (!oldSrcFormat.equals(format))
      src.setDataSource(format);

    src.setDateRange(range);

    BBoolean delta = (BBoolean) deltaFE.saveValue();
    src.setDeltaValues(delta.getBoolean());

    return src;
  }

  /*
   * (non-Javadoc)
   *
   * @see javax.baja.workbench.BWbEditor#doSetReadonly(boolean)
   */
  protected void doSetReadonly(boolean readonly)
  {
    dataSrcFE.setEnabled(!readonly);
    schemaFE.setEnabled(!readonly);
    intervalFE.setEnabled(!readonly);
    timeRangeEd.setEnabled(!readonly);
    deltaFE.setEnabled(!readonly);
  }

  // //////////////////////////////////////////////////////////////
  // Actions
  // //////////////////////////////////////////////////////////////

  /**
   * This action attempts to get the source ORD and resolve the ORD if possible in order to retrieve
   * the schema of the source.
   *
   */
  public void doSourceChanged()
  {
    try
    {
      BFormat format = (BFormat) dataSrcFE.saveValue();
      String ordStr = format.getFormat();
      // if our ordStr isn't relativized, we can attempt to load schema
      try
      {
        BOrd dataOrd = BOrd.make(ordStr);
        schemaFE.loadFromSource(dataOrd);
      }
      catch (Exception e)
      {
        schemaFE.loadFromSource(BOrd.NULL);
      }
    }
    catch (CannotSaveException e)
    {
      /* do nothing, ORD may not be properly formed */
    }
    catch (Exception e)
    {
      e.printStackTrace();
    }
  }

////////////////////////////////////////////////////////////////
//Attributes
////////////////////////////////////////////////////////////////

private static final Lexicon lex = Lexicon.make(BHistoryDeltaPE.class);
private static final String LBL_SRC = lex.getText("sourceIPE.datasource");
private static final String LBL_INTERVAL = lex.getText("sourceIPE.intervalFE");
private static final String LBL_RANGE = lex.getText("sourceIPE.range");
private static final String LBL_DELTA = lex.getText("sourceIPE.delta");

private static final String TITLE_CONFIG = lex.getText("sourceIPE.title.config");
private static final String TITLE_SCHEMA = lex.getText("sourceIPE.title.schema");

private BHistorySourceNodeDelta src;
private BSeriesIntervalFE intervalFE = new BSeriesIntervalFE();
private BFormatOrdFE dataSrcFE = new BFormatOrdFE();
private BNodeSchemaFE schemaFE = new BNodeSchemaFE();
private BHistoryDateRangeFE timeRangeEd = new BHistoryDateRangeFE();
private BWbFieldEditor deltaFE;

}